/* coding: utf-8 */
/* Copyright (C) 2021 SofTek Systems, Inc. */

$(function(){

    function execute_filter(filters){
        reset_pages_checked_values();
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    };

    //prevent dropdown-menu from closing by click
    $('.filter-dropdown-menu *').on('click', function(e){
        e.stopPropagation();
    });

    //期間指定検索
    $('.filter-date-preset').on('click', function() {
        $('#filters_search_date_begin').val($(this).data('begindate'));
        $('#filters_search_date_end').val($(this).data('enddate'));
        $('#filters_search_date_in_rev').prop('checked', $(this).data('inrev') ? true : false);
        return false;
    });


    $('#filter-date-form').on('submit', function() {
        var pages_filters = $('#pages_filters');
        var filters = JSON.parse(pages_filters.val());
        var begindate = $('#filters_search_date_begin').val();
        var enddate = $('#filters_search_date_end').val();
        var inrev = $('#filters_search_date_in_rev').prop('checked');
        var v = (inrev ? 'rev' : 'in') + ':' + begindate + ':' + enddate;
        filters['date'] = String(v);
        execute_filter(filters);
        return false;
    });

    $('#reset-filter-date').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['date'] = '::';
        execute_filter(filters);
        return false;
    }); 

    //SRI検索
    $('#exec-filter-statuses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var sris = [];
        $('#filter-statuses-menu [data-sri]:checked').each(function(){
            sris.push($(this).val());
        });
        filters['sris'] = sris;
        filters['warning'] = 'all';
        execute_filter(filters);
        return false;
    }); 

    $('#reset-filter-statuses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['sris'] = [];
        execute_filter(filters);
        return false;
    });

    //CVSS検索
    $('#exec-filter-cvsses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var cvsses = [];
        $('#filter-cvsses-menu [data-cvss]:checked').each(function(){
            cvsses.push($(this).val());
        });
        filters['cvsses'] = cvsses;
        filters['warning'] = 'all';
        execute_filter(filters);
        return false;
    });

    $('#reset-filter-cvsses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['cvsses'] = [];
        execute_filter(filters);
        return false;
    });

    //履歴検索
    $('.filter-journal-preset').on('click', function(){
       $('#filters_search_journal_begin').val($(this).attr('data-begindate'));
       $('#filters_search_journal_end').val($(this).attr('data-enddate'));
       $('#filters_search_journal_in_rev').prop('checked', $(this).data('inrev') ? true : false);
       return false;
   });

   $('#filter-journal-form').on('submit', function(){
       var begindate = $('#filters_search_journal_begin').val();
       var enddate = $('#filters_search_journal_end').val();
       if( begindate == '' && enddate == '' ){
           alert('期間を指定して下さい');
           return false;
       }
       var filters = JSON.parse($('#pages_filters').val());
       var inrev = $('#filters_search_journal_in_rev').prop('checked');
       var v = (inrev ? 'rev' : 'in') + ':' + begindate + ':' + enddate;
       filters['journal']['period'] = String(v);
       filters['journal']['filter_status_change'] = $('#filter-journal-filter-status-change').prop('checked');
       filters['journal']['filter_duedate_change'] = $('#filter-journal-filter-duedate-change').prop('checked');
       execute_filter(filters);
       return false;
   });

   $('#reset-filter-journal').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       filters['journal']['period'] = '::';
       filters['journal']['filter_status_change'] = false;
       filters['journal']['filter_duedate_change'] = false;
       execute_filter(filters);
       return false;
   });

   //カテゴリ検索(複数)
   $('#filter-categories-is-and-check-box').on('change', function(){
        if( $(this).prop('checked') ){
            $('#filter-categories-is-except-check-box').prop('checked', false);
        }
    });

    $('#filter-categories-is-except-check-box').on('change', function(){
        if( $(this).prop('checked') ){
            $('#filter-categories-is-and-check-box').prop('checked', false);
        }
    });

    if( $('#filter-categories-menu #filter-categories-is-notreg-check-box').length === 1 ){
        $('#filter-categories-is-notreg-check-box').on('change', function(){
            if( $(this).prop('checked') ){
                $('#filter-categories-is-and-check-box, #filter-categories-is-except-check-box').prop('checked', false);
                $('#filter-summary-category-tab-content input[type="checkbox"]').prop('disabled', true);
            }else{
                $('#filter-summary-category-tab-content input[type="checkbox"]').prop('disabled', false);
            }
        });

        $('#filter-categories-is-and-check-box, #filter-categories-is-except-check-box').on('change', function(){
           if( $(this).prop('checked') ){
                $('#filter-categories-is-notreg-check-box').prop('checked', false);
                $('#filter-summary-category-tab-content input[type="checkbox"]').prop('disabled', false);
            }
        });
    }

    $('#exec-filter-categories').on('click', function(){
        var cat_ids = [];
        $('#filter-categories-menu .category-select:checked').each(function(){
            cat_ids.push($(this).val());
        });
        if( cat_ids.length === 0){
            if( $('#filter-categories-menu #filter-categories-is-notreg-check-box:checked').length === 0 ){
                alert('カテゴリを1つ以上選択して下さい');
                return false;
            }
        }
        var filters = JSON.parse($('#pages_filters').val());
        const is_notreg_check_box = $('#filter-categories-menu #filter-categories-is-notreg-check-box');
        if( is_notreg_check_box.length === 1 ){
            filters['categories']['is_notreg'] = is_notreg_check_box.prop('checked');
        }
        if( filters['categories']['is_notreg'] === true ){
            filters['categories']['ids'] = [];
            filters['categories']['is_and'] = false;
            filters['categories']['is_except'] = false;
        }else{
            filters['categories']['ids'] = cat_ids;
            filters['categories']['is_and'] = $('#filter-categories-is-and-check-box').prop('checked');
            filters['categories']['is_except'] = $('#filter-categories-is-except-check-box').prop('checked');
        }
        execute_filter(filters);
    });

    (function(){
        var target_tab_content = ($.cookie('summary_category_tag') === 'custom_category' ? '#filter-summary-category-select-custom-category-tab-content' : '#filter-summary-category-select-system-category-tab-content');
        $('#filter-categories-menu li [data-target="' + target_tab_content + '"]').addClass('active');
        $(target_tab_content).show();

        $('#filter-categories-menu .nav-link').on('click', function(e){
            var tab_item = $(this);
            if( !tab_item.hasClass('active') ){
                var target_content_id = tab_item.data('target');
                $('#filter-categories-menu .nav-link, #filter-categories-menu .nav-item').removeClass('active');
                tab_item.addClass('active');
                tab_item.closest('.nav-item').addClass('active');
                $('#filter-summary-category-tab-content [data-tabcontent="true"]').hide();
                $(target_content_id).show();
                $.cookie('summary_category_tag', (target_content_id.indexOf('system-category') === -1 ? 'custom_category' : 'system_category'), { path:'/' });
            }
            e.stopPropagation();
        });
    })();

    //カテゴリ検索リセット
    $('#reset-filter-categories').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['categories']['ids'] = [];
        filters['categories']['is_and'] = false;
        filters['categories']['is_except'] = false;
        if( $('#filter-categories-menu #filter-categories-is-notreg-check-box:checked').length === 1 ){
            filters['categories']['is_notreg'] = false;
        }
        execute_filter(filters);
    });

});


//上記の検索を関数に移行予定。管理しやすく(使いやすく)バグが発生しにくくするため。

function execute_filter(filters){
    reset_pages_checked_values();
    $('#pages_filters').val(JSON.stringify(filters));
    $('#pages_offset').val('0');
    $('#pages_form').submit();
    return false;
};

//有効期間/対策予定日検索
function enable_filter_date2(item){
    $('#exec-filter-date2').on('click', function(){
        let filters = JSON.parse($('#pages_filters').val());
        let begin_date = $('#filter-date2-begin-date-field').val();
        let end_date = $('#filter-date2-end-date-field').val();
        const notset = $('#filter-date2-notset').prop('checked');
        if( notset ){
            begin_date = '';
            end_date = ''; 
        }
        filters[item] = String((notset ? 'notset' : '') + ':' + begin_date + ':' + end_date);
        execute_filter(filters);
        return false;
    });

    $('#filter-date2-preset [data-preset="true"]').on('click', function(){
        $('#filter-date2-begin-date-field').val($(this).attr('data-begindate'));
        $('#filter-date2-end-date-field').val($(this).attr('data-enddate'));
        $('#filter-date2-notset').prop('checked', ('notset' === $(this).attr('data-notset')));
    });

    $('#filter-date2-notset').on('change', function(){
        if( $(this).prop('checked') ) {
            $('#filter-date2-begin-date-field, #filter-date2-end-date-field').val('');
        }
    });

    $('#reset-filter-date2').on('click', function(){
        let filters = JSON.parse($('#pages_filters').val());
        filters[item] = '::';
        execute_filter(filters);
        return false;
    });
}

//テキスト検索
function enable_filter_text(item_name, input_id, filter_button_id, reset_button_id, notreg_checkbox_elm_id = ''){
    $('#' + filter_button_id).on('click', function(){
       let filter = JSON.parse($('#pages_filters').val());
       let text = $('#' + input_id).val();
       if( notreg_checkbox_elm_id.length > 0 ){
           filter[item_name]['is_target_notreg'] = $('#' + notreg_checkbox_elm_id).prop('checked');
           if( filter[item_name]['is_target_notreg'] ){
               filter[item_name]['text'] = '';
           }else{
               filter[item_name]['text'] = text;
           }
       }else{
           filter[item_name] = text
       }
       execute_filter(filter);
       return false;
   });

   $('#' + reset_button_id).on('click', function(){
       let filter = JSON.parse($('#pages_filters').val());
       if( notreg_checkbox_elm_id.length > 0 ){
           filter[item_name]['text'] = '';
           filter[item_name]['is_target_notreg'] = false;
       }else{
           filter[item_name] = ''
       }
       execute_filter(filter);
       return false;
   });
}

//「SRI重大度/CVSSスコア 別ホスト数分布」「対応の状況別ホスト数分布」のフィルタ
function enable_filter_by_score_status(){
    $('.filter-change-exclusion').on('click', function() {
        const link = $(this);
        const name = link.attr('data-name');
        let value = link.data('value');
        if( typeof( value ) === 'number' ){
            value = String(value);
        }
        let filters = JSON.parse($('#pages_filters').val());
        const keys = Object.keys(filters);
        keys.forEach( key => {
            let val = null;
            if( key === name ){
                val = value; 
            }else if( key === 'warning' ){
                val = 'all';
            }else if( key === 'status' ){
                val = '0';
            }else if( key === 'sris' || key === 'cvsses' ){
                val = [];
            }else if( key === 'due_date' || key === 'date' ){
                val = '::';
            }else if( key === 'cvss_vector' || key === 'product' ){
                val = {};
            }else if( key === 'journal' ){
                val = { 
                    'period': '::',
                    'filter_status_change': false,
                    'filter_duedate_change': false
                };
            }else if( key === 'categories' ){
                val = {
                    'ids': [],
                    'is_and': false,
                    'is_except': false
                };
            }else{
                val = '';
            }
            filters[[key]] = val;
        });
        if( name === 'sris' || name == 'cvsses' ){
            filters['status'] = '1:2';
        }
        execute_filter(filters);
        return false;
    });
}

