/* coding: utf-8 * /
/* Copyright (C) 2021 SofTek Systems, Inc. */

$(function(){
    init_sidfm();
    enable_dropdown_balloon();

    $('.cancel-import').on('click', function(){
        $('#form-to-index-page').submit();
    });

    function import_apply_with_progress_bar(){
        var import_apply_path = $('#import-apply-path').val();
        var actions = JSON.parse($('#actions').val());
        var progress_window = get_progress_bar();
        $('body').append(progress_window);
        var executed_actions = 0;
        var total_actions = actions.length;
        var err_messages = new Set();
        var err_cnt = 0;
        var cnt = 0;
        var is_delete_action_executed = false;
  
        var send_data_of_import = function(){
            var is_delete_action = false; 
            action = actions[cnt];
            action_data = {'action_data': JSON.stringify(action)};
            if( action['action'] === 'delete' && !is_delete_action_executed ){
                //カテゴリ削除の1つ目のカテゴリで、ルール関連の処理を実行
                is_delete_action = true;
                action_data['rule_info'] = $('#delete-categories-related-rules').val();
            }
            $.ajax({
                type: 'POST',
                url: import_apply_path,
                data: action_data,
            }).done(function(result){
                err_message = result['err_message'];
                if( err_message.length > 0 ){
                    err_messages.add(err_message);
                    err_cnt += 1;
                }
                executed_actions += 1;
                if( is_delete_action && !is_delete_action_executed ){
                    is_delete_action_executed = true;
                }
                var percentage = (executed_actions / total_actions) * 100;
                if( percentage >= 99 && percentage < 100 ){
                    percentage = 99;
                }else{
                    percentage = Math.round(percentage);
                }
                $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                if( percentage == 100 ){
                    setTimeout(function(){//progress barのbarが満たされるまで待つ
                        if(err_messages.size > 0){
                            err_messages = Array.from(err_messages);
                            alert(err_messages.join('\n') + (err_cnt == total_actions ? '' : '\n※他のデータの登録は完了しています。') + '\nカテゴリ設定画面に移動します。');
                            $('#form-to-index-page').submit();
                        }else{
                            $('#form-to-index-page').submit();
                        }
                    },800);
                }else{
                    cnt += 1;
                    send_data_of_import();
                }
            });
        };

        send_data_of_import();
    };
    
    $('.execute-submit-import-apply').on('click', function(){
        $('#delete-categories-related-rules').val('{}');
        var actions = JSON.parse($('#actions').val());
        var del_cat_ids = [];
        actions.forEach(function(ac){
            if( ac.action === 'delete' ){
                del_cat_ids.push(ac.cat_id);
            }
        });
        if( del_cat_ids.length > 0 ){
            $('body').append(
                $('<div>').attr({'id': 'checking-delete-categories-realted-data-window', 'class': 'progress-window'}).append(
                    $('<div>').attr('class', 'progress-wait-area').append(
                        $('<div>').attr({'class': 'progress-wait-area-label'}).text('お待ちください...'),
                    )
                )
            );

            var is_related_hosts = false;
            var is_related_users = false;
            var is_related_rules = false;

            var check_rules = $.ajax({
                url: $('#sidfm_internal_api_check_related_rules_path').val(),
                type: 'POST',
                data: {'page_name': 'category_import', 'category_ids': JSON.stringify(del_cat_ids)},
            }).done(function(data){
                var rule_messages = data['rule_messages'];
                var rule_names = Object.keys(rule_messages);
                if(rule_names.length > 0){
                    is_related_rules = true;
                    $('#related-rule-info-area').show();
                    delete data['rule_messages'];
                    $('#delete-categories-related-rules').val(JSON.stringify(data));
                    $('#RuleInfoArea > *').remove();
                    rule_names.sort();
                    for(var i = 0; i < rule_names.length; i++){
                        var rule_name = rule_names[i];
                        var rule_message = rule_messages[rule_name];
                        var item_name = rule_message['item_name'];
                        var content = rule_message['content'];
                        var reason = rule_message['reason'];
                        var tr = $('<tr>').attr('class', 'list_alternative');
                        var rule_name_td = $('<td>').attr('class', 'rule-name').text(rule_name);
                        var item_td = $('<td>').attr('class', 'rule-item').text(item_name);
                        var message_td = $('<td>').attr('class', 'rule-changes').text(content);
                        var reason_td = $('<td>').attr('class', 'rule-reason').text(reason);
                        tr.append(rule_name_td, item_td, message_td, reason_td);
                        $('#RuleInfoArea').append(tr);
                    }
                }else{
                    $('#related-rule-info-area').hide();
                }
            });
            
            var check_hosts = $.ajax({
                url: $('#check_categories_related_hosts_path').val(),
                type: 'POST',
                data: { 'category_ids': JSON.stringify(del_cat_ids) }
            }).done(function(hosts){
                if( hosts.length > 0 ){
                    is_related_hosts = true;
                    $('#related-host-info-area-tbody > *').remove();
                    $('#related-host-info-area').show();
                    var host_elms = hosts.map(function(host){
                        return $('<tr>').attr('class', 'list_alternative').append(
                            $('<td>').append(
                                 $('<div>').attr({
                                     'data-toggle': 'tooltip',
                                     'data-title': ('ホスト名: ' + host.hostname + '<br/>表示名: ' + (host.ext_name ? host.ext_name : '(未設定)')),
                                     'data-html': 'true',
                                     'data-boundary': 'window',
                                     'data-placement': 'left',
                                 }).text(host.ext_name ? host.ext_name : host.hostname)
                            )
                        );
                    });
                    $('#related-host-info-area-tbody').append(host_elms);
                    $('#related-host-info-area-tbody').find('[data-toggle="tooltip"]').tooltip();
                }else{
                    $('#related-host-info-area').hide();
                } 
            });

            var check_users = $.ajax({
                url: $('#check_categories_related_users_path').val(),
                type: 'POST',
                data: { 'category_ids': JSON.stringify(del_cat_ids)} 
            }).done(function(users){
                if( users.length > 0 ){
                    is_related_users = true;
                    $('#related-user-info-area').show();
                    $('#related-user-info-area-tbody > *').remove();
                    var user_elms = users.map(function(user){
                        return $('<tr>').attr('class', 'list_alternative').append(
                                   $('<td>').append(
                                       $('<div>').text(user.login)
                                   ),
                                   $('<td>').append(
                                       $('<div>').text(user.lastname + ' ' + user.firstname)
                                   )
                               );
                    });
                    $('#related-user-info-area-tbody').append(user_elms);
                }else{
                    $('#related-user-info-area').hide();
                }
            });


            $.when(check_rules, check_hosts, check_users).done(function(){
                $('#checking-delete-categories-realted-data-window').remove();
                if( is_related_rules || is_related_users || is_related_hosts){
                    $('#related-host-info-content, #related-user-info-content, #related-rule-info-content').hide();
                    $('#related-host-info-btn-icon, #related-user-info-btn-icon, #related-rule-info-btn-icon').removeClass('fa-angle-up')
                                                                                                              .addClass('fa-angle-down')
                    var title_items = [];
                    if( is_related_hosts ){
                        title_items.push('ホスト');
                    }
                    if( is_related_users ){
                        title_items.push('ユーザ');
                    }
                    if( is_related_rules ){
                        title_items.push('ルール');
                    }
                    $('#modalConfRelatedRules-title').text('削除対象のカテゴリに関連する' + title_items.join('/') + 'の情報');
                    $('#modalConfRelatedRules').modal('show');
                }else{
                    import_apply_with_progress_bar();   
                }
            });             
        }else{
            import_apply_with_progress_bar();
        }
    });

    $('#submit-related-rules-item-form').on('click', function(){
        import_apply_with_progress_bar();
    });
  
    function toggle_category_related_info_content(target_content_id, target_icon_id){
        var target_content = $('#' + target_content_id);
        var target_icon = $('#' + target_icon_id);
        if( target_content.is(':visible') ){
             target_content.hide();
             target_icon.removeClass('fa-angle-up').addClass('fa-angle-down');
        }else{
            target_content.show();
            target_icon.removeClass('fa-angle-down').addClass('fa-angle-up');
        }
    }

    $('#toggle-related-host-info-content-btn').on('click', function(){
        toggle_category_related_info_content('related-host-info-content', 'related-host-info-btn-icon');
    });

    $('#toggle-related-user-info-content-btn').on('click', function(){
        toggle_category_related_info_content('related-user-info-content', 'related-user-info-btn-icon');
    });

    $('#toggle-related-rule-info-content-btn').on('click', function(){
        toggle_category_related_info_content('related-rule-info-content', 'related-rule-info-btn-icon');
    });
});
