// ヒートマップ描画
function vul_heatmap(opt, page_name = '') {
    switch (opt.idx) {
    case 'sri':    vul_heatmap_sri(opt, page_name); break;
    case 'cvss':   vul_heatmap_cvss(opt, page_name); break;
    }
}

// ヒートマップ(SRI)
function vul_heatmap_sri(opt, page_name = '') {
    var path = $('#sidfm_internal_api_get_vul_view_heat_map_data_path').val();
    $.ajax({
        type: 'POST',
        url: path,
        data: { 
            'index': 'sri', 
            'host_id': (page_name === 'host' ? $('#host_id').val() : ''),
            'category_id': $('#category_id').val()
        } 
    }).done(function(heat_map_data){
        if( heat_map_data.length > 0 ){
            heatmap('#graph-heatmap', graph_width('#graph-heatmap'), 200, heat_map_data, function(row) {
                var grid_color = $('#color_success').val();
                switch(row.riskid) {
                    case 0: grid_color = $('#color_sri_none').val(); break;
                    case 1: grid_color = $('#color_sri_low').val(); break;
                    case 2: grid_color = $('#color_sri_medium').val(); break;
                    case 3: grid_color = $('#color_sri_high').val(); break;
                    case 4: grid_color = $('#color_sri_critical').val(); break;
                    case 5: grid_color = $('#color_sri_fixed').val(); break;
                    default: grid_color = $('#color_sri_none').val(); break;
                }
                var tooltip = row.title + '<br />' + row.riskname;
                var link = url_vulnerability_detail(row.htmlid);
                return { color: grid_color, tooltip: tooltip, link: link };
            });
        }
        $('#wrap-loading-heatmap-window').remove();
    });
}

// ヒートマップ(CVSS)
function vul_heatmap_cvss(opt, page_name = '') {
    var path = $('#sidfm_internal_api_get_vul_view_heat_map_data_path').val();
    $.ajax({
        type: 'POST',
        url: path,
        data: { 
            'index': 'cvss',
            'host_id': (page_name === 'host' ? $('#host_id').val() : ''),
            'category_id': $('#category_id').val()
       }
    }).done(function(heat_map_data){
        if( heat_map_data.length > 0 ){
            heatmap('#graph-heatmap', graph_width('#graph-heatmap'), 200, heat_map_data, function(row) {
                var grid_color = $('#color_cvss_notreg').val();
                var riskid = row.riskid;
                grid_color = $('#color_cvss_' + riskid).val();
                var tooltip = row.title + '<br />' + row.riskname;
                var link = url_vulnerability_detail(row.htmlid);
                return { color: grid_color, tooltip: tooltip, link: link };
            });
        }
        $('#wrap-loading-heatmap-window').remove();
    });
}

function host_heatmap(opt, page_name = '') {
    switch (opt.idx) {
    case 'sri':    host_heatmap_sri(opt, page_name); break;
    case 'cvss':   host_heatmap_cvss(opt, page_name); break;
    }
}

// ヒートマップ(SRI)
function host_heatmap_sri(opt, page_name = '') {
    var path = $('#sidfm_internal_api_get_host_view_heat_map_data_path').val();
    $.ajax({
      type: 'POST',
      url: path,
      data: {  
        'index': 'sri', 
        'html_id': (page_name === 'vulnerability' ? $('#html_id').val() : ''),
        'category_id': $('#category_id').val()
      }
    }).done(function(heat_map_data){
        if( heat_map_data.length > 0 ){
            heatmap('#graph-heatmap', graph_width('#graph-heatmap'), 200, heat_map_data, function(row) {
                var grid_color = $('#color_success').val();
                switch(row.riskid) {
                    case 0: grid_color = $('#color_sri_none').val(); break;
                    case 1: grid_color = $('#color_sri_low').val(); break;
                    case 2: grid_color = $('#color_sri_medium').val(); break;
                    case 3: grid_color = $('#color_sri_high').val(); break;
                    case 4: grid_color = $('#color_sri_critical').val(); break;
                    default: grid_color = $('#color_sri_fixed').val(); break;
                }
                var tooltip = row.displayname + '<br />' + row.riskname;
                var link = url_host_detail(row.hostid);
                return { color: grid_color, tooltip: tooltip, link: link };
            });
        }
        $('#wrap-loading-heatmap-window').remove();
    });
  
 /*   heatmap('#graph-heatmap', graph_width('#graph-heatmap'), 200, $('#data-graph-heatmap input'), function(row) {
	var r = $(row);
	var grid_color = $('#color_success').val();
	switch(r.data('riskid')) {
	case 0: grid_color = $('#color_sri_none').val(); break;
	case 1: grid_color = $('#color_sri_low').val(); break;
	case 2: grid_color = $('#color_sri_medium').val(); break;
	case 3: grid_color = $('#color_sri_high').val(); break;
	case 4: grid_color = $('#color_sri_critical').val(); break;
	default: grid_color = $('#color_sri_fixed').val(); break;
	}
  var tooltip = r.data('displayname') + '<br />' + r.data('riskname');
	//var tooltip = r.data('hostname') + '<br />' + r.data('riskname');
	var link = url_host_detail(r.data('hostid'));
	return { color: grid_color, tooltip: tooltip, link: link };
    });*/
}

// ヒートマップ(CVSS)
function host_heatmap_cvss(opt, page_name = '') {
    var path = $('#sidfm_internal_api_get_host_view_heat_map_data_path').val();
    $.ajax({
      type: 'POST',
      url: path,
      data: { 
        'index': 'cvss',
        'html_id': (page_name === 'vulnerability' ? $('#html_id').val() : ''),
        'category_id': $('#category_id').val()
      }
    }).done(function(heat_map_data){
        if( heat_map_data.length > 0 ){
            heatmap('#graph-heatmap', graph_width('#graph-heatmap'), 200, heat_map_data, function(row) {
                var grid_color = $('#color_success').val();
                var riskid = row.riskid;
                if (riskid) {
                    grid_color = $('#color_cvss_' + riskid).val();
                }
                var tooltip = row.displayname + '<br />' + row.riskname;
                var link = url_host_detail(row.hostid);
                return { color: grid_color, tooltip: tooltip, link: link };
            });
        }
        $('#wrap-loading-heatmap-window').remove();
    });
    /*heatmap('#graph-heatmap', graph_width('#graph-heatmap'), 200, $('#data-graph-heatmap input'), function(row) {
	var r = $(row);
	var grid_color = $('#color_success').val();
	var riskid = r.data('riskid');
	if (riskid) {
	    grid_color = $('#color_cvss_' + riskid).val();
	}
  var tooltip = r.data('displayname') + '<br />' + r.data('riskname');
	//var tooltip = r.data('hostname') + '<br />' + r.data('riskname');
	var link = url_host_detail(r.data('hostid'));
	return { color: grid_color, tooltip: tooltip, link: link };
    });*/
}

// 危険度のグラフ
function risk_graph(opt) {
    switch (opt.grp) {
    case 'count': risk_graph_proportion(opt); break;
    case 'distribution': risk_graph_timeline(opt); break;
    }
}

// 危険度のグラフ(割合)
function risk_graph_proportion(opt) {
    switch (opt.idx) {
    case 'sri': risk_graph_proportion_sri(opt); break;
    case 'cvss': risk_graph_proportion_cvss(opt); break;
    }
}

// 危険度のグラフ(割合) - SRI
function risk_graph_proportion_sri(opt) {
    var distribution_risk = JSON.parse($('#distribution_risk').val());
    var risks = [ 'none', 'low', 'medium', 'high', 'critical', 'fixed' ];
    var risk_names = [ '無', '低', '中', '高', '重大', '済' ];
    var sum = 0;
    for (var i = 0; i < risks.length; i++) {
	sum += distribution_risk[risks[i]];
    }
    if (sum > 0) {
	var data = [{
	    values: risks.map(function(value, index, context) {
		return distribution_risk[value];
	    }),
	    labels: risks.map(function(value, index, context) {
		// 後述の細工のためのリンク
		return '<a href="#' + index + '" target="_self"><span>' + risk_names[index] + '</span></a>';
	    }),
	    marker: {
		colors: risks.map(function(value, index, context) {
		    return $('#color_sri_' + value).val();
		}),
	    },
	    type: 'pie',
	    sort: false,
	    textinfo: 'label+percent',
	    textposition: 'inside',
	    hoverlabel: { font: { color: '#fff' } },
	    textfont: { color: '#000' }
	}];
	var layout = {
	    height: 200,
	    width: graph_width('#graph-risk'),
	    margin: { l:40, r:10, b:10, t:18, pad:4 },
	    paper_bgcolor: 'rgba(0,0,0,0)',
	    showlegend: false
	};
	var config = {
	    displaylogo: false,
	    displayModeBar: false
	};
	Plotly.newPlot('graph-risk', data, layout, config);
	// plotlyのラベルの制限が厳しすぎるため、JavaScriptの処理を
	// ラベルのクリックに埋め込むため、細工を行う。
	$('#graph-risk a').each(function(i, e) {
	    var t = $(e);
	    var href = t.attr('xlink:href');
	    if (href && href.startsWith('#')) {
		t.on('click', function(event) {
		    var target = $(this);
		    var index = parseInt($(this).attr('xlink:href').slice(1));
		    var filters = JSON.parse($('#pages_filters').val());
		    if (index >= 0 && index <= 4) {
			filters['status'] = '1:2';
			filters['sri'] = String(index);
		    } else {
			delete filters['sri'];
			filters['status'] = '3:4';
		    }
		    filters['warning'] = 'all';
		    $('#pages_filters').val(JSON.stringify(filters));
		    $('#pages_form').submit();
		    return false;
		});
	    }
	});
    }
}

// 危険度のグラフ(割合) - CVSS
function risk_graph_proportion_cvss(opt) {
    var distribution_risk = JSON.parse($('#distribution_risk').val());
    var risks = [ 'd1', 'd2', 'd3', 'd4', 'notreg', 'fixed' ];
    var risk_names = [ '3.9〜0.0', '6.9〜4.0', '8.9〜7.0', '10.0〜9.0', '未登録', '済' ];
    var sum = 0;
    for (var i = 0; i < risks.length; i++) {
	sum += distribution_risk[risks[i]];
    }
    if (sum > 0) {
	var data = [{
	    values: risks.map(function(value, index, context) {
		return distribution_risk[value];
	    }),
	    labels: risks.map(function(value, index, context) {
		return '<a href="#' + risks[index]  + '" target="_self"><span>' + risk_names[index] + '</span></a>';
	    }),
	    marker: {
		colors: risks.map(function(value, index, context) {
		    return $('#color_cvss_' + value).val();
		})
	    },
	    type: 'pie',
	    sort: false,
	    textinfo: 'label+percent',
	    textposition: 'inside',
	    hoverlabel: { font: { color: '#fff' } },
	    textfont: { color: '#000' }
	}];
	var layout = {
	    height: 200,
	    width: graph_width('#graph-risk'),
	    margin: { l:40, r:10, b:10, t:20, pad:4 },
	    paper_bgcolor: 'rgba(0,0,0,0)',
	    showlegend: false
	};
	var config = {
	    displaylogo: false,
	    displayModeBar: false
	};
	Plotly.newPlot('graph-risk', data, layout, config);
	// plotlyのラベルの制限が厳しすぎるため、JavaScriptの処理を
	// ラベルのクリックに埋め込むため、細工を行う。
	$('#graph-risk a').each(function(i, e) {
	    var t = $(e);
	    var href = t.attr('xlink:href');
	    if (href && href.startsWith('#')) {
		t.on('click', function(event) {
		    var target = $(this);
		    var index = $(this).attr('xlink:href').slice(1);
		    var filters = JSON.parse($('#pages_filters').val());
		    if (index != 'fixed') {
			filters['status'] = '1:2';
			filters['cvss'] = String(index);
		    } else {
			delete filters['cvss'];
			filters['status'] = '3:4';
		    }
		    filters['warning'] = 'all';
		    $('#pages_filters').val(JSON.stringify(filters));
		    $('#pages_form').submit();
		    return false;
		});
	    }
	});
    }
}


// 危険度のグラフ(時系列)
function risk_graph_timeline(opt) {
    switch (opt.idx) {
    case 'sri': risk_graph_timeline_sri(opt); break;
    case 'cvss': risk_graph_timeline_cvss(opt); break;
    }
}

// 危険度のグラフ(時系列) - SRI
function risk_graph_timeline_sri(opt) {
    var timeline_data = JSON.parse($('#timeline_data').val());
    var x = timeline_data['timescale'].map(x => x['name'])

    var trace_none = {
	name: timeline_data['risk_names'][0],
	x: x,
	y: timeline_data['risk_counts'][0],
	fill: 'tonexty',
	line: { color: $('#color_sri_' + timeline_data['risk_syms'][0]).val() },
	type: 'scatter'
    };
    var trace_low = calc_stacked(trace_none, {
	name: timeline_data['risk_names'][1],
	x: x,
	y: timeline_data['risk_counts'][1],
	fill: 'tonexty',
	line: { color: $('#color_sri_' + timeline_data['risk_syms'][1]).val() },
	type: 'scatter'
    });
    var trace_medium = calc_stacked(trace_low, {
	name: timeline_data['risk_names'][2],
	x: x,
	y: timeline_data['risk_counts'][2],
	fill: 'tonexty',
	line: { color: $('#color_sri_' + timeline_data['risk_syms'][2]).val() },
	type: 'scatter'
    });
    var trace_high = calc_stacked(trace_medium, {
	name: timeline_data['risk_names'][3],
	x: x,
	y: timeline_data['risk_counts'][3],
	fill: 'tonexty',
	line: { color: $('#color_sri_' + timeline_data['risk_syms'][3]).val() },
	type: 'scatter'
    });
    var trace_critical = calc_stacked(trace_high, {
	name: timeline_data['risk_names'][4],
	x: x,
	y: timeline_data['risk_counts'][4],
	fill: 'tonexty',
	line: { color: $('#color_sri_' + timeline_data['risk_syms'][4]).val() },
	type: 'scatter'
    });
    var trace_fixed = calc_stacked(trace_critical, {
	name: timeline_data['risk_names'][5],
	x: x,
	y: timeline_data['risk_counts'][5],
	fill: 'tonexty',
	line: { color: $('#color_sri_' + timeline_data['risk_syms'][5]).val() },
	type: 'scatter'
    });
    var data = [ trace_fixed, trace_critical, trace_high, trace_medium, trace_low, trace_none ];
    var layout = {
	height: 210,
	width: graph_width('#graph-risk'),
	margin: { l:35, r:20, b:30, t:10, pad:0 },
	xaxis: { tickangle: 'auto', tickfont: { size: 10, family: 'Arial Narrow' }, ticklen: 4 },
  yaxis: { rangemode: 'nonnegative' },
	showlegend: false
    };
    var config = {
	displaylogo: false,
	displayModeBar: false
    };
    Plotly.newPlot('graph-risk', data.reverse(), layout, config);
}

// 危険度のグラフ(時系列) - CVSS
function risk_graph_timeline_cvss(opt) {
    var timeline_data = JSON.parse($('#timeline_data').val());

    var x = timeline_data['timescale'].map(x => x['name']);
    var label = timeline_data['risk_labels'][4];
    var trace_d1 = {
	name: timeline_data['risk_names'][label],
	x: x,
	y: timeline_data['risk_counts'][label],
	fill: 'tozeroy',
	line: { color: $('#color_cvss_' + label).val() },
	type: 'scatter'
    };
    label = timeline_data['risk_labels'][3];
    var trace_d2 = calc_stacked(trace_d1, {
	name: timeline_data['risk_names'][label],
	x: x,
	y: timeline_data['risk_counts'][label],
	fill: 'tonexty',
	line: { color: $('#color_cvss_' + label).val() },
	type: 'scatter'
    });
    label = timeline_data['risk_labels'][2];
    var trace_d3 = calc_stacked(trace_d2, {
	name: timeline_data['risk_names'][label],
	x: x,
	y: timeline_data['risk_counts'][label],
	fill: 'tonexty',
	line: { color: $('#color_cvss_' + label).val() },
	type: 'scatter'
    });
    label = timeline_data['risk_labels'][1];
    var trace_d4 = calc_stacked(trace_d3, {
	name: timeline_data['risk_names'][label],
	x: x,
	y: timeline_data['risk_counts'][label],
	fill: 'tonexty',
	line: { color: $('#color_cvss_' + label).val() },
	type: 'scatter'
    });
    label = timeline_data['risk_labels'][0];
    var trace_notreg = calc_stacked(trace_d4, {
	name: timeline_data['risk_names'][label],
	x: x,
	y: timeline_data['risk_counts'][label],
	fill: 'tonexty',
	line: { color: $('#color_cvss_' + label).val() },
	type: 'scatter'
    });
    label = timeline_data['risk_labels'][5];
    var trace_fixed = calc_stacked(trace_notreg, {
	name: timeline_data['risk_names'][label],
	x: x,
	y: timeline_data['risk_counts'][label],
	fill: 'tonexty',
	line: { color: $('#color_cvss_' + label).val() },
	type: 'scatter'
    });
    var data = [ trace_fixed, trace_notreg, trace_d4, trace_d3, trace_d2, trace_d1 ];
    var layout = {
	height: 210,
	width: graph_width('#graph-risk'),
	margin: { l:35, r:20, b:30, t:10, pad:0 },
  xaxis: { tickangle: 'auto', tickfont: { size: 10, family: 'Arial Narrow' }, ticklen: 4 },
	yaxis: { rangemode: 'nonnegative' },
	showlegend: false
    };
    var config = {
	displaylogo: false,
	displayModeBar: false
    };
    Plotly.newPlot('graph-risk', data.reverse(), layout, config);
}

// 対応状況のグラフ描画
function status_graph(opt) {
    switch (opt.grp) {
    case 'count': status_graph_proportion(opt); break;
    case 'distribution': status_graph_distribution(opt); break;
    }
}

// 対応状況のグラフ(割合)
function status_graph_proportion(opt) {
    var distribution_status = JSON.parse($('#distribution_status').val());
    var statuses = JSON.parse($('#statuses2').val());
    var sum = 0;
    for (var i = 0; i < statuses.length; i++) {
	sum += distribution_status[statuses[i]['label']];
    }
    if (sum > 0) {
	var data = [{
	    values: statuses.map(function(value, index, context) {
		return distribution_status[value['label']];
	    }),
	    labels: statuses.map(function(value, index, context) {
		return '<a href="#' + value['id'] + '" target="_self"><span>' + value['name'] + '</span></a>';
	    }),
	    marker: {
		colors: statuses.map(function(value, index, context) {
		    return $('#color_status_' + value['label']).val();
		}),
	    },
	    type: 'pie',
	    sort: false,
	    textinfo: 'label+percent',
	    textposition: 'inside',
	    hoverlabel: { font: { color: '#fff' } },
	    textfont: { color: '#000' }
	}];
	var layout = {
	    height: 200,
	    width: graph_width('#graph-status'),
	    margin: { l:40, r:10, b:10, t:18, pad:4 },
	    paper_bgcolor: 'rgba(0,0,0,0)',
	    showlegend: false
	};
	var config = {
	    displaylogo: false,
	    displayModeBar: false
	};
	Plotly.newPlot('graph-status', data, layout, config);
	$('#graph-status a').each(function(i, e) {
	    var t = $(e);
	    var href = t.attr('xlink:href');
	    if (href && href.startsWith('#')) {
		t.on('click', function(event) {
		    var target = $(this);
		    var index = parseInt($(this).attr('xlink:href').slice(1));
		    var filters = JSON.parse($('#pages_filters').val());
		    filters['status'] = String(index);
		    $('#pages_filters').val(JSON.stringify(filters));
		    $('#pages_form').submit();
		    return false;
		});
	    }
	});
    }
}

// 対応状況のグラフ(時系列)
function status_graph_distribution(opt) {
    var timeline_data = JSON.parse($('#timeline_data').val());
    var x = timeline_data['timescale'].map(x => x['name']);
    var trace_notaffect = {
	name: timeline_data['status_names'][4],
	x: x,
	y: timeline_data['status_counts'][4],
	fill: 'tozeroy',
	line: { color: $('#color_status_notaffect').val() },
	type: 'scatter'
    };
    var trace_fixed = calc_stacked(trace_notaffect, {
	name: timeline_data['status_names'][3],
	x: x,
	y: timeline_data['status_counts'][3],
	fill: 'tonexty',
	line: { color: $('#color_status_fixed').val() },
	type: 'scatter'
    });
    var trace_ongoing = calc_stacked(trace_fixed, {
	name: timeline_data['status_names'][2],
	x: x,
	y: timeline_data['status_counts'][2],
	fill: 'tonexty',
	line: { color: $('#color_status_ongoing').val() },
	type: 'scatter'
    });
    var trace_notconfirmed = calc_stacked(trace_ongoing, {
	name: timeline_data['status_names'][1],
	x: x,
	y: timeline_data['status_counts'][1],
	fill: 'tonexty',
	line: { color: $('#color_status_notconfirmed').val() },
	type: 'scatter'
    });
    var data = [ trace_notaffect, trace_fixed, trace_ongoing, trace_notconfirmed ];
    var layout = {
	height: 210,
	width: graph_width('#graph-status'),
	margin: { l:35, r:20, b:30, t:10, pad:0 },
  xaxis: { tickangle: 'auto', tickfont: { size: 10, family: 'Arial Narrow' }, ticklen: 4 },
	yaxis: { rangemode: 'nonnegative' },
	showlegend: false
    };
    var config = {
	displaylogo: false,
	displayModeBar: false
    };
    Plotly.newPlot('graph-status', data, layout, config);
}
