/* coding: utf-8 */
/* Copyright (C) 2018 SofTek Systems, Inc. */

// ホスト詳細画面


$(function() {

    init_paginator();
    enable_dropdown_balloon();
    enable_display_cve_ids();
    set_style_for_ActionArea_on_filter_dropdown_event();
    $('[data-toggle="dropdown"]').dropdown();
    enable_affitems_dropdown('outer-host-table');
    $('#pages_form').on('submit', function(){ set_summary_table_lines('host', $('#pages_per_page').val()) });

    //サマリー表内のdropdown-itemでaタグがクリック時にリンクしないのを防ぐための処理
    $('.dropdown-item-link-to-page').on('click', function(e){
        e.stopPropagation();
    });

    // 左袖メニューのactivate
    (function() {
	var t_filters = $('#pages_filters');
	if (t_filters.length) {
	    var filters = JSON.parse(t_filters.val());
	    if (filters['warning'] == 'warning') {
		activate_sidebar_item('sidebar-item-warninghosts');
	    } else {
		activate_sidebar_item('sidebar-item-hosts');
	    }
	} else {
	    activate_sidebar_item('sidebar-item-hosts');
	}
    })();

  //タイトルに表示名とホスト名をtooltipで表示する
  var attr_for_title = JSON.parse($('#attr-for-title').val());
  for(attr_name in attr_for_title){ 
      $('#sidfm_header_title').attr(attr_name, attr_for_title[attr_name]);
  } 
  $('#sidfm_header_title').tooltip();      

  $(window).on('load', function() {
      if($('#history_id').val()){
          var html_id = $('#history_id').val();
          var elm = $('.vulSelect[value=' + html_id  + ']')
                     .closest('.chk-box')
                     .siblings('.record')
                     .find('.action-open-history');
          build_JournalArea(elm);
      }
      setTimeout(function(){
          set_scroll();
          $(window).on('resize scroll', set_scroll);
      },200);
  });
  sticky_control('SummaryTable', 'host');

  function create_gragh_loading_elm(gragh_name){
      return $('<div>').attr('id', 'wrap-loading-' + gragh_name + '-window').append(
          $('<div>').attr({'id': 'loading-' + gragh_name + '-window'}).append(
              $('<div>').attr({
                  'id': 'loading-' + gragh_name + '-mark',
                  'class': 'spinner-border text-secondary',
                  'role': 'status',
              }).append(
                  $('<span>').attr('class', 'sr-only').text('Loading...')
              )
          )
      );
  }
    // グラフの描画とリサイズ(navbar-btnのクリックイベントも含む)
    (function() {
        var timer = false;
        var action = function() {
            if (timer !== false) {
                clearTimeout(timer);
            }
            timer = setTimeout(function() {
                var opt = {
                    grp: $('#pages_grp').val(),
                    idx: $('#pages_idx').val(),
                    risks: JSON.parse($('#risks').val()),
                    statuses: JSON.parse($('#statuses').val())
                };
                vul_heatmap(opt, 'host');
                if( $('#timeline_data').length == 1 ){
                    risk_graph(opt);
                    status_graph(opt);
                }
            }, 200);
        };
        $(window).on('load', function(){
            $('#wrap-graph-heatmap').append(create_gragh_loading_elm('heatmap'));
            setTimeout(function() {
                var opt = {
                    grp: $('#pages_grp').val(),
                    idx: $('#pages_idx').val(),
                    risks: JSON.parse($('#risks').val()),
                    statuses: JSON.parse($('#statuses').val())

                };
                vul_heatmap(opt, 'host');
            });
            if ( $('#pages_grp').val() === 'distribution' ){
                $('#wrap-graph-risk').append(create_gragh_loading_elm('risk'));
                $('#wrap-graph-status').append(create_gragh_loading_elm('status'));
                $.ajax({
                    type: 'POST',
                    url: $('#get_timeline_data_path').val(),
                    data: { 'host_ids': JSON.stringify([ $('#host_id').val() ]), 'idx': $('#pages_idx').val() }
                }).done(function(data){
                    if( data['err']) {
                        alert('エラーが発生しました。時系列を表示できません。');
                        return false;
                    }
                    $('body').append(
                        $('<input>').attr({
                        'type': 'hidden',
                            'value': JSON.stringify(data['timeline_data']),
                            'id': 'timeline_data'
                        })
                    );
                    var opt = {
                        grp: $('#pages_grp').val(),
                        idx: $('#pages_idx').val(),
                        risks: JSON.parse($('#risks').val()),
                        statuses: JSON.parse($('#statuses').val())
                    };
                    risk_graph(opt);
                    status_graph(opt);
                    $('#wrap-loading-risk-window, #wrap-loading-status-window').remove();
                });
            }else{
                var opt = {
                    grp: $('#pages_grp').val(),
                    idx: $('#pages_idx').val(),
                    risks: JSON.parse($('#risks').val()),
                    statuses: JSON.parse($('#statuses').val())
                };
                $('body').append(
                    $('<input>').attr({
                        'type': 'hidden',
                        'value': JSON.stringify([]),
                        'id': 'timeline_data'
                   })
                );
                risk_graph(opt);
                status_graph(opt);
            }
        });
        $(window).on('resize', action);
        $('.navbar-btn').on('click', action);
        $('#hostSTAT').on('shown.bs.collapse', action);
    })();

    // 開閉ボタン
    (function() {
	var c_hoststat = $.cookie('c_hoststat');
	var c_hostinfo = $.cookie('c_hostinfo');
	if (c_hoststat) {
	    if ('show' === c_hoststat) {
		$('#hostSTAT').collapse('show');
	    }
	} else {
	    $.cookie('c_hoststat', 'hide');
	}
	if (c_hostinfo) {
	    if ('hide' === c_hostinfo) {
		$('#hostInformations').collapse('hide');
	    }
	} else {
	    $.cookie('c_hostinfo', 'show');
	}
    })();
    $('#hostSTAT').on('show.bs.collapse', function() {
	$.cookie('c_hoststat', 'show');
	return true;
    });
    $('#hostSTAT').on('hide.bs.collapse', function() {
	$.cookie('c_hoststat', 'hide');
	return true;
    });
    $('#hostInformations').on('show.bs.collapse', function() { 
	$.cookie('c_hostinfo', 'show');
	return true;
    });
    $('#hostInformations').on('hide.bs.collapse', function() {
	$.cookie('c_hostinfo', 'hide');
	return true;
    });

    // ソート
    $('.sort-warning').on('click', sort_toggle('warning'));
    $('.sort-status').on('click', sort_toggle('status'));
    $('.sort-sri').on('click', sort_toggle('sri'));
    $('.sort-cvss').on('click', sort_toggle('cvss'));
    $('.sort-area').on('click', sort_toggle('area'));
    $('.sort-exploitable').on('click', sort_toggle('exploitable'));
    $('.sort-elapseddays').on('click', sort_toggle('elapseddays'));
    $('.sort-title').on('click', sort_toggle('title'));
    $('.sort-journals').on('click', sort_toggle('journals'));
    $('.sort-duedate').on('click', sort_toggle('duedate'));

    // グラフ、評価指標初期化
    (function() {
	$('.gtpbtns-change').removeClass('active');
	$('.grpbtns-change > input').prop('checked', false);
	var grp = $('#pages_grp').val();
	if (grp) {
	    $('#grpbtns-' + grp).addClass('active');
	    $('#grpbtns-' + grp + ' > input').prop('checked', true);
	}
	$('.idxbtns-change').removeClass('active');
	$('.idxbtns-change > input').prop('checked', false);
	var idx = $('#pages_idx').val();
	if (idx) {
	    $('#idxbtns-' + idx).addClass('active');
	    $('#idxbtns-' + idx + ' > input').prop('checked', true);
	}
    })();
							  
    // グラフ変更
    $('.grpbtns-change').on('click', function() {
	var button = $(this);
	var target = button.data('target');
	$('#pages_grp').val(target);
	var form = $('#pages_form');
	form.attr('action', remove_anchor(form.attr('action')));
	form.submit();
	return true;
    });

    // 評価指標変更
    $('.idxbtns-change').on('click', function() {
	var button = $(this);
	var target = button.data('target');
	$('#pages_idx').val(target);
	$('#pages_offset').val('0');
	var form = $('#pages_form');
	form.attr('action', remove_anchor(form.attr('action')));
	form.submit();
	return true;
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages').on('click', function(e) {
	var button = $(this);
	var target = $(button.data('target'));
	var dump = {
	    'pages[offset]': $('#pages_offset').val(),
	    'pages[per_page]': $('#pages_per_page').val(),
	    'pages[order]' : $('#pages_order').val(),
	    'pages[filters]': JSON.parse($('#pages_filters').val()),
	    'pages[grp]': $('#pages_grp').val(),
	    'pages[idx]': $('#pages_idx').val(),
	    'pages[checked]': [],
	    'pages[all_checked]': false
	};
	target.val(JSON.stringify(dump));
	return true;
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages-confirm').on('confirm:complete', function(e, answer) {
	if (answer) {
	    var button = $(this);
	    var target = $(button.data('target'));
	    var dump = {
		'pages[offset]': $('#pages_offset').val(),
		'pages[per_page]': $('#pages_per_page').val(),
		'pages[order]' : $('#pages_order').val(),
		'pages[filters]': JSON.parse($('#pages_filters').val()),
		'pages[grp]': $('#pages_grp').val(),
		'pages[idx]': $('#pages_idx').val(),
		'pages[checked]': [],
		'pages[all_checked]': false
	    };
	    target.val(JSON.stringify(dump));
	}
	return true;
    });

    $('.filter-change').on('click', function() {
  reset_pages_checked_values();
	var link = $(this);
	var name = link.data('name');
	var value = link.data('value');
	var filters = JSON.parse($('#pages_filters').val());
	// 強制的に文字列として設定。dataメソッドが、属性値をJSON.parse
	// してから返すため、数値の文字列を数値として解釈しまうため。
	filters[name] = String(value);
	if (name == 'sri' || name == 'cvss' || name == 'risk' || name == 'area') {
	    filters['warning'] = 'all';
	}
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

/*    $('.filter-change-exclusion').on('click', function() {
	var link = $(this);
	var name = link.data('name');
	var value = link.data('value');
	var filters = JSON.parse($('#pages_filters').val());
	filters['warning'] = String('all');
	filters['status'] = String('0');
	filters['sri'] = String('');
	filters['cvss'] = String('');
	filters['risk'] = String('');
	filters['area'] = String('');
	filters['exploitable'] = String('');
	filters['journal'] = String('');
	filters['due_date'] = String('::');
	filters['keyword'] = String('');
	filters['date'] = String('::');
  filters['cvss_vector'] = {};
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_checked').val(JSON.stringify([]));
	$('#pages_all_checked').val('');
	$('#pages_offset').val('0');
	// 強制的に文字列として設定。dataメソッドが、属性値をJSON.parse
	// してから返すため、数値の文字列を数値として解釈しまうため。
	filters[name] = String(value);
	if (name == 'sri' || name == 'cvss') {
	    filters['status'] = String('1:2');
        }
	if (name == 'sri' || name == 'cvss' || name == 'risk' || name == 'area') {
	    filters['warning'] = 'all';
	}
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });
*/
    enable_filter_by_score_status();

    $('.filter-duedate-preset').on('click', function(e) {
	var button = $(this);
	var begindate = button.data('begindate');
	var enddate = button.data('enddate');
	var notset = button.data('notset');
	$('#filters_search_duedate_begin').val(begindate);
	$('#filters_search_duedate_end').val(enddate);
	$('#filters_search_duedate_notset').prop('checked', ('notset' === notset));
	return false;
    });

    $('.filter-duedate').on('click', function(e) {
  reset_pages_checked_values();
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	var begindate = $('#filters_search_duedate_begin').val();
	var enddate = $('#filters_search_duedate_end').val();
	var notset = $('#filters_search_duedate_notset').prop('checked');
	filters['due_date'] = String((notset ? 'notset' : '') + ':' + begindate + ':' + enddate);
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-duedate-reset').on('click', function(e) {
  reset_pages_checked_values();
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	filters['due_date'] = '::';
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-duedate-notset').on('click', function(e) {
	if ($(this).prop('checked')) {
	    $('#filters_search_duedate_begin').val('');
	    $('#filters_search_duedate_end').val('');
	}
	return true;
    });

    $('.filter-keyword').on('click', function() {
  reset_pages_checked_values();
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	var kwd = $('#filters_search_keyword').val();
	filters['keyword'] = String(kwd);
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-keyword-clear').on('click', function() {
  reset_pages_checked_values();
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	filters['keyword'] = String('');
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-clear').on('click', function() {
	var filters = JSON.parse($('#pages_filters').val());
	filters['warning'] = String('all');
	filters['status'] = String('0');
	filters['sris'] = [];
	filters['cvsses'] = [];
	filters['risk'] = String('');
	filters['area'] = String('');
	filters['exploitable'] = String('');
	filters['due_date'] = String('::');
	filters['keyword'] = String('');
	filters['date'] = String('::');
  filters['cvss_vector'] = {};
  filters['journal'] = { 'period': '::', 'filter_status_change': false, 'filter_duedate_change': false };
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_checked').val(JSON.stringify([]));
	$('#pages_all_checked').val('');
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

  //CVSS指標検索
  function toggle_execute_filter_cvss_vector_button(){
       var cvss_v2_param = JSON.parse($('#cvss-v2-vectors-for-filter').val());
       var cvss_v3_param = JSON.parse($('#cvss-v3-vectors-for-filter').val());
       var is_unregist_checkbox_checked = $('#filter-unregistered-cvss-vector-checkbox').prop('checked');
       var is_selected_value = false;
       if( is_unregist_checkbox_checked ){
           is_selected_value = true;
       }
       if( !is_selected_value ){
           $.each(cvss_v2_param, function(vector, value){
               if( is_selected_value ){
                   return false;
               }
               if( value ){
                   is_selected_value = true;
               }
           });
           $.each(cvss_v3_param, function(vector, value){
               if( is_selected_value ){
                   return false;
               }
               if( value ){
                   is_selected_value = true;
               }
           });

       }
       if( is_selected_value ){
           $('#execute-filter-cvss-vector').prop('disabled', false);
       }else{
           $('#execute-filter-cvss-vector').prop('disabled', true);
       }
   }

   function toggle_filter_cvss_areas(checkbox){
       if( checkbox.prop('checked') ){
           $('#cvss-v2-vectors-area').append(
               $('<div>').attr('class', 'disabled-cvss-area')
           );
           $('#cvss-v3-vectors-area').append(
               $('<div>').attr('class', 'disabled-cvss-area')
           );
       }else{
           $('#cvss-v2-vectors-area .disabled-cvss-area').remove();
           $('#cvss-v3-vectors-area .disabled-cvss-area').remove();
       }
   }

   $('#filter-cve-vector-btn').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       if( Object.keys(filters['cvss_vector']).length > 0 ) {
           var filtered_cvss_v2 = filters['cvss_vector']['cvss_v2'];
           var filtered_cvss_v3 = filters['cvss_vector']['cvss_v3'];
           $('#cvss-v2-vectors-for-filter').val(JSON.stringify(filtered_cvss_v2));
           $('#cvss-v3-vectors-for-filter').val(JSON.stringify(filtered_cvss_v3));
           var cvss_v2_area = $('#cvss-v2-vectors-area');
           var cvss_v3_area = $('#cvss-v3-vectors-area');
           cvss_v2_area.find('[data-cvss]').removeClass('selected-cvss');
           $.each(filtered_cvss_v2, function(vector, value){
               if( value ){
                   cvss_v2_area.find('[data-cvss="' + vector + '"][data-value="' + value + '"]').addClass('selected-cvss');
               }
           });
           cvss_v3_area.find('[data-cvss]').removeClass('selected-cvss');
           $.each(filtered_cvss_v3, function(vector, value){
               if( value ){
                   cvss_v3_area.find('[data-cvss="' + vector + '"][data-value="' + value + '"]').addClass('selected-cvss');
               }
           });
           var checkbox = $('#filter-unregistered-cvss-vector-checkbox');
           if( filters['cvss_vector']['is_target_unregistered'] ){
               checkbox.prop('checked', true);
           }else{
               checkbox.prop('checked', false);
           }
           toggle_filter_cvss_areas(checkbox);
       }else{
           $('#filter-unregistered-cvss-vector-checkbox').prop('checked', false);
           var default_cvss_v2_val = {};
           var cvss_v2_vector_items = JSON.parse($('#cvss-v2-vectors').val());
           $.each(cvss_v2_vector_items, function(vector, items) {
               default_cvss_v2_val[vector] = null;
           });
           $('#cvss-v2-vectors-for-filter').val(JSON.stringify(default_cvss_v2_val));
           $('#cvss-v2-vectors-area').find('[data-cvss]').removeClass('selected-cvss');

           var default_cvss_v3_val = {};
           var cvss_v3_vector_items = JSON.parse($('#cvss-v3-vectors').val());
           $.each(cvss_v3_vector_items, function(vector, items) {
               default_cvss_v3_val[vector] = null;
           });
           $('#cvss-v3-vectors-for-filter').val(JSON.stringify(default_cvss_v3_val));
           $('#cvss-v3-vectors-area').find('[data-cvss]').removeClass('selected-cvss');
       }
       toggle_execute_filter_cvss_vector_button();
       $('#FilterCvssVectorModal').modal('show');
   });

   function set_filter_cvss_item(clicked_elm, cvss_area_name){
       if( cvss_area_name === 'cvss_v2' ){
           var target_param_elm = $('#cvss-v2-vectors-for-filter');
           var target_area = $('#cvss-v2-vectors-area');
       }else{
           var target_param_elm = $('#cvss-v3-vectors-for-filter');
           var target_area = $('#cvss-v3-vectors-area');
       }
       var param = JSON.parse(target_param_elm.val());
       var vector_name = clicked_elm.attr('data-cvss');
       var is_selected = clicked_elm.hasClass('selected-cvss');
       target_area.find('[data-cvss="' + vector_name + '"]').removeClass('selected-cvss');
       if( is_selected ){
           param[vector_name] = null;
       }else{
           clicked_elm.addClass('selected-cvss');
           param[vector_name] = clicked_elm.attr('data-value');
       }
       target_param_elm.val(JSON.stringify(param));
       toggle_execute_filter_cvss_vector_button();
   }

   $('#cvss-v2-vectors-area [data-cvss]').on('click', function(){
       set_filter_cvss_item($(this), 'cvss_v2');
   });

   $('#cvss-v3-vectors-area [data-cvss]').on('click', function(){
       set_filter_cvss_item($(this), 'cvss_v3');
   });

   $('#filter-unregistered-cvss-vector-checkbox').on('change', function(){
       toggle_filter_cvss_areas($(this));
       toggle_execute_filter_cvss_vector_button();
   });

   $('#execute-filter-cvss-vector').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       var is_target_unregistered = $('#filter-unregistered-cvss-vector-checkbox').prop('checked');
       filters['cvss_vector']['is_target_unregistered'] = is_target_unregistered;
       var selected_cvss_v2 = JSON.parse($('#cvss-v2-vectors-for-filter').val());
       var selected_cvss_v3 = JSON.parse($('#cvss-v3-vectors-for-filter').val());
       if( is_target_unregistered ){
           $.each(selected_cvss_v2, function(vector, value){
               selected_cvss_v2[vector] = null;
           });
           $.each(selected_cvss_v3, function(vector, value){
               selected_cvss_v3[vector] = null;
           });
       }
       filters['cvss_vector']['cvss_v2'] = selected_cvss_v2;
       filters['cvss_vector']['cvss_v3'] = selected_cvss_v3;

       reset_pages_checked_values();
       $('#pages_filters').val(JSON.stringify(filters));
       $('#pages_form').submit();
   });

   $('#reset-filter-cvss-vector').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       filters['cvss_vector'] = {}
       reset_pages_checked_values();
       $('#pages_filters').val(JSON.stringify(filters));
       $('#pages_form').submit();
   });


  /*$('#exec-download').on('click', function() {
      $('#download_idx').val($('#pages_idx').val());
      $('#download_order').val($('#pages_order').val());
      $('#download_filters').val($('#pages_filters').val());
      $('#download_htmlids').val($('#pages_checked').val());
      $('#form-download').submit();
      return true;
  });*/

  /*$('#modalPlaybook').on('show.bs.modal',function(){
      $('#wrap-ActionArea').css('z-index', '10');
      $('#floating-scroll').css('z-index', '10');
  });*/

  //エージェントを使用していなければツールチップでPlaybook出力できないことを表示
  if($('#open-modalPlaybook').hasClass('inactive')){
      $('#open-modalPlaybook').attr({
                   'data-toggle': 'tooltip',
                   'data-title': 'エージェントを使用していないため、Playbook の出力はできません'
                   }).tooltip();
      $('#open-modalPlaybook').on('click', function(){
          $(this).tooltip('hide');
      });
  }

  $('#open-modalPlaybook').on('click', function(){
      if(!$(this).hasClass('inactive')){
          $('#wrap-playbook-btn').append(
              $('<div>').attr('id', 'playbook-loading-mark')
                        .append(
                            $('<div>').attr('class', '_loading mx-auto')
                        )
          );
          $('#playbook-tbody > *').remove();
          $('#not-playbook-tbody > *').remove();
          var os_name = $('#hostinfo-os-name').data('osname');
          if(os_name.indexOf('Windows') != -1){
              var is_all_status_completed = true;
              var all_html_ids = JSON.parse($('#all_html_ids').val());
              var checked = JSON.parse($('#pages_checked').val());
              var checked_len = checked.length;
              if(checked_len > 0){
                  all_html_ids = checked;
              }
              var path = $('#sidfm_internal_api_get_host_playbook_data_path').val();
              $.ajax({
                  type: 'POST',
                  url: path,
                  data: {
                      'host_id': $('#host_id').val(),
                      'html_ids': JSON.stringify(all_html_ids),
                      'is_windows': true
                  }
              }).done(function(data){
                  is_all_status_completed = data.is_all_status_completed;
                  var is_all_checked = $('#pages_all_checked').val();
                  if((is_all_status_completed && checked_len === 0) ||
                     (is_all_status_completed && is_all_checked === 'true')){
                      $('#playbook-loading-mark').remove();
                      alert('全ての脆弱性に対して Playbook による Windows Update が不要なため、Playbook は出力されません。'); 
                      return false;
                  }else if(is_all_status_completed && checked_len > 0 && is_all_checked != 'true'){
                      $('#playbook-loading-mark').remove();
                      alert('選択した脆弱性に対して Playbook による Windows Update が不要なため、Playbook は出力されません。');
                      return false;
                  }
                  $('#modalPlaybook').find('.playbook-table').remove();
                  $('#modalPlaybook').find('#playbook-osname')
                                     .attr('class', 'badge badge-info font-weight-normal')
                                     .text('Windows Update 実行 Playbook');
                  $('#playbook-Windows-warning').show();
                  $('#modalPlaybook').modal('show');
                  $('#playbook-loading-mark').remove();
              });
          }else{
              var checked = JSON.parse($('#pages_checked').val());
              if(checked.length === 0){
                  checked = JSON.parse($('#all_html_ids').val());
              }
              var is_tr = false;
              var is_tr_for_not_playbook = false;
              var path = $('#sidfm_internal_api_get_host_playbook_data_path').val();
              $.ajax({
                  type: 'POST',
                  url: path,
                  data: {
                      'host_id': $('#host_id').val(),
                      'html_ids': JSON.stringify(checked)
                  }
              }).done(function(vuls){
                  $.each(vuls, function(){
                      var vul = this;
                      var pkg = vul.count_affpkgs;
                      var html_id = vul.html_id; 
                      if ( html_id < 0 ){
                          html_id = 'KB' + -html_id;
                      } 
                      var status_id = vul.status_id;
                      var title = '[' + html_id + ']' + ' ' + vul.title;
                      var tr = $('<tr>').attr('class', '');
                      var td = $('<td>').attr('class', 'g-max-width-440');
                      var div = $('<div>').attr('class', 'text-left text-truncate');
                      var link = url_vulnerabilities_detail(vul.html_id);
                      var a = $('<a>').attr('href', link);
                      var span = $('<span>').text(title);
                      a.append(span);
                      div.append(a);
                      td.append(div);
                      tr.append(td);
                      if(pkg === 0 || status_id == 3 || status_id == 4 ){
                          $('#not-playbook-tbody').append(tr);
                          is_tr_for_not_playbook = true; 
                      }else{
                          $('#playbook-tbody').append(tr);
                          is_tr = true;
                      }    
                  });
                  if (is_tr){
                      if(!is_tr_for_not_playbook){
                          $('.not-playbook').hide();
                      }else{
                          $('.not-playbook').show();
                      }
                      var os_name = $('#hostInformations').find('.os-name').text(); 
          
                      if( os_name.match(/RedHat|Red Hat|CentOS|Cent OS|Amazon/i)){
                          $('#modalPlaybook').find('#playbook-osname')
                                             .attr('class', 'badge badge-info font-weight-normal')
                                             .text('rpm パッケージ更新 Playbook');
                      }else if(os_name.indexOf('Ubuntu') != -1 || os_name.indexOf('Debian') != -1){
                          $('#modalPlaybook').find('#playbook-osname')
                                             .attr('class', 'badge badge-info font-weight-normal')
                                             .text('deb パッケージ更新 Playbook'); 
                      }
                      $('#playbook-loading-mark').remove();
                      $('#modalPlaybook').modal('show');
                  }else{
                      $('#playbook-loading-mark').remove();
                      if(JSON.parse($('#pages_checked').val()).length === 0 || $('#allSelect').prop('checked')){
                          alert('全ての脆弱性に関して影響しているパッケージが存在しないため、Playbook は出力されません。');
                      }else{
                          alert('選択した脆弱性には影響しているパッケージが存在しないため、Playbook は出力されません。');
                      }
                  }
              });
          }
      }
  });
 
  $('#playbook-download').on('click', function(){
      /*$('#playbook_download_idx').val($('#pages_idx').val());
      $('#playbook_download_order').val($('#pages_order').val());
      $('#playbook_download_filters').val($('#pages_filters').val());
      $('#playbook_download_htmlids').val($('#pages_checked').val());
      $('#form_playbook_download').submit();*/
      json_tsv_summary_table_progress_download($('#playbook_download_format').val(), $('#read-download-data-path').val(), {'form': $('#form_playbook_download')});
  });


    $('.vulSelect').on('change', function() {
	var checkbox = $(this);
	var hostid = parseInt(checkbox.val());
	var checked = JSON.parse($('#pages_checked').val());
	var all_host_ids = JSON.parse($('#all_html_ids').val());
	var all_host_size = all_host_ids.length;
	if (checkbox.prop('checked')) {
	    if (!checked.includes(hostid)) {
		checked.push(hostid);
		$('#pages_checked').val(JSON.stringify(checked));
	    }
	} else {
	    var idx = checked.indexOf(hostid);
	    if (idx == 0) {
		checked = checked.slice(1, all_host_size);
	    } else if (idx == all_host_size - 1) {
		checked = checked.slice(0, all_host_size - 1);
	    } else if (idx > 0 ) {
		var c_left = checked.slice(0, idx);
		var c_right = checked.slice(idx + 1, all_host_size);
		checked = c_left.concat(c_right);
	    }
	    $('#pages_checked').val(JSON.stringify(checked));
	}
	if (checked.length == all_host_size) {
	    $('.allVulSelect').prop('checked', true);
	    $('#pages_all_checked').val('true');
	} else {
	    $('.allVulSelect').prop('checked', false);
	    $('#pages_all_checked').val('');
	}
	if (checked.length) {
	    $('.bulkbtns').removeClass('disabled');
	    $('.bulkbtns').prop('disabled', false);
	} else {
	    $('.bulkbtns').addClass('disabled');
	    $('.bulkbtns').prop('disabled', true);
	}
	return true;
    });

    $('.allVulSelect').on('change', function() {
	var checkbox = $(this);
	if (checkbox.prop('checked')) {
	    $('#pages_checked').val($('#all_html_ids').val());
	    $('#pages_all_checked').val('true');
	    $('.vulSelect').prop('checked', true);
	    $('.bulkbtns').removeClass('disabled');
	    $('.bulkbtns').prop('disabled', false);
	} else {
	    $('#pages_checked').val(JSON.stringify([]));
	    $('#pages_all_checked').val('');
	    $('.vulSelect').prop('checked', false);
	    $('.bulkbtns').addClass('disabled');
	    $('.bulkbtns').prop('disabled', true);
	}
	return true;
    });

    $('#modalEditStatus').on('show.bs.modal', function(event) {
	var submit_button = $('#modalEditStatusExecute');
  if( $('#modalEditStatusSelect').val() == 0 ){
      submit_button.prop('disabled', true);
      submit_button.attr('aria-disabled', 'true');
   }else{
      submit_button.prop('disabled', false);
      submit_button.attr('aria-disabled', 'false');
   }
  $('#modalEditStatus_action').val('');
	var button = $(event.relatedTarget);
  if(button.data('action') === 'single'){
      $('#modalEditStatus_action').val('single');
  }
	var hostid = $('#host_id').val();
	var htmlid = button.data('htmlid');
	if (htmlid != 0) {
	    $('#modalLabelEditStatus').text('ステータス変更');
	    $('#modalEditStatusPrevBox').addClass('d-none');
	    $('#form_status').removeAttr('data-confirm');
	    $('#modalEditStatusPrev').val('0');
	} else {
	    $('#modalLabelEditStatus').text('ステータス一括変更');
	    $('#modalEditStatusPrevBox').removeClass('d-none');
	    $('#form_status').attr('data-confirm', '指定した脆弱性の内、変更対象ステータスで指定した対応状況に該当するもの全てが更新されます。本当に実行してよろしいですか？');
	}
	var htmlids = htmlid != 0 ? [ htmlid ] : JSON.parse($('#pages_checked').val());
	if (htmlids.length > 0) {
	    $.ajax({
		url: $('#host_htmls_statuses_path').val(),
		type: 'POST',
		dataType: 'json',
		data: {
		    'params[hostid]': hostid,
		    'params[htmlids]': JSON.stringify(htmlids)
		},
		timeout: AJAX_TIMEOUT_SECOND
	    })
	    .done(function(data) {
		$('#modalEditStatusTargetList > *').remove();
    if(Browser_Ident === 'Chrome'){
        var overflow_class = '';
    }else if(Browser_Ident === 'FireFox'){
        var overflow_class = ' overflow-clip';
    }else{
        //Safari
        var overflow_class = ' overflow-initial';
    }
		if (data.length > 0) {
		    var statuses = JSON.parse($('#statuses').val());
		    $('#modalEditStatusPrev > option').prop('selected', false);
		    if (data.length == 1) {
			$('#modalEditStatusPrev > option').each(function(i, e) {
			    var option = $(e);
			    var value = parseInt(option.attr('value'));
			    if (value == data[0]['status_id']) {
				option.prop('selected', true);
				return false;
			    }
			});
		    }
		    for (var i = 0; i < data.length; i++) {
			var c_tr = $('<tr></tr>').attr('class', 'd-flex');
			var c_td = $('<td></td>').attr({
          class: 'd-block modal-t-name' + overflow_class,
          style: 'padding: 0.17rem 0px 0.17rem !important;'//cssで!importantされているもの上書き
      });//, { class: 'hostname' });
			c_td.append(
          $('<div>').attr('class', 'modalEditStatus-vul-td-inner text-truncate').css('padding', '0px 0.25rem 0px').append(
               $('<span>').text(data[i]['title'])
          )
      );
			c_tr.append(c_td);
			c_td = $('<td></td>').attr('class', 'd-block modal-t-status');
			for (var j = 0; j < statuses.length; j++) {
			    if (statuses[j]['id'] == data[i]['status_id']) {
				var l = 'not-confirmed';
				switch (data[i]['status_id']) {
				case 1: l = 'not-confirmed'; break;
				case 2: l = 'ongoing'; break;
				case 3: l = 'fixed'; break;
				case 4: l = 'notaffect'; break;
				}
				var c_span = $('<span></span>', {
				    class: 'status-btn btn_st_' + l,
				    text: statuses[j]['name']
				});
				c_td.append(c_span);
				break;
			    }
			}
			c_tr.append(c_td);
			$('#modalEditStatusTargetList').append(c_tr);
		    }
		    $('#modalEditStatusNotice > *').remove();
		    if ('0' != $('#modalEditStatusSelect').val()) {
			$('#modalEditStatusExecute').prop('disabled', false);
			$('#modalEditStatusExecute').attr('aria-disabled', 'false');
		    }
		    $('#modalEditStatus_htmlids').val(JSON.stringify(htmlids));
        $('.modalEditStatus-vul-td-inner').outerWidth($('#modalEditStatus-vul-th').outerWidth() - 1.5);
		} else {
		    alert('対象データが削除されたため、画面をリロードします。');
		    location.reload(true);
		    return false;
		}
	    })
	    .fail(function(data) {
		alert('データの取得に失敗したため、画面をリロードします。');
		location.reload(true);
		return false;
	    })
	} else {
	    return false;
	}
	return true;
    });

  $('#form_status').on('submit', function(){
      /*var button = $(this);
      var target = $(button.data('target'));
      var dump = {
          'pages[offset]': $('#pages_offset').val(),
          'pages[per_page]': $('#pages_per_page').val(),
          'pages[order]' : $('#pages_order').val(),
          'pages[filters]': JSON.parse($('#pages_filters').val()),
          'pages[grp]': $('#pages_grp').val(),
          'pages[idx]': $('#pages_idx').val(),
          'pages[checked]': [],
          'pages[all_checked]': false
      };
      target.val(JSON.stringify(dump));
      if($('#modalEditStatus_action').val() === 'single'){
          var htmlid = JSON.parse($('#modalEditStatus_htmlids').val())[0];
          $.cookie('clicked_vul_id', htmlid);
      }*/
      var msg = $('#form_status').attr('data-confirm'); 
      var info = {
          'prev_status': $('#modalEditStatusPrev').val(),
          'new_status': $('#modalEditStatusSelect').val(),
          'comment': $('#modalEditStatus-comment-field').val(),
          'action': $('#modalEditStatus_action').val()
      }
      if($('#modalEditStatus_action').val() === 'single'){
          var htmlid = JSON.parse($('#modalEditStatus_htmlids').val())[0];
          $.cookie('clicked_vul_id', htmlid);
          info['ids'] = [ htmlid ];
      }else{
          info['ids'] = JSON.parse($('#modalEditStatus_htmlids').val());
      }
      execute_process_with_progress_bar('status', msg, info, $('#sidfm_host_update_status_path').val());
      return false;
  }); 
 

  $(window).on('load', function(){
      var selected_id = $('#selected_id').val();
      if(selected_id){
          $('#host-table').find('[data-htmlid=' + selected_id + ']')
                          .find('td').addClass('selected-tr-item');
      } 
  });  

   /* $('#modalEditStatus, #modalEditSchedule').on('shown.bs.modal', function() {
      if($(this).attr('id') == 'modalEditSchedule'){
          var tbody = $('#modalEditScheduleTargetList');
          var thead_w = $('#modalEditSchedule-thead').outerWidth(true);
      }else{
          var tbody = $('#modalEditStatusTargetList');
          var thead_w = $('#modalEditStatus-thead').outerWidth(true);
      }
      var tr_w = tbody.find('tr:first').outerWidth(true);
      if(thead_w > tr_w){
          var width = thead_w - tr_w;
          var target_width = tbody.find('.modal-t-name:first').outerWidth(true);
          tbody.find('.modal-t-name')
               .width(target_width + width + 7);
      }
   });*/


    $('#modalEditStatusSelect').on('change', function(event) {
	var target = $(this);
	var new_val = target.val();
	var button = $('#modalEditStatusExecute');
	if ('0' == new_val) {
	    button.prop('disabled', true);
	    button.attr('aria-disabled', 'true');
	} else {
	    button.prop('disabled', false);
	    button.attr('aria-disabled', 'false');
	}
	return true;
    });

    function bulk_update_shedule(hostid, htmlids){
        if(htmlids.length === 0){
            return false;
        }
        $.ajax({
            url: $('#host_htmls_due_dates_path').val(),
            type: 'POST',
            dataType: 'json',
            data: {
                'params[hostid]': hostid,
                'params[htmlids]': JSON.stringify(htmlids)
            },
            timeout: AJAX_TIMEOUT_SECOND
        }).done(function(data) {
            $('#modalEditScheduleTargetList > *').remove();
            if (data.length > 0) {
                if(Browser_Ident === 'Chrome'){
                    var overflow_class = '';
                }else if(Browser_Ident === 'FireFox'){
                    var overflow_class = ' overflow-clip';
                }else{
                    //Safari
                    var overflow_class = ' overflow-initial';
                }
                $('#modalEditSchedule').modal('show');
                $('#modalEditSchedule_due_date').val('');
                if (data.length == 1) {
                    $('#modalEditSchedule_due_date').val(data[0]['due_date']);
                }
                for (var i = 0; i < data.length; i++) {
                    var c_tr = $('<tr></tr>').attr('class', 'd-flex');
                    var c_td = $('<td></td>').attr({
                        'class': 'd-block modal-t-name' + overflow_class,
                        style: 'padding: 0.17rem 0px 0.17rem !important;'//cssで!importantされているものを上書き
                    });
                    c_td.append(
                        $('<div>').attr('class', 'modalEditSchedule-vul-td-inner text-truncate').css('padding', '0px 0.25rem 0px').append(
                            $('<span>').text(data[i]['title'])
                        )
                    );
                    c_tr.append(c_td);
                    c_td = $('<td></td>', { class: 'd-block modal-t-date' });
                    c_td.text(data[i]['due_date'] ? data[i]['due_date'] : '未設定');
                    c_tr.append(c_td);
                    $('#modalEditScheduleTargetList').append(c_tr);
                }
                $('#modalEditScheduleNotice > *').remove();
                $('#modalEditScheduleExecute').prop('disabled', false);
                $('#modalEditSchedule_htmlids').val(JSON.stringify(htmlids));
                $('.modalEditSchedule-vul-td-inner').outerWidth($('#modalEditSchedule-vul-th').width());
            } else {
                alert('指定したホストが削除されたため、画面をリロードします。');
                location.reload(true);
                return false;
            }
        }).fail(function(data) {
            alert('データの取得に失敗したため、画面をリロードします。');
            location.reload(true);
            return false;
        });
    }
   
    $('[data-target="#modalEditSchedule"]').on('click', function(){
        var button = $(this);
        var hostid = $('#host_id').val();
        var htmlid = button.data('htmlid');
        $('#modalEditSchedule_action').val('');
        if(button.data('action') === 'single'){
            $('#modalEditSchedule_action').val('single');
        }
        if (htmlid != 0) {
            $('#modalLabelEditSchedule').text('対策予定日変更');
            $('#bulk-edit-schedule-caution').hide();
            var htmlids = [ htmlid ];
        } else {
            $('#modalLabelEditSchedule').text('対策予定日一括変更');
            var htmlids = JSON.parse($('#pages_checked').val());
        }
        //対策予定日一括変更の時に、ステータスが対策済・影響無のものを外す
        $.ajax({
            url: $('#get_unfinished_htmlids_path').val(),
            type: 'POST',
            data: { 'html_ids': JSON.stringify(htmlids), 'host_id': hostid },
            timeout: AJAX_TIMEOUT_SECOND
        }).done(function(data){
            var filtered_htmlids = data['target_ids'];
            var untargeted_vuls = data['not_target_ids'];
            if(filtered_htmlids.length === 0){
                alert('対象となる脆弱性は存在しません。\n※未対策と対策中の脆弱性のみ、対策予定日を設定できます。\n未対策あるいは対策中の脆弱性を選択している場合は、脆弱性のステータスが変更されています。画面をリロードして下さい。');
                return false;
            }
            if(untargeted_vuls.length > 0 ){
                untargeted_vuls = untargeted_vuls.map(function(h_id){
                    return '.vulSelect[value="' + h_id + '"]';
                });
                $('#host-table').find(untargeted_vuls.join(', ')).prop('checked', false);
                $('#bulk-edit-schedule-caution').show();
                $('#allSelect').prop('checked', false);
            }else{
                $('#bulk-edit-schedule-caution').hide();
            }
            $('#pages_checked').val(JSON.stringify(filtered_htmlids));
            bulk_update_shedule(hostid, filtered_htmlids);
        }).fail(function(data) {
            alert('データの取得に失敗したため、画面をリロードします。');
            location.reload(true);
            return false;
        });
   
    });

  $('#form_due_dates').on('submit', function(){
      if($('#modalEditSchedule_action').val() === 'single'){
          var conf = true;
      }else{
          var conf = confirm('「強制上書き」が有効な場合は指定した脆弱性全て、無効な場合は対策予定日が設定されていない脆弱性の内、対策が終了していないもの全ての対策予定日が更新されます。本当に実行してよろしいですか？');
      }
      if( conf ){
          var msg = $('#form_due_dates').attr('data-confirm');
          var info = {
              'force': $('#modalEditSchedule-force-flg').prop('checked'),
              'due_date': $('#modalEditSchedule_due_date').val(),
              'comment': $('#modalEditSchedule-comment-field').val(),
              'action': $('#modalEditSchedule_action').val()
          }
          if($('#modalEditSchedule_action').val() === 'single'){
              var htmlid = JSON.parse($('#modalEditSchedule_htmlids').val())[0];
              $.cookie('clicked_vul_id', htmlid);
                 info['ids'] = [ htmlid ];
          }else{
              info['ids'] = JSON.parse($('#modalEditSchedule_htmlids').val());
          }
          execute_process_with_progress_bar('schedule', msg, info, $('#sidfm_host_update_due_dates_path').val());
      }
      return false;
  });

  function get_popover_btn(names_array, userid, type){
      var elms_for_popover = '';
      for(var j = 0; j < names_array.length; j++){
          elms_for_popover += '<div class="p-1 max-width-160px g-font-size-0_93x text-truncate border list_alternative3">' + escape_html_special_chars(names_array[j]) + '</div>';
      }
      var popover_btn = $('<div>').attr({
                            'class': 'max-width-160px',
                         }).append(
                             $('<div>').attr({
                                 'class': ' mail-btn show-original-popover btn btn-xs btn-light-nb text-nowrap w-100',
                                 'data-popoverid': type + userid,
                                 'data-html': 'true',
                                 'data-content': elms_for_popover,
                             }).append(
                                 $('<div>').attr('class', 'd-flex').append(
                                     $('<span>').attr('class', 'text-left mr-1 inline-block text-truncate w-100')
                                                .text(names_array[0]),
                                     $('<span>').attr('class', 'position-static ml-auto inline-block badge badge-pill badge-gray-999')                                                                                      .text(names_array.length)
                                   )
                               )
                           );
      return popover_btn
  }
  
  $('#modalSendMail').on('show.bs.modal', function(event) {
  $('#loading').hide();
  $('#recipients').val(JSON.stringify({}));
  $('#users_sidinfo').val(JSON.stringify([]));
  $('#AllUsersSelect').prop('checked', false);
  $('#count-letters').text('0');
  revert_changekeywords_btn();
  $('#mail-length-over').attr('class', 'invisible');
  $('#limit-keywords-data').text('20件');
  $('#limit-data-num').val(20);
  $('#show-byte').text('byte');
  $('#keyword_loading').remove();
  $('#modalSendMailTargetList .chk-box .user-chk-box').prop('checked', false);
	var button = $(event.relatedTarget);
	var target_hostname = button.data('hostname');
  var target_extname = button.data('extname');
  var target_displayname = button.data('displayname');
	var htmlids = JSON.parse($('#pages_checked').val());
	if (htmlids.length == 0) {
	    var firstVulSelect = $('.vulSelect:first');
	    if (firstVulSelect) {
		htmlids = [ parseInt(firstVulSelect.val()) ];
	    }
	}
	if (htmlids.length > 0) {
     $('#modal-main').hide();
     $('#loading').show();
	    $.ajax({
		url: $('#host_htmls_emails_path').val(),
		type: 'POST',
		dataType: 'json',
		data: { 'params[htmlids]': JSON.stringify(htmlids),
		        'params[hostid]': $('#host_id').val() },
		timeout: 5000
	    })
	    .done(function(data) {
    $('#loading').hide();
    $('#modal-main').show();
		var htmls = data['htmls'];
		var users = data['users'];
		var userids = Object.keys(users);
    if(userids.length === 0){
        $('#AllUsersSelect').prop('disabled', true);
    } else {
        $('#AllUsersSelect').prop('disabled', false);
    }
		if (userids.length > 0) {
		    var hostnames = [ target_hostname ];
		    $('#modalSendMailTargetList > *').remove();
        var users_without_id = [];
        for (var i = 0; i < userids.length; i++) {
            var user = users[userids[i]];
            users_without_id.push(user);
        }
        users_without_id = users_without_id.sort(function(a, b) {
                           if(a['lastname'].toString().toLowerCase() > b['lastname'].toString().toLowerCase()){
                               return 1;
                           }else if(a['lastname'].toString().toLowerCase() === b['lastname'].toString().toLowerCase()){
                                if(a['firstname'].toString().toLowerCase() > b['firstname'].toString().toLowerCase()){
                                    return 1;
                                } else {
                                    return -1;
                                } 

                           }else{
                               return -1;
                           }
                           }); 
        var all_users = {};
        var users_sidinfo = [];
        var user_num = 0;
		    for (var i = 0; i < userids.length; i++) { 
      user_num += 1;
			var user = users_without_id[i];
      var fullname = user['lastname'] + ' ' +  user['firstname']; 
      var c_tr = $('<tr></tr>').attr('class', '');
      var c_td = $('<td></td>', { class: 'chk-box modal-mail-chkbox text-center' });
      var c_chkbox = $('<input>', { type: 'checkbox', class: 'user-chk-box'});
      c_td.append(c_chkbox);
      c_tr.append(c_td);
			c_td = $('<td></td>', { class: 'name modal-mail-name' });
		  c_td.text(fullname);
			c_tr.append(c_td);
			c_td = $('<td></td>', { class: 'mailaddress modal-mail-address' });
			for (var j = 0; j < user['emails'].length; j++) {
			    var email = user['emails'][j];
			    var c_div = $('<div class="text-truncate modal-mail-address"></div>');
			    c_div.text(email['address']);
			    c_td.append(c_div);
          all_users[email['address']] = fullname;
			}
			c_tr.append(c_td);
      var category_names = [];
			c_td = $('<td></td>', { class: 'category modal-mail-category' });
			for (var j = 0; j < user['categories'].length; j++) {
			    var category = user['categories'][j];
			    category_names.push(category['name']);
			}
      if(category_names.length > 1){
          category_names.sort();
          var categories_elm = get_popover_btn(category_names, userids[i], 'category');
      }else{
          var categories_elm = $('<div>').attr('class', 'g-pl-5 g-font-size-0_93x text-truncate max-width-160px').text(category_names[0]);
      }
      c_td.append(categories_elm);
			c_tr.append(c_td);
      //var temp_hostnames = [];
			c_td = $('<td></td>', { class: 'host modal-mail-host' });
      var c_div = $('<div>').attr({
          'class': 'g-pl-5 g-font-size-0_93x text-truncate max-width-160px',
          'data-toggle': 'tooltip',
          'data-title': 'ホスト名: ' + target_hostname + '<br/>表示名: ' + (target_extname.length > 0 ? target_extname : '(未設定)'),
          'data-html': 'true',
          'data-boundary': 'window',
          'data-placement': 'right'
      }).text(target_displayname);
			c_td.append(c_div);
			c_tr.append(c_td);
      var userinfo = {
          'num': user_num, 
          'category_names': category_names, 
          'hostnames': [target_hostname],
          'display_names': [target_displayname]
      };
      c_chkbox.val(JSON.stringify(userinfo));
      users_sidinfo.push(userinfo);
			$('#modalSendMailTargetList').append(c_tr);
      $('#modalSendMailTargetList').find('[data-toggle="tooltip"]').tooltip();
		    }
		    $('#modalSendMailNotice > *').remove();
		   
      $('#modalSendmailBodyTitle').val('');
      $('#modalSendmailBodyText').val('');
      $('#keywords-list').prop('disabled', false);
      $('#modalSendmailExecute').prop('disabled', true);
      $('#MailConfirmation-btn').prop('disabled', true); 
      $('#change-keywords').prop('disabled', false);
      $('#limit-keywords-data').prop('disabled', false);
      $('#reset-mailmodal').prop('disabled', false);     
      var chk_box_length = $('#modalSendMailTargetList .user-chk-box').length;
      $('#modalSendMailTargetList .chk-box .user-chk-box').on('change', function() {
          var checkbox = $(this);
          var user_info = JSON.parse(checkbox.val());
          var temp_users_sidinfo = JSON.parse($('#users_sidinfo').val());
          var recipients = JSON.parse($('#recipients').val());
          var user_address = checkbox.parent().siblings('.mailaddress').text();
          var user_name = checkbox.parent().siblings('.name').text();
          if (checkbox.prop('checked')) {
              temp_users_sidinfo.push(user_info);
              recipients[user_address] = user_name;
          }else{
              for(var i = 0; i < temp_users_sidinfo.length; i++){
                  if(temp_users_sidinfo[i]['num'] === user_info['num']){
                      temp_users_sidinfo.splice(i, 1);
                  }
              }
              delete recipients[user_address];
          }
          if (Object.keys(recipients).length === chk_box_length){
              $('#AllUsersSelect').prop('checked', true);
          }else{
              $('#AllUsersSelect').prop('checked', false);
          }
          if($('.user-chk-box:checked').length === 0){
              $('#modalSendmailExecute').prop('disabled', true);
          }else{
              if($('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
                  $('#modalSendmailExecute').prop('disabled', false);
              }
          }
          $('#recipients').val(JSON.stringify(recipients));
          $('#users_sidinfo').val(JSON.stringify(temp_users_sidinfo));
      });
      $('#AllUsersSelect').on('change', function (){
          var all_chk_box = $('#modalSendMailTargetList .user-chk-box');
          if ($(this).prop('checked')) {
              all_chk_box.prop('checked', true);
              $('#recipients').val(JSON.stringify(all_users));
              $('#users_sidinfo').val(JSON.stringify(users_sidinfo));
              if($('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){            
                  $('#modalSendmailExecute').prop('disabled', false);
              }
          }else{
              all_chk_box.prop('checked', false);
              $('#recipients').val(JSON.stringify({}));
              $('#users_sidinfo').val(JSON.stringify([]));
              $('#modalSendmailExecute').prop('disabled', true);
          }
      });
      $('#modalSendmailBodyTitle').on('keydown', function(e) {
          if(e.keyCode && e.keyCode === 13){
              return false;
          }
      });
     
      $('#modalSendMail').on('hide.bs.modal', function (){
         $('.dropdown-menu.show:last').closest('.action-close-dropdown').find('.dropdown-toggle').click();
      });
      // tableのcss設定中は表示隠す
      //$('#modalSendMailTargetList').css('opacity', '0.05');
      
      set_modal_mail_btn_font_size();
		} else {
		    var temp = $('<div></div>', {
			class: 'alert alert-danger',
			role: 'alert'
		    });
		    temp.text('指定したホストに、メール送信可能なユーザが関連付けられたカテゴリが設定されておりません。メール送信を行うためには、ユーザを関連づけたカテゴリを作成し、各ホストのカテゴリとして追加登録する必要があります。');
		    $('#modalSendMailNotice > *').remove();
		    $('#modalSendMailNotice').append(temp);
        $('#keywords-list').prop('disabled', true);
  		  $('#modalSendmailExecute').prop('disabled', true);
        $('#MailConfirmation-btn').prop('disabled', true);
        $('#modalSendmailBodyTitle').val('');
        $('#modalSendmailBodyText').val('');
        $('#change-keywords').prop('disabled', true);
        $('#limit-keywords-data').prop('disabled', true);
        $('#reset-mailmodal').prop('disabled', true);
		}
 	    })
            .fail(function(data) {
		alert('データの取得に失敗したため、画面をリロードします。');
		location.reload(true);
		return false;
	    });
	} else {
	    return false;
	}
  return true;
  });
  $('#modalSendmailBodyText, #modalSendmailBodyTitle').on('input', function(){
      if($('#change-keywords').text() === 'キーワードに戻す'){
          revert_changekeywords_btn();
      }
      check_mail_length($('#modalSendmailBodyTitle').val() + $('#modalSendmailBodyText').val());
       if($('#recipients').val() != '{}' && $('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
          $('#modalSendmailExecute').prop('disabled', false);
      }else{
          $('#modalSendmailExecute').prop('disabled', true);
      }
  });
  
  $('#modalSendMail').on('shown.bs.modal',function(){
      //heightを設定してロードマーク表示時に崩れないようにする
      $('#LoadingTarget').height($('#change-keywords').height());
  });

  function set_modal_mail_btn_font_size(){
      if($(window).width() < 992){
          $('#modalSendMail').find('.modal-mail-footer-part').css('font-size', '75%');
      }else{
          $('#modalSendMail').find('.modal-mail-footer-part').css('font-size', '');
      }
  }

  $(window).on('resize', set_modal_mail_btn_font_size);
 // var edited_text;
 // var edited_title;
  $('#modalSendmailExecute').on('click', function(){
      if($('#modalSendmailBodyTitle').val().length === 0){
          alert('件名を入力して下さい');
          return false;
      }
      if($('#modalSendmailBodyText').val().length ===0){
          alert('本文を入力して下さい');
          return false;
      }
      $('#wrap-modalSendmailExecute').append(
           $('<div>').attr('id', 'conf-btn-loading-mark').append(
               $('<div>').attr('class', '_loading mx-auto')
           )
      );
      replace_mail_keywords('#confirm-subject', '#confirm-message', true);
  });
  $('#mail-cancel, #close-mailmodal').on('click', function(){
      if($('#modalSendmailBodyText').val() != '' || $('#modalSendmailBodyTitle').val() != ''){
           return confirm('メールの内容は破棄されます。よろしいですか？');
      }
  });
  $('#MailConfirmation').on('hide.bs.modal', function(){
      $('#modalSendmailBodyTitle').val($('#confirm-subject').text());
      $('#modalSendmailBodyText').val($('#confirm-message').val());
      check_mail_length($('#confirm-message').val() + $('#confirm-subject').text());
  });
  $('#MailConfirmation').on('show.bs.modal', function (e){
      $('#confirm-recipients > *').remove();
      var recipients = JSON.parse($('#recipients').val());
      $.each(recipients, function( address, name) {
         var recipient_text = name + '<' + address + '>';
         var recipient = $('<tr><td></td></tr>');
         recipient.text(recipient_text);
         $('#confirm-recipients').append(recipient);
      });
      /*var mailcontent = replace_mail_keywords('#confirm-subject', '#confirm-message');
      if(mailcontent != 'nochange'){
          change_changekeywords_btn();
          before_replaced = mailcontent;
      }
      var bytes = calc_bytes($('#confirm-message').val() + $('#confirm-subject').text());
      if(bytes > 1048576){
          $('#warn-length-over').attr('class', 'ml-auto visible');
          $('#MailConfirmationSubmit').prop('disabled', true);
      }else{
          $('#warn-length-over').attr('class', 'ml-auto invisible');
          $('#MailConfirmationSubmit').prop('disabled', false);
      }*/
  });
  /*var unhandled_rate = $('#unhandled_rate').val() + '%';
  var URL = location.origin + location.pathname;
  var page_title = $('#sidfm_header_title').text().trim();
  var risks = JSON.parse($('#number_of_risks').val());
  var risks_text;
  var risks_names;
  var nums;
  if (risks['sri']){
      risks_names = ['重大', '高', '中', '低', '無', '済'];
      nums = risks['sri'];
  }else if (risks['cvss']){
      nums = risks['cvss'];
      risks_names = ['未登録', ' 10.0～9.0', ' 8.9～7.0', ' 6.9～4.0', ' 3.9～0.0', ' 済'];
  }
  calculate_percentage(nums, risks_names, 'risks');
  var status_text;
  var status_nums = JSON.parse($('#number_of_status').val());
  var all_area = ['未定義 ', 'ローカル ', 'クライント ', 'リモート '];
  var all_status_names = ['未対策', ' 対策中', ' 対策済', ' 影響無'];
  var all_sri_status = ['無', '低', '中', '高', '重大']; 
  calculate_percentage(status_nums, all_status_names, 'status');
  function calculate_percentage(numbers, labelnames, section){
      var sum = 0;
      var text = [];
      for (var i = 0; i < numbers.length; i++){
          sum += parseInt(numbers[i]);
      }
      for (var i = 0; i < labelnames.length; i++){
          var num = parseInt(numbers[i]);
          var percentage = (num / sum * 100).toFixed(3);
          if(percentage >= 10){
              percentage = (num / sum * 100).toFixed(1);
          } else if(percentage < 10 && percentage >= 1) {
              percentage = (num / sum * 100).toFixed(2);
          }
          percentage = parseFloat(percentage) + '%';
          text.push(labelnames[i] + ': ' + percentage);
      }
      if(section === 'risks'){
          risks_text = text;
      } else {
          status_text = text;
      }
  }
  var risks_rate = risks_text.join(',');
  var handling_rate = status_text.join(',');
  var hostinfo = JSON.parse($('#hostinfo').val());
  var self_hostname = hostinfo['hostname'];
  var self_displayname = hostinfo['display_name'];
  var osname = hostinfo['osname'];
  var latest_date = hostinfo['last_checked_at'];
  var synchro = hostinfo['synchro'];
  var agent = hostinfo['agent'];
  var s_cat = hostinfo['s_category'];
  var c_cat = hostinfo['c_category'];
  var pkgs_quant = hostinfo['pkgs_quantity'];
  var apps = hostinfo['apps'];
  var lapps = hostinfo['lapps'];
  var lproducts = hostinfo['lproducts'];
  var memo = hostinfo['memo'];
  var myuserinfo = JSON.parse($('#myuserinfo').val());
  var myusername = myuserinfo['name'];
  var myemail = myuserinfo['email'];
  var mylogin = myuserinfo['login'];*/
  function replace_mail_keywords(subject_field, message_field, is_conf_modal = false){
      var unhandled_rate = $('#unhandled_rate').val() + '%';
      var URL = location.origin + location.pathname;
      var page_title = $('#sidfm_header_title').text().trim();
      var risks = JSON.parse($('#number_of_risks').val());
      var risks_text;
      var risks_names;
      var nums;
      if (risks['sri']){
          risks_names = ['重大', '高', '中', '低', '無', '済'];
          nums = risks['sri'];
      }else if (risks['cvss']){
          nums = risks['cvss'];
          risks_names = ['未登録', ' 10.0～9.0', ' 8.9～7.0', ' 6.9～4.0', ' 3.9～0.0', ' 済'];
      }
      calculate_percentage(nums, risks_names, 'risks');
      var status_text;
      var status_nums = JSON.parse($('#number_of_status').val());
      var all_area = ['未定義 ', 'ローカル ', 'クライント ', 'リモート '];
      var all_status_names = ['未対策', ' 対策中', ' 対策済', ' 影響無'];
      var all_sri_status = ['無', '低', '中', '高', '重大'];
      calculate_percentage(status_nums, all_status_names, 'status');
      function calculate_percentage(numbers, labelnames, section){
          var sum = 0;
          var text = [];
          for (var i = 0; i < numbers.length; i++){
              sum += parseInt(numbers[i]);
          }
          for (var i = 0; i < labelnames.length; i++){
              var num = parseInt(numbers[i]);
              var percentage = (num / sum * 100).toFixed(3);
              if(percentage >= 10){
                  percentage = (num / sum * 100).toFixed(1);
              } else if(percentage < 10 && percentage >= 1) {
                  percentage = (num / sum * 100).toFixed(2);
              }
              percentage = parseFloat(percentage) + '%';
              text.push(labelnames[i] + ': ' + percentage);
          }
          if(section === 'risks'){
              risks_text = text;
          } else {
              status_text = text;
          }
      }
      var risks_rate = risks_text.join(',');
      var handling_rate = status_text.join(',');
      var hostinfo = JSON.parse($('#hostinfo').val());
      var self_hostname = hostinfo['hostname'];
      var self_displayname = hostinfo['display_name'];
      var osname = hostinfo['osname'];
      var latest_date = hostinfo['last_checked_at'];
      var synchro = hostinfo['synchro'];
      var agent = hostinfo['agent'];
      var s_cat = hostinfo['s_category'];
      var c_cat = hostinfo['c_category'];
      var pkgs_quant = hostinfo['pkgs_quantity'];
      var apps = hostinfo['apps'];
      var lapps = hostinfo['lapps'];
      var lproducts = hostinfo['lproducts'];
      var memo = hostinfo['memo'];
      var myuserinfo = JSON.parse($('#myuserinfo').val());
      var myusername = myuserinfo['name'];
      var myemail = myuserinfo['email'];
      var mylogin = myuserinfo['login'];

      var limit_num = parseInt($('#limit-data-num').val());
      var checked = JSON.parse($('#pages_checked').val());
      var vuls_info_list = [];
      var selected_users = [];
      var unhandled_rate = $('#unhandled_rate').val() + '%';
      var recipients_sidinfo = JSON.parse($('#users_sidinfo').val());
      var recipients_hostnames = [];
      var recipients_display_names = [];
      var recipients_categories = [];
      for(var i = 0; i < recipients_sidinfo.length; i++){
          var info = recipients_sidinfo[i];
          recipients_hostnames.push(info['hostnames']);
          recipients_display_names.push(info['display_names']);
          recipients_categories.push(info['category_names']);
      }
      recipients_hostnames = Array.prototype.concat.apply([], recipients_hostnames);
      recipients_display_names = Array.prototype.concat.apply([], recipients_display_names);
      recipients_categories = Array.prototype.concat.apply([], recipients_categories);
      recipients_categories = Array.from(new Set(recipients_categories));
      recipients_hostnames = Array.from(new Set(recipients_hostnames));
      recipients_display_names = Array.from(new Set(recipients_display_names));
      var self_categories = JSON.parse($('#self_user_categories').val());
      var self_custom_category_names = [];
      var self_system_category_names = [];
      for(var i = 0; i < self_categories.length; i++){
          var c = self_categories[i];
          if(c['custom_c']){
              self_custom_category_names.push(c['custom_c']);
          }else if(c['system_c']){
              self_system_category_names.push(c['system_c']);
          }
      }
      var vulsnames_list = [];
      var links_to_vuldetail = [];
      var count = 0;
      var subject_val = $('#modalSendmailBodyTitle').val();
      var message_val = $('#modalSendmailBodyText').val();
      var is_list_related_keywords = (subject_val + message_val).match(/%VULNERABILITY%|%VULTITLE%|%LINKS%/);
      var path = $('#sidfm_internal_api_get_host_send_mail_data_path').val();
      $.ajax({
          type: 'POST',
          url: path,
          data: { 
            'host_id': $('#host_id').val(),
            'html_ids': is_list_related_keywords ? JSON.stringify(checked) : '[]', 
            'index': $('#pages_idx').val() 
          }
      }).done(function(data){
          if( data['err_message'] ){
              alert(data['err_message']);
              location.reload();
              return false;
          }
          $.each(data['data'], function(){
              var vul = this;
              var vulid = vul.html_id;
              var vulname = vul.vulname;
              vulsnames_list.push(vulname);
              if(count < limit_num){
                  var link = location.origin + url_vulnerability_detail(vulid);
                  link_with_vulname =  vulname + '\n' + link;
                  links_to_vuldetail.push(link_with_vulname);
              }
              if(subject_val.indexOf('%VULNERABILITY%') != -1 || message_val.indexOf('%VULNERABILITY%') != -1){
                  if(count < limit_num){
                      var areaid = vul.area_id;
                      var area = all_area[areaid];
                      var status_id = vul.status_id;
                      var h_status = all_status_names[status_id -1];
                      var date = vul.date;
                      var detected_date = vul.detected_date;
                      var elapsed_days = vul.elapsed_days;
                      var sri_id = vul.sri;
                      var sri = all_sri_status[sri_id];
                      var cvss = vul.cvss;
                      var taiou = vul.taiou;
                      var exploit = vul.exploit;
                      var text =  [vulname, link, '対応:' + taiou + '   ' + 'SRI値:' + sri + '   ' + 'CVSS値:' + cvss + '   ' + '影響範囲:' + area + '   ' + '攻撃コード:' + exploit, '対応状況:' + h_status, '検出日:' + detected_date + '   ' + '検出後の経過日数:' + elapsed_days + '   ' + '対策予定日:' + date];
                      vuls_info_list.push(text.join('\n'));
                 }
              }
              count += 1;
          });
     
          var host_detail_info = [
              self_displayname + '   ' + synchro + '   ' + 'エージェント:' + agent, 
              '最新の脆弱性確認日時:' + latest_date, 
              'システムカテゴリ:' + s_cat + '   ' + 'カスタムカテゴリ:' + c_cat.join(', '),
              '検出パッケージ数:' + pkgs_quant + '件' + '   ' + '検出アプリケーション数:' + ((apps.length === 1 && apps[0] === 'なし') ? '0件' : apps.length + '件') + '   ' + '手動登録プロダクト数:' + ((lapps.length === 1 && lapps[0] === 'なし') ? '0件' : lapps.length + '件') + '   ローカルプロダクト数:' + ((lproducts.length === 1 && lproducts[0] === 'なし') ? '0件' : lproducts.length + '件'), 
              'メモ:' + (memo ? memo : '') 
          ];
  
          var u_checked  = JSON.parse($('#recipients').val());
          for (key in u_checked){
              selected_users.push(u_checked[key]);
          }
          var sort_list = [
              apps, lapps, lproducts, selected_users, c_cat, recipients_categories,
              recipients_hostnames, recipients_display_names , self_custom_category_names 
          ];
          for(var n = 0; n < sort_list.length; n ++){
              var l = sort_list[n];
              l.sort(function(a, b){
                  if(a.toLowerCase() > b.toLowerCase()){
                      return 1;
                  }else{
                      return -1;
                 }
              });
          }
          apps = apps.slice(0, limit_num);
          lapps = lapps.slice(0, limit_num);
          lproducts = lproducts.slice(0, limit_num);
          selected_users = selected_users.slice(0, limit_num);
          c_cat = c_cat.slice(0, limit_num);
          c_cat = Array.from(new Set(c_cat));
          vulsnames_list = vulsnames_list.slice(0, limit_num);
          recipients_categories = recipients_categories.slice(0, limit_num);
          recipients_hostnames = recipients_hostnames.slice(0, limit_num);
          recipients_display_names = recipients_display_names.slice(0, limit_num);
          self_system_category = self_system_category_names.slice(0, limit_num);
          self_custom_category_names = self_custom_category_names.slice(0, limit_num);

          function replace_keywords(text) {
              var replaced_text = 
              text.replace(/%VULNERABILITY%/, vuls_info_list.join('\n\n'))
                  .replace(/%HOSTDETAIL%/g, host_detail_info.join('\n'))
                  .replace(/%APP%/g, apps.join('\n'))
                  .replace(/%PRODUCT%/g, lapps.join(', '))
                  .replace(/%LPRODUCT%/g, lproducts.join(', '))
                  .replace(/%PKG%/g, pkgs_quant)
                  .replace(/%URL%/g, URL)
                  .replace(/%LINKS%/, links_to_vuldetail.join(',\n'))
                  .replace(/%NAME%/, selected_users.join(', '))
                  .replace(/%TITLE%/g, page_title)
                  .replace(/%UNHANDLED_RATE%/g, unhandled_rate)
                  .replace(/%RISK_RATE%/g, risks_rate)
                  .replace(/%HANDLING_RATE%/g, handling_rate)
                  .replace(/%OSNAME%/g, osname)
                  .replace(/%DATE%/g, latest_date)
                  .replace(/%AGENT%/g, agent)
                  .replace(/%S_CATEGORY%/g, s_cat)
                  .replace(/%C_CATEGORY%/g, c_cat.join(', '))
                  .replace(/%STATUS%/g, synchro)
                  .replace(/%MEMO%/g, memo ? memo : '')
                  .replace(/%VULTITLE%/, vulsnames_list.join('\n'))
                  .replace(/%MYNAME%/g, myusername)
                  .replace(/%MY_USER_NAME%/g, mylogin)
                  .replace(/%MYEMAIL%/g, myemail)
                  .replace(/%R_HOSTNAME%/, recipients_hostnames.join(', '))
                  .replace(/%R_DISPLAY_NAME%/, recipients_display_names.join(', '))
                  .replace(/%R_CATEGORY%/, recipients_categories.join(', '))
                  .replace(/%MY_S_CATEGORY%/g, self_system_category_names.length > 0 ? self_system_category_names.join(', ') : 'システムカテゴリ無し')
                  .replace(/%MY_C_CATEGORY%/g, self_custom_category_names.length > 0 ? self_custom_category_names.join(', ') : 'カスタムカテゴリ無し')
                  ;
              return replaced_text;
          }
          var message = $('#modalSendmailBodyText').val();        
          var replaced_message = replace_keywords(message);
          var subject = $('#modalSendmailBodyTitle').val();
          var replaced_subject = replace_keywords(subject);
          if(subject_field === '#modalSendmailBodyTitle'){
              $(subject_field).val(replaced_subject);
          }else{
              $(subject_field).text(replaced_subject);
          }
          $(message_field).val(replaced_message);
    
          if(message === replaced_message && subject === replaced_subject){
             if( !is_conf_modal ){
                 $('#change-keywords').tooltip('show');
                 setTimeout(function(){
                     $('#change-keywords').tooltip('hide');
                 }, 1000);
             }
          }else{
              $('#before_replaced').val(JSON.stringify({'subject': subject, 'message': message}));
              change_changekeywords_btn();
          }

          if( is_conf_modal ){
              var bytes = calc_bytes($('#confirm-message').val() + $('#confirm-subject').text());
              if(bytes > 1048576){
                  $('#warn-length-over').attr('class', 'ml-auto visible');
                  $('#MailConfirmationSubmit').prop('disabled', true);
              }else{
                  $('#warn-length-over').attr('class', 'ml-auto invisible');
                  $('#MailConfirmationSubmit').prop('disabled', false);
              }
              $('#MailConfirmation').modal('show');
              $('#conf-btn-loading-mark').remove();
          }else{
              check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
              $('#keyword_loading').remove();
          }
          /*if(message === replaced_message && subject === replaced_subject){
              return 'nochange';
          }else{
              return {'subject': subject, 'message': message};
          }*/
      });
  }
  
  function revert_changekeywords_btn() {
      $('#change-keywords').text('キーワードを変換')
                           .attr('class', 'btn btn-light btn-sm text-nowrap')
                           .data('replace', 'replace')
                           .css('color', 'black');
  }
  function change_changekeywords_btn(){
       $('#change-keywords').text('キーワードに戻す')
                            .attr('class', 'btn btn-secondary btn-sm text-nowrap')
                            .data('replace', 'revert')
                            .css('color', 'white');
  }
  var before_replaced;
  $('#LoadingTarget').on('click', function(){
      if($('.action-close-dropdown').is(':visible')){
          $('#keywords-list').dropdown('toggle');
      }
      //if($('#limit-data-num').val() >= 500 && $('#change-keywords').data('replace') === 'replace'){
      if( $('#change-keywords').data('replace') === 'replace' ){ 
          var target_offset = $('#LoadingTarget').offset();
          var target_top = target_offset.top;
          var target_left = target_offset.left;
          var keyword_loading = $('<div>').attr('id', 'keyword_loading');
          var hidden_loading = $('<div>').attr({
                                             'id': 'hidden_loading',
                                             'class': '_loading mx-auto',
                                             'style': 'display:none;height:20;'
                                         });
          keyword_loading.append(hidden_loading);
          $(this).append(keyword_loading);
          $('#keyword_loading').offset({
             top: target_top -15,
             left: target_left
          });
          $('#hidden_loading').show(adjust_btn_status);
      }else{
          adjust_btn_status();
      }
  });
  function adjust_btn_status(){
      var btn =  $('#change-keywords');
      if(btn.data('replace') === 'replace'){
          replace_mail_keywords('#modalSendmailBodyTitle', '#modalSendmailBodyText');
      }else{
          before_replaced = JSON.parse($('#before_replaced').val());
          revert_changekeywords_btn();
          $('#modalSendmailBodyTitle').val(before_replaced['subject']);
          $('#modalSendmailBodyText').val(before_replaced['message']);
          check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
          $('#keyword_loading').remove();
      }

          /*if(before_replaced != 'nochange'){
              change_changekeywords_btn();
          }else{
              btn.tooltip('show');
              setTimeout(function(){
                  btn.tooltip('hide');
              }, 1000);
          }
      }else{
          if(before_replaced != null){
              revert_changekeywords_btn();
              $('#modalSendmailBodyTitle').val(before_replaced['subject']);
              $('#modalSendmailBodyText').val(before_replaced['message']);
          }
      }
      check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
      $('#keyword_loading').remove();*/
  }
  $(document).on('click', '#MailConfirmationSubmit', function(){
      $('#modalSendmailBodyTitle').val($('#confirm-subject').text());
      $('#modalSendmailBodyText').val($('#confirm-message').val());
      $('#MailConfirmation').modal('hide');
      $('#modalSendMail').modal('hide');
      $('#form_sendmails').submit();
  });
  var selected_textarea = $('#modalSendmailBodyText');
  $('#modalSendmailBodyTitle, #modalSendmailBodyText').on('click', function (){
      selected_textarea = $(this);
  });
  $('.put-keyword').on('click', function (){
      var textarea = selected_textarea;
      var pos = textarea.get(0).selectionStart;
      var len = textarea.val().length;
      var content =  textarea.val();
      var before = content.substr(0, pos);
      var keyword = $(this).val();
      var after = content.substr(pos);
      content = before + keyword + after;
      textarea.val(content);
      revert_changekeywords_btn();
      var sum_mail_letters = $('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val();
      check_mail_length(sum_mail_letters);
      if($('#recipients').val() != '{}' && $('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
          $('#modalSendmailExecute').prop('disabled', false);
      }else{
          $('#modalSendmailExecute').prop('disabled', true);
      }
      $('#keywords-list-menu').hide();
  });
  $('#reset-mailmodal').on('click', function(){
      $('#AllUsersSelect').prop('checked', false);
      $('.user-chk-box').prop('checked', false);
      $('#recipients').val(JSON.stringify({}));
      $('#users_sidinfo').val(JSON.stringify([])); 
      $('#modalSendmailBodyTitle').val('');
      $('#modalSendmailBodyText').val('');
      check_mail_length('');
      revert_changekeywords_btn();
      $(this).tooltip('hide');
      $('#limit-keywords-data').text('20件');
      $('#limit-data-num').val(20);
      $('#modalSendmailExecute').prop('disabled', true);
      $('.dropdown-menu.show:last').closest('.action-close-dropdown').find('.dropdown-toggle').click();
  });

  $('#limit-keywords-data-tooltip').on('show.bs.dropdown', function(){
      $(this).tooltip('disable');
  });
  $('#limit-keywords-data-tooltip').on('hide.bs.dropdown', function(){
      $(this).tooltip('enable');
  });
  $('#limit-data-num option').on('click', function(){
      $('#limit-keywords-data').text($(this).val() + '件');
  });

  $('#keywords-list').on('click', function(e) {
      var check_letters = $('#modalSendmailBodyTitle').val() + $('#modalSendmailBodyText').val();
      check_presence_keyword(check_letters);
      //dropdownがうまく動作しないため、実装
      var menu = $('#keywords-list-menu');
      if( menu.is(':visible') ){
          menu.hide();
      }else{
          menu.show();
      }
      var menu_offset = menu.offset();
      if( menu_offset.top + menu.outerHeight() > $(this).offset().top ){
          menu.css('transform', 'translate3d(15px, -' + (menu.outerHeight() + 1) + 'px, 0px)');
      }
      menu.css('left', 'auto !important'); 
      e.stopPropagation();
  });


  //dropdownがうまく動作しないため、実装
  $('#LoadingTarget, #limit-keywords-data, #reset-mailmodal, #modalSendMail').on('click', function(){
      $('#keywords-list-menu').hide();
  });

  $('#modalSendMail *').not('#modalSendMailOptsArea *').on('click', function(e){
      $('#keywords-list-menu').hide();
  });

  var buttons_as_disabled = $('.list-tooltip-as-disabled');
  function check_presence_keyword(letters) {
      $.each(buttons_as_disabled, function(){
          var tooltip_selector = $(this);
          var target_selector = tooltip_selector.find('button');
          var class_name = target_selector.attr('class');
          if(letters.indexOf(target_selector.val()) != -1){
              class_name = class_name.replace(/btn-outline-dark2/, 'btn-outline-secondary');
              target_selector.prop('disabled', true).attr({
                  'class': class_name,
                   'style': 'pointer-events:none;border-color:#a8b7c5;'
              });
              tooltip_selector.tooltip('enable');
          }else{
              class_name = class_name.replace(/btn-outline-secondary/, 'btn-outline-dark2');
              target_selector.prop('disabled', false).attr('class', class_name).removeAttr('style');
              tooltip_selector.tooltip('disable');
          }
      });
  }
  function check_mail_length(letters){
      var count_bytes = calc_bytes(letters);
      count_bytes > 1 ? $('#show-byte').text('bytes') : $('#show-byte').text('byte');
      $('#count-letters').text(count_bytes.toLocaleString());
      if(count_bytes > 1048576){
          $('#mail-length-over').attr('class', 'visible');
      }else{
          $('#mail-length-over').attr('class', 'invisible');
      }
  }
  function calc_bytes(letters){
      var bytes = encodeURIComponent(letters).replace(/%../g,"x").length;
      return bytes;
  }
  
  if (JSON.parse($('#pages_checked').val()).length > 0){
      $('.bulkbtns').removeClass('disabled');
      $('.bulkbtns').prop('disabled', false);
  }
  
  //クリップボード
  const clipboard = new ClipboardJS('.copybtn', {
                    text: function(e){
                        if((e.id).indexOf('copy-host-history') != -1){
                            var t = '';
                            $('#JournalArea').find('.copy-target-history').find('.copy-target-date, .copy-target-user-mail, .copy-target-user-name, .copy-target-content, .copy-target-comment').each( function( index, elm) {
                                if($(this).attr('class').indexOf('copy-target-content') != -1){
                                    var content = $(this);
                                    if( content.find('.copy-target-badge').length != 0){
                                        t += content.find('.copy-target-badge').text() + ' ';
                                    }
                                    if(content.find('.copy-target-text').length != 0){
                                        t += content.find('.copy-target-text').text() + '\n';
                                    }
                                }else{    
                                    t += $.trim(elm.textContent).concat('\n');
                                    if(elm.className === 'copy-target-comment'){
                                        t += '\n';
                                    }
                                }
                            });
                            return t;
                        }else if((e.className).indexOf('copy-pkg-list') != -1){
                            var t = '';
                            $(e).parent().siblings('.copy-target-pkg-list').find('li').each( function(index, elm) {
                               t += (elm.textContent).concat('\n');
                            });
                            return t;
                        }else if((e.className).indexOf('copy-prd-list') != -1){
                            var t = '';
                            $(e).parent().siblings('.copy-target-prd-list').find('li').each( function(index, elm) {
                               t += (elm.textContent).concat('\n');
                            });
                            return t;
                        }else if( (e.className).match(/copy-cveids-list/) ){
                            var t = '';
                            $('.summary-cveids-list .summary-cveid').each(function(){
                                t += $(this).text() + '\n';
                            });
                            return t;
                        } 
                    }
               });
    
  const clipboard_supported = ClipboardJS.isSupported();
  
  //クリップボードがサポートされていなければアラートを表示 
  $(document).on('click', '.copybtn', function(e){
    e.stopPropagation();
    $('#tooltip-copy-btn').tooltip('hide');
    if(clipboard_supported === false) {
        alert('このブラウザではコピー機能はサポートされておりません');
        return false;
    }
  });

  clipboard.on('success', function(e){ 
     if((e.trigger.id).indexOf('copy-host-history') != -1){
        var obj = $(e.trigger);
     }else if (e.trigger.id === 'copy-detection-pkg-list'){
         var obj = $('#tooltip-target');
     }else if (e.trigger.id === 'copy-detection-app-list'){
         var obj = $('#app-tooltip-target');
     }else if((e.trigger.className).indexOf('copy-pkg-list') != -1 || (e.trigger.className).indexOf('copy-prd-list') != -1){
         //var obj = $(e.trigger).closest('.detail-info-tooltip-target');
         var obj = $(e.trigger);
     }else if((e.trigger.className).match(/copy-cveids-list/)){
         var obj = $(e.trigger);
     }
     obj.tooltip('show');
     setTimeout(function (){
         obj.tooltip('hide');
         e.clearSelection();
     }, 1000);       
  });
  clipboard.on('error', function(e) {
        alert('コピーに失敗しました');
        e.clearSelection();
  });
  
  /*$(document).on('click', '#close-detection-pkg-list', function(e){
      $(e.target).closest('.popover').popover('hide');
  });*/
  //import画面のメモ・手動登録プロダクト・パッケージ・検出アプリのballoonを開く時に、初めからcssを入れると、一番最初に>表示する時だけ表示位置がずれるため、表示後にcssをいれる  
  //原因は不明だが、これで解消される。
  $('.balloon-dropdown').on('shown.bs.dropdown', function(){
        setTimeout(function(){ $('.balloon-memo:visible, .balloon-host-item:visible').css({'white-space': 'normal', 'word-break': 'break-all'}) }, 10);
    });
  
  //履歴表示
  var j_user_id;
  var j_html_id;
  var j_host_id;
  var elm_num = 0;
  $('.action-open-history').on('click', function(){
      $('[data-toggle="popover"]').popover('hide');
      build_JournalArea($(this));
  });
  function build_JournalArea(elm){
      if($('#target-JournalArea').length > 0){
          $('#JournalArea').unwrap();
      }
      var roles = JSON.stringify($('#user_roles').val());
      if(!roles.includes('admin') && !roles.includes('use')){
          $('#execute-submit-comment').prop('disabled', true);
      }else {
          $('#execute-submit-comment').prop('disabled', false);
      }
      var button = elm;
      var title = button.data('journaltitle');
      $('#Journal-title-name').text(title);
      $('#journal-comment').val('');
      elm_num = 0;
      $('#modal-JournalArea').remove();
      $('#show-no-journal').tooltip('dispose');
      $('#show-no-journal').remove();
      reset_narrow_dropdown();
      $('#narrowed-keyword').val('');
      $('#narrow-by-keyword').val('');
      $('#JournalArea').hide();
      adjust_JournalArea_footer();
      $('body').css('overflow-x', 'hidden');
      var userid = button.data('userid');
      var html_id = button.data('htmlid');
      var path = $('#get_journals_path').val();
      var host_id = $('#host_id').val();
      j_user_id = userid;
      j_html_id = html_id;
      j_host_id = host_id;
      $('#JournalArea-body > *').remove();
      var JournalArea_body = $('#JournalArea-body'); 
      var JournalArea = $('#JournalArea');
      var window_height = $(window).height();
      var window_width = $(window).width();
      JournalArea.width(window_width * 0.7);
      JournalArea_body.height(window_height / 1.8);
//   JournalArea.height(JournalArea_body.height() + 60);
      var target_JournalArea = $('<div>').attr('id', 'target-JournalArea');
      $('body').append(target_JournalArea);
      var offset_top = $(window).scrollTop() + (window_height / 6);
      var offset_left = (window_width - JournalArea.width()) / 2;
      target_JournalArea.offset({top: offset_top, left: offset_left});
      target_JournalArea.height(JournalArea.height());
      target_JournalArea.width(JournalArea.width());
      target_JournalArea.append(JournalArea);
      $('#Journal-title-name').width(JournalArea.width() * 0.7);
      var modal_window = $('<div>').attr('id', 'modal-JournalArea');
      $('body').append(modal_window);
      JournalArea.show();
      $('body').css('overflow-y','hidden');
      $('#JournalArea-menu').dropdown();
      $('#floating-scroll').css('z-index', '10');
      $('#wrap-ActionArea').css('z-index', '500');
      $.post(path, {'html_id':html_id, 'host_id':host_id})
          .done(function(d){
              $('#wrap-ActionArea').css('z-index', '500');
              var data = d;
              data.sort(function(a,b) {
                  return (a[3] > b[3] ? 1 : -1);
              });
              if(data.length > 0){
                  var target_j_num_elm = $('#journal-amount-html'+ html_id);
                  target_j_num_elm.attr('data-journalnum', data.length).text(data.length);
                  $.each(data, function(){
                      var deleted_comment = $('#history-deleted-comment').val();
                      var journal_user_id = this[1];
                      var note = this[2];
                      var journal_date = this[3];
                      var journal_user_mail = this[4][0];
                      var is_anonymous_user = journal_user_mail.length === 0;
                      var journal_user_name = this[4][1] + (is_anonymous_user ? '' : ' ') + this[4][2];
                      var journal_details = this[5];
                      var copy_target_history = $('<div>').attr({
                                                          'class': (userid === journal_user_id) ? 
                                                              'ml-auto mr-1 j-right pos-right' 
                                                            : 'mr-auto ml-1 j-left pos-left'
                                                           })
                                                           .addClass('copy-target-history');
                      var journal = $('<div>');
                      journal.attr({
                              'class': 'journal card g-font-size-0_89x',
                              'data-elmnum': elm_num
                             });
                      elm_num += 1;
                      var journal_header = $('<div>').attr('class', 'card-header journal-header');
                      var created_date = $('<div>').attr('class', 'float-right')
                      var copy_target_date = $('<span>').attr('class', 'copy-target-date').text(journal_date);
                      created_date.append(copy_target_date);
                      journal_header.append(created_date);
                      var user_mail = $('<div>').attr('class', (is_anonymous_user ? 'd-inline' : ''));
                      var copy_target_user_mail = $('<span>').attr('class', 'copy-target-user-mail');
                      var user_mail_text = is_anonymous_user ? '' : '( ' + journal_user_mail + ' )';
                      copy_target_user_mail.text(user_mail_text);
                      user_mail.append(copy_target_user_mail);
                      var user_name = $('<div>').attr('class', 'd-block');
                      var copy_target_user_name = $('<div>').attr('class', 'copy-target-user-name');
                      var user_name_text = journal_user_name;
                      copy_target_user_name.text(user_name_text);
                      user_name.append(copy_target_user_name);
                      journal_header.append(user_name);
                      journal_header.append(user_mail);
                      journal.append(journal_header);
                      var journal_body = $('<div>').attr('class', 'card-body g-bg-gray-v8 g-brd-around g-brd-e6e6');
                      var copy_target_content = $('<div>').attr('class', 'copy-target-content');
                      var is_comment_only = journal_details.length === 0 ? 'true' : 'false';

	              if(is_comment_only != 'true'){     
                          $.each(journal_details, function(){
                                var detail_label = this[0];
			        var detail_p = $('<div>').attr('class', 'mb-0');
			        if(detail_label === 'status'){
			            var old_val = this[1];
			            var new_val = this[2];
			            var st = $('<span>').attr('class', 'copy-target-badge badge badge-success g-font-size-0_83x');
			            st.text('ステータス変更');
                                    detail_p.append(st);
			            var content = $('<span>').attr('class', 'copy-target-text d-inline-block ml-2');
			            content.text('[' + old_val + '] から [' +  new_val + '] へ');
			            detail_p.append(content);
			        }else if(detail_label === 'due_date'){
			            var old_date = this[1];
			            var new_date = this[2];
			            var ch = $('<span>').attr('class', 'copy-target-badge badge badge-warning g-font-size-0_83x');
			            ch.text('対策予定日の変更');
			            detail_p.append(ch);
			            var content = $('<span>').attr('class', 'copy-target-text copy-target d-inline-block ml-2');
			            content.text(old_date + ' から ' +  new_date + ' へ');
			            detail_p.append(content);
			        }else{
			            var other = $('<span>').attr('class', 'copy-target-text d-inline-block ml-2').text('その他変更');
			            detail_p.append(other);
			        }
			        copy_target_content.append(detail_p);
		          });
		      }

                      journal_body.append(copy_target_content);
                      if(is_comment_only != 'true'){
                          journal_body.append($('<hr>').attr('class', 'my-1 g-brd-style-dotted'));
                      }
                      var comment_p = $('<p>').attr('class', 'card-text p-1 g-bg-white');
                      var copy_target_comment = $('<span>').attr('class', 'copy-target-comment' + (deleted_comment === note ? ' slanted-font' : ''));
                      var comment_text = note;
                      copy_target_comment.text(comment_text);
                      if(userid === journal_user_id){
                          journal_header.addClass('self-j-header');
                          journal_body.addClass('self-j-body');
                      }
                      comment_p.append(copy_target_comment);
                      journal_body.append(comment_p);
                      journal.append(journal_body);
                      copy_target_history.append(journal);
                      copy_target_history.width(JournalArea_body.width() / 1.8);
                      JournalArea_body.append(copy_target_history);
                  });
              }else{
                  var show_no_journal = $('<div>').attr({
                                                   'data-toggle':'tooltip',
                                                   'data-original-title':'現在履歴はありません',
                                                   'data-placement':'top',
                                                   'data-tirgger':'manual',
                                                   'id': 'show-no-journal'
                                                   });
                  $('body').append(show_no_journal);
                  show_no_journal.offset({'top': ($(window).scrollTop() + (window_height / 2)), 'left': ($(window).width / 2)});
                  $('#show-no-journal').tooltip('show');
                  setTimeout(function(){
                     $('#show-no-journal').tooltip('dispose');
                     $('#show-no-journal').remove();
                  },3000);
              }
              $('#JournalArea-body').get(0).scrollTop = $('#JournalArea-body').get(0).scrollHeight;
          }).fail(function(){
               $(this).attr({
                      'data-toggle': 'tooltip',
                      'data-placement': 'top',
                      'data-original-title': 'サーバーエラーが発生しました'
                       })
                       .tooltip('show');
          });
  }
 
  $('#close-journal').on('click', function(){
      $('#JournalArea').unwrap();
      $('#JournalArea').hide();
      $('#JournalArea-body > *').remove();
      $('body').css('overflow-x', 'auto');
      $('#show-no-journal').tooltip('dispose');
      $('#show-no-journal').remove();
      $('#modal-JournalArea').remove();
      $('body').css('overflow-y','auto');
      $('#JournalArea').find('[data-toggle="tooltip"]').tooltip('hide');
      $('#floating-scroll').css('z-index', '1060');
      $('#wrap-ActionArea').css('z-index', '1045');
  });
  
  function adjust_JournalArea_footer() {
      var footer_area = $('#JournalArea-footer');
      var comment_area = $('#wrap-journal-comment');
      if(comment_area.data('expanded')){
          footer_area.offset({top: comment_area.offset().top + 56});
          footer_area.height('30');
          comment_area.data('expanded', false);
      }
  }       
 
  $('#execute-submit-comment').on('click', function(){
      if( j_user_id != null && j_html_id != null && j_host_id != null){
          var comment = $('#journal-comment').val();
          var user_id = j_user_id;
          var html_id = j_html_id;
          var host_id = j_host_id;
          var path = $('#post_journal_comment_path').val();
      }
      if(comment === '' || comment.trim() === ''){
          $.cookie('journal_posted', 'fail');
          return false;
      }
      $.post(path, 
          {
           'html_id':html_id, 
           'comment':comment, 
           'user_id':user_id,
           'host_id':host_id
      }).done(function(data){ 
          if(data === null){
              $.cookie('journal_posted', 'fail');
              $('#execute-submit-comment').tooltip('show');
          }else{
              var journal_date = data[0];
              var note = data[1];
              var journal_user_mail = data[2][0];
              var journal_user_name = data[2][1] + ' ' + data[2][2];
              var last_journal_elmnum = $('#JournalArea-body').find('.journal:last').data('elmnum');
              var copy_target_history = $('<div>').attr('class', 'ml-auto mr-1 j-right pos-right copy-target-history');
              var journal = $('<div>');
              journal.attr({
                     'class': 'journal card g-font-size-0_89x',
                     'data-elmnum': (last_journal_elmnum + 1)
                     });
              var journal_header = $('<div>').attr('class', 'card-header journal-header');
              var created_date = $('<span>').attr('class', 'float-right')
              var copy_target_date = $('<span>').attr('class', 'copy-target-date').text(journal_date);
              created_date.append(copy_target_date);
              journal_header.append(created_date);
              var user_mail = $('<span>').attr('class', 'd-block');
              var copy_target_user_mail = $('<span>').attr('class', 'copy-target-user-mail');
              var user_mail_text = '(' + journal_user_mail + ')';
              copy_target_user_mail.text(user_mail_text);
              user_mail.append(copy_target_user_mail);
              var user_name = $('<div>').attr('class', 'd-block');
              var copy_target_user_name = $('<div>').attr('class', 'copy-target-user-name');
              var user_name_text = journal_user_name;
              copy_target_user_name.text(user_name_text);
              user_name.append(copy_target_user_name);
              journal_header.append(user_name);
              journal_header.append(user_mail);
              journal.append(journal_header);
              var journal_body = $('<div>').attr('class', 'card-body g-bg-gray-v8 g-brd-around g-brd-eee');
              var copy_target_content = $('<div>').attr('class', 'copy-target-content');
              var comment_p = $('<p>').attr('class', 'card-text p-1 g-bg-white');
              var copy_target_comment = $('<span>').attr('class', 'copy-target-comment');
              var comment_text = note;
              copy_target_comment.text(comment_text);
              journal_header.addClass('self-j-header');
              journal_body.addClass('self-j-body');
              comment_p.append(copy_target_comment);
              journal_body.append(comment_p);
              journal.append(journal_body);
              if($('#JournalArea-body').find('.copy-target-history').length > 0){
                  copy_target_history.width($('#JournalArea-body').find('.copy-target-history:first').outerWidth());
              }else{
                  copy_target_history.width($('#JournalArea-body').width() / 2.5);
              }
              copy_target_history.append(journal);
              $('#JournalArea-body').append(copy_target_history);
              $('#JournalArea-body').get(0).scrollTop = $('#JournalArea-body').get(0).scrollHeight;
              $('#journal-comment').val('');  
              //表示されている履歴数を+1する
              var target_j_num_elm = $('#journal-amount-html'+ html_id);
              var j_num = parseInt(target_j_num_elm.attr('data-journalnum'));
              var new_j_num = j_num + 1;
              target_j_num_elm.attr('data-journalnum', new_j_num).text(new_j_num);
              //cookieを使用して、sidfm_headerと連携して履歴を更新
              $.cookie('journal_posted', 'success');
          }
      }).fail(function(){
          $.cookie('journal_posted', 'fail');
          $('#execute-submit-comment').tooltip('show');
      });
  });
  
  function html_escape(text){
      return text.replace(/[<>&"'`]/g, function(letter){
           const escaper = {
               '<': '&lt;',
               '>': '&gt;',
               '"': '&quot;',
               "'": '&#39;',
               '`': '&#x60;',
               '&': '&amp;'
           };
           return escaper[letter];
      });
  }
  var hit_j_nums = [];
  var num_select_elm = 0;
  const escapes = ['&lt;', '&gt;', '&quot;', '&#39;', '&#x60;', '&amp;'];
  $('#execute-narrow').on('click', function(){
      hit_j_nums = [];
      num_select_elm = 0;
      var searched_word = $('#narrow-by-keyword').val();
      if(searched_word.length === 0){
          $(this).attr({
                  'data-original-title': '文字を入力して下さい'
                 }).tooltip('show');
          setTimeout(function(){
              $('#execute-narrow').tooltip('hide');
          },1500);
          return false;
      }
      if(searched_word.match(/^[ 　\r\n\t]*$/)){  
          var searched_words = [searched_word];
      }else{
          var index_of_space = searched_word.indexOf(' ');
          var num_of_space = searched_word.match(/' '/g);
          num_of_space = (num_of_space === null ? 0 : num_of_space.length);
          if(index_of_space === -1 || (index_of_space === 0 && num_of_space === 1)){
              var searched_words =  [searched_word];
          }else{
              if(searched_word[0] === ' '){
                  var temp_searched = searched_word.slice(1);
                  var searched_words = temp_searched.split(' ');
                  searched_words = searched_words.map(x => x.trim());
                  searched_words[0] = ' ' + searched_words[0];
              }else{
                  var searched_words = searched_word.split(' ');
                  searched_words = searched_words.map(x => x.trim());
              }
              searched_words = Array.from(new Set(searched_words));
              searched_words = searched_words.filter(function(a){
                  return a.length > 0;
              });  
          } 
      }
      var is_hit = 0;
      var prev_num = -1;
      $('#JournalArea-body').find('.journal')
                            .find('.copy-target-date, .copy-target-user-mail, .copy-target-user-name, .copy-target-comment, .copy-target-content span') 
                            .each(function(){
                                    var elm = $(this);
                                    var elm_text = html_escape(elm.text());                             
                                    var indexes = [];
                                    var escapes_indexes = [];
                                    for(var i = 0; i < escapes.length; i++){
                                        var e = escapes[i];
                                        var hit_e_index = 0;
                                        for(var j = 0; j < elm_text.length; j++){
                                            var e_idx = elm_text.indexOf(e, hit_e_index);
                                            if(e_idx >= 0){
                                                 escapes_indexes.push([e_idx, (e_idx + e.length)]);
                                                 hit_e_index = e_idx + 1;
                                            }else{ 
                                                 break;
                                            }
                                        }
                                    }
                                    searched_words.forEach(function(w){
                                        var word = html_escape(w);
                                        var index = elm_text.indexOf(word);
                                        if(index != -1 && searched_word != ''){
                                             is_hit = 1;
                                             var hit_index = 0;
                                             for(var i = 0; i < elm_text.length; i++){
                                                 var word_idx = elm_text.indexOf(word, hit_index);
                                                 var hit_flag = 0;
                                                 for(var j = 0; j < escapes_indexes.length; j++){
                                                     var e_idx = escapes_indexes[j][0];
                                                     var e_idx_plus_length = escapes_indexes[j][1];
                                                     if(word_idx > e_idx && word_idx < e_idx_plus_length){
                                                         hit_index = word_idx + 1;
                                                         hit_flag = 1;
                                                         break;
                                                     }
                                                 }
                                                 if(hit_flag === 0){
                                                     if(word_idx >= 0 ){
                                                         indexes.push([word_idx,word.length]);
                                                         hit_index = word_idx + word.length;
                                                      }
                                                 }
                                             }
                                        }
                                    });
                                    var indexes_length = indexes.length;
                                    if(indexes_length > 1){
                                        for(var i = 0; i < indexes.length; i++){
                                            var idx = indexes[i][0];
                                            var last_idx = idx + indexes[i][1];
                                            for(var j = 0; j < indexes.length; j++){
                                                var comp_idx = indexes[j][0];
                                                var comp_last_idx = comp_idx +indexes[j][1];
                                                if( !(idx === comp_idx && last_idx === comp_last_idx)){
                                                    if(comp_idx === idx){ 
                                                        if(last_idx > comp_last_idx){
                                                            indexes.splice([j], 1);
                                                            j--;
                                                        }else{
                                                            indexes.splice([i], 1);
                                                            i--;
                                                        }
                                                    }else if(last_idx === comp_last_idx){
                                                        if(idx < comp_idx){
                                                            indexes.splice([j], 1);
                                                            j--;
                                                        }else{
                                                            indexes.splice([i], 1);
                                                            i--;
                                                        }
                                                    }
                                                }
                                            } 
                                        } 
                                        var insert_indexes = [];
                                        indexes = indexes.sort(function(a,b){return(a[0] - b[0]);});
                                        for(var i = 0; i < indexes.length; i++){
                                            var idx = indexes[i][0];
                                            var last_idx = idx + indexes[i][1];
                                            if(insert_indexes.length === 0){
                                                insert_indexes.push([idx, last_idx]);
                                            }else{        
                                                var i_idx = insert_indexes[insert_indexes.length - 1][0];
                                                var last_i_idx = insert_indexes[insert_indexes.length - 1][1];
                                                if(idx <= last_i_idx && last_idx > last_i_idx){
                                                    insert_indexes[insert_indexes.length - 1] = [i_idx, last_idx];
                                                }else if(idx > last_i_idx){
                                                    insert_indexes.push([idx, last_idx]);
                                                } 
                                            }
                                        }            
                                        var insert_highlight = elm_text;
                                        var count_letters = 0;
                                        var insert_span_length = '<span class="highlight"></span>'.length;
                                     
                                        for(var i = 0; i < insert_indexes.length ; i++){
                                            var target_index = insert_indexes[i][0];
                                            var target_end = insert_indexes[i][1];
                                            var target_word = elm_text.slice(target_index, target_end);
                                            var insert_span = '<span class="highlight">' + target_word + '</span>';
                                            insert_highlight = insert_highlight.slice(0, (target_index + count_letters)) + insert_span + insert_highlight.slice(target_index + count_letters + target_word.length);
                                            count_letters += insert_span_length;
                                        }
                                    }else if(indexes_length === 1){
                                        var target_index = indexes[0][0];
                                        var target_end = indexes[0][1] + target_index;
                                        var target_word = elm_text.slice(target_index, target_end);
                                        var insert_span = '<span class="highlight">' + target_word + '</span>';
                                        var insert_highlight = elm_text.slice(0, target_index) + insert_span + elm_text.slice(target_index + target_word.length);
                                    }
                                    if(indexes_length > 0){
                                        elm.html(insert_highlight);
                                        var num = elm.closest('.journal').data('elmnum');
                                        if(prev_num != num){
                                             hit_j_nums.push(num);
                                             prev_num = num;
                                        }
                                    }
                               
                            });
                                            
      if(is_hit === 1){
          $('.highlight').css('background-color', 'yellow');
          $('#JournalArea-menu').parent().dropdown('hide');
          $('#journal-keyword-btn').hide();
          $('#journal-users-list-btn').hide();
          $('#narrowed-item-keyword').css('display', '');
          $('#narrowed-keyword').val($('#narrow-by-keyword').val());
          $('#JournalArea-menu').parent().dropdown('show');
          hit_j_nums.sort(function(a,b){
               if(a < b){return 1};
               if( a > b){return -1};
               return 0;
          });
          $('#label-narrowed-keyoword').text('検索結果 : ' +  hit_j_nums.length + ' 件');
          var target_elm_num = hit_j_nums[num_select_elm];
          var target_elm = $('[data-elmnum=' + target_elm_num + ']');
          var target_pos = target_elm.position();
          var present_scrollTop = $('#JournalArea-body').scrollTop();
          var pos = target_pos.top +  present_scrollTop - ($('#JournalArea-body').height() - target_elm.height() - 3);
          $('#JournalArea-body').get(0).scrollTop = pos;
          target_elm.find('.highlight').css('background-color', 'red');
          var place = $('#dropdown-menu-JournalArea').outerWidth() - $('#JournalArea-menu').outerWidth();
          $('#dropdown-menu-JournalArea').offset({'left': $('#JournalArea-menu').offset().left - place});
      }else{
          $(this).attr('data-original-title', '該当するデータはありません');
          $(this).tooltip('show');
          setTimeout(function(){
              $('#execute-narrow').tooltip('hide')
          },1000);
      }
  });
  

  $('#narrow-next').on('click', function(){
      if(num_select_elm < hit_j_nums.length){
          if(num_select_elm !=  hit_j_nums.length -1){
              num_select_elm += 1;
          }
          var prev_target_elm_num = hit_j_nums[num_select_elm - 1];
          $('[data-elmnum=' + prev_target_elm_num + ']').find('.highlight').css('background-color', 'yellow');
          var target_elm_num = hit_j_nums[num_select_elm];
          var target_elm = $('[data-elmnum=' + target_elm_num + ']');
          var target_pos = target_elm.position();
          var present_scrollTop = $('#JournalArea-body').scrollTop();
          var pos = target_pos.top +  present_scrollTop - ($('#JournalArea-body').height() - target_elm.height() - 3);
          $('#JournalArea-body').animate({scrollTop:pos}, 250);
          target_elm.find('.highlight').css('background-color', 'red');
      }
  });

  $('#narrow-before').on('click', function(){
      if(num_select_elm >= 0){
          if(num_select_elm != 0){
              num_select_elm -= 1;
          }
          var prev_target_elm_num = hit_j_nums[num_select_elm + 1];
          $('[data-elmnum=' + prev_target_elm_num + ']').find('.highlight').css('background-color', 'yellow');
          var target_elm_num = hit_j_nums[num_select_elm];
          var target_elm = $('[data-elmnum=' + target_elm_num + ']');
          var target_pos = target_elm.position();
          var present_scrollTop = $('#JournalArea-body').scrollTop();
          var pos = target_pos.top + present_scrollTop - ($('#JournalArea-body').height() - target_elm.height() - 3);
          $('#JournalArea-body').animate({scrollTop:pos}, 250);
          target_elm.find('.highlight').css('background-color', 'red'); 
      }
  });
 
  $('.close-narrow').on('click', function(){
      $('.highlight').css('background-color', '');
      $('.highlight').removeClass();
      reset_narrow_dropdown();
  });
 
  $('#narrow-menu-item-keyword').on('click', function(e){
      e.stopPropagation();
  });

  $('#JournalArea-users-btn').on('click', function(e){
      $('#journal-users-list-btn, #journal-keyword-btn, #narrowed-item-keyword').hide();
      $('#journal-users-list').addClass('users-list-show').show();
      var users = [];
      $('#JournalArea-body').find('.copy-target-user-name').each(function(){
          var user_name = $(this).text().slice(0);
          users.push(user_name);
      });
      if(users.length === 0){
          var display_no_user = $('<div>').attr('class', 'text-nowrap m-1 g-font-size-0_89x').text('ユーザは存在しません');
          $('#journal-users-list-body').append(display_no_user);
      }else{
          users = Array.from(new Set(users));
          users.sort(function(a,b){
              if(a < b){return -1;}
              if(a > b){return 1;}
              return 0;
          });
          var list_body = $('#journal-users-list-body');
          var wrap_users = $('<div>').attr('id', 'wrap-users')
                                     .css({
                                         'max-height': ($('#JournalArea-body').outerHeight(true) / 2),
                                         'overflow-y': 'auto',
                                         'max-width': '180px'
                                         });
          list_body.append(wrap_users);
          for(var i = 0; i < users.length; i++){
              var user = users[i];
              var btn_user = $('<a>').attr({
                                 'class': 'dropdown-toggle btn btn-xs text-nowrap journal-list-user-name w-100 text-left g-font-size-0_93x text-truncate',
                                 'data-toggle': 'dropdown', 
                                 'aria-haspopup': 'true',
                                 'aria-expanded': 'false',
                                 'title': user
                                 }).text(user);
              wrap_users.append(btn_user);
              var divider = $('<div>').attr('class', 'user-list-divider');
              if(i != (users.length - 1)){
                  divider.css({'border-top': '1px solid #999'});
              }
              wrap_users.append(divider);
              var d_menu = $('<div>').attr({'class': 'hidden-menu', 'style':'display:none;'});
              var d_item = $('<div>').attr('class', 'hidden-item');
              $('#JournalArea-body').find('.journal').each(function(){
                  var user_text = $(this).find('.copy-target-user-name').text().slice(0);
                  if(user === user_text){
                     var clone = $(this).clone(true);
                     d_item.append(clone);
                  }
              });
              var elm_journal = $('#JournalArea-body').find('.journal:first');
              d_menu.width(elm_journal.width() + 60);
              d_menu.css('max-height', elm_journal.height() * 2 + 20);
              d_menu.append(d_item);
              wrap_users.append(d_menu);
              d_menu.find('.journal').addClass('mb-1 text-left');
              d_menu.find('.copy-target-date, .copy-target-user-mail, .copy-target-user-name, p').addClass('text-wrap');
          }
          var place = $('#dropdown-menu-JournalArea').outerWidth(true) - $('#JournalArea-menu').outerWidth();
          $('#dropdown-menu-JournalArea').offset({'left': $('#JournalArea-menu').offset().left - place});
          $('.journal-list-user-name').on('click', function(){
              var d_menu = $(this).next('.user-list-divider').next('.hidden-menu');
              var all_d_menu = $(this).parent().find('.hidden-menu');
              $('.journal-list-user-name').css({'background': '', 'color':''});
              all_d_menu.hide();
              if(!d_menu.hasClass('displayed')){ 
                  $(this).css({'background':'#333', 'color':'#fff'});
                  d_menu.show();
                  d_menu.offset({'top':$(this).offset().top});
                  all_d_menu.removeClass('displayed');
                  d_menu.addClass('displayed');
              }else{
                  d_menu.removeClass('displayed');
              }
          });
      }
      e.stopPropagation();
  });
    
  $('#journal-users-list').on('click', function(e){
      e.stopPropagation();
  });
  $('#narrowed-item-keyword').on('click',function(e){
      e.stopPropagation();
  });


  $('#close-journal-users-list').on('click', function(){
      reset_narrow_dropdown();
  });

  
  //操作したtrに色を付ける
  $('.link-to-detail').on('click', function(e){
      e.preventDefault();
      var htmlid = $(this).data('htmlid');
      $.cookie('clicked_vul_id', htmlid);
      try_color_selcted_tr(htmlid, 'click', $(this).attr('href'));
  });

  $('.link-to-detail').bind('contextmenu', function(){
      var htmlid = $(this).data('htmlid');
      var htmlid = $(this).data('htmlid');
      try_color_selcted_tr(htmlid, 'right-click', 'no_change');
  });

  function try_color_selcted_tr(htmlid, trigger, url){
      var path = $('#store_selected_id_path').val();
      var hostid = $('#host_id').val();
      $.post(path, {'hostid_with_htmlid': JSON.stringify([hostid, htmlid]), 'page_name':'host'},
      function(){
          if(trigger === 'click'){
              window.location.href = url;
          }
          var get_htmlid = setInterval(function(){
                                color_selcted_tr(get_htmlid, htmlid);
                            }, 300);
           setTimeout(function(){
               clearInterval(get_htmlid)
           },15000);
      });
  }

  function color_selcted_tr(timer, htmlid){
      if(!htmlid){
           htmlid = $.cookie('clicked_vul_id');
      }
      var path = $('#store_selected_id_path').val();
      var hostid = $('#host_id').val();
      $.post(path, {'selected_id': hostid, 'page_name':'host'},
      function(htmlids){
         if(htmlids.length > 0){
             for(var id of htmlids){
                 if(id === String(htmlid)){
                     $('#host-table').find('.selected-tr-item')
                                     .removeClass('selected-tr-item');
                     if(timer != 'load'){
                         clearInterval(timer)
                     }
                     $('#host-table').find('#tr' + htmlid)
                                     .find('td')
                                     .addClass('selected-tr-item');
                     $.removeCookie('clicked_vul_id');
                     break;
                 }
             }
          }        
      });
  }

  //ロード時にtrに色を付ける
  color_selcted_tr('load');

  //サマリー表のチェックボックスとpages_checkedの整合性を取る
  $(window).on('pageshow', function(){
      var is_all_checked = $('#pages_all_checked').val();
      if(is_all_checked === 'true'){
          var all_ids = JSON.parse($('#all_html_ids').val());
          $('#SortTR').find('#allSelect, .vulSelect').prop('checked', true);
          $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
      }else{
          $('#SortTR').find('#allSelect, .vulSelect').prop('checked', false);
          var pages_checked = JSON.parse($('#pages_checked').val());
          var target_elm = '';
          pages_checked.forEach(function(id){
              target_elm += '#table_selected' + id + ',';
          });
          target_elm = target_elm.slice(0, -1);
          $(target_elm).prop('checked', true);
      }

  });

  //ブラウザバックによるロードだったらチェックボックスのチェックを修正する
  /*$.post($('#check_browser_back_path').val(), {'page_name': 'host'},
      function(info){
          if(info === 'browser_back'){
              var is_all_checked = $('#pages_all_checked').val();
              if(is_all_checked === 'true'){
                  var all_ids = JSON.parse($('#all_html_ids').val());
                  $('#Sort-TR').find('#allSelect, .vulSelect').prop('checked', true);
                  $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
              }else{
                  $('#SortTR').find('#allSelect, .vulSelect').prop('checked', false);
                  var pages_checked = JSON.parse($('#pages_checked').val());
                  var target_elm = '';
                  for (var id of pages_checked){
                      target_elm += '#table_selected' + id + ',';
                  }
                  target_elm = target_elm.slice(0, -1);
                  $(target_elm).prop('checked', true);
              }
          }
  });*/


  $(window).on('resize',function(){
      var JournalArea_body = $('#JournalArea-body');
      var JournalArea = $('#JournalArea');
      var targetArea = $('#target-JournalArea');
      var window_height = $(window).height();
      var window_width = $(window).width();
      var Area_width = window_width * 0.7
      targetArea.width(Area_width);
      JournalArea.width(window_width * 0.7);
      JournalArea_body.height(window_height / 1.8);
//    JournalArea.height(JournalArea_body.height() + 60);
      var offset_top = $(window).scrollTop() + (window_height / 6);
      var offset_left = (window_width - JournalArea.width()) / 2;
      targetArea.offset({top: offset_top, left: offset_left});
      targetArea.height(JournalArea.height());
      targetArea.width(JournalArea.width());
      var journal_width = JournalArea_body.width() / 1.8;
      $('.copy-target-history').width(journal_width)
      $('#Journal-title-name').outerWidth(JournalArea.width() * 0.6);
      var elm_journal = $('#JournalArea-body').find('.journal:first');
      var hidden_j_menu = JournalArea.find('.hidden-menu');
      hidden_j_menu.width(elm_journal.width() + 60);
  });
  function reset_narrow_dropdown(){
      $('#narrow-menu').css({
                        'background': '',
                        'border': ''
                        });
      $('#journal-users-list-btn, #journal-keyword-btn').css('display', '');
      $('#journal-users-list-body > *').remove();
      $('#narrowed-item-keyword, #journal-users-list').css('display', 'none');
      $('#narrowed-keyword, #narrow-by-keyword').val('');
//    $('#dropdown-menu-JournalArea').css('background','linear-gradient(silver, #444) fixed'); 
      setTimeout(function(){
          $('#narrow-journal').parent().dropdown('hide');
          $('#dropdown-menu-JournalArea').parent().dropdown('hide');
          $('#JournalArea-menu').parent().dropdown('hide');
      },1);
  }
  //担当者にメール送信画面で、ホスト名とカテゴリ名を表示した時にpopoverを表示する（bootstrapのpopoverだとバグになるので独自に実装
  $(document).on('click', '.show-original-popover', function(){
      var button = $(this);
      var id = button.attr('data-popoverid');
      var popover = $('.original-popover');
      var popover_id = popover.attr('data-popoverid');
      popover.remove();
      if(popover_id === id){
          return false;
      }
      var content = $('<div>').attr({
                              'class': 'original-popover',
                              'data-popoverid': id,
                              });
      var inner_content = $('<div>').attr('class', 'original-popover-inner');
      var text = button.attr('data-content');
      button.attr('data-html') ? inner_content.html(text) : inner_content.text(text);
      content.append(inner_content);
      var triangle_target = $('<div>').attr({
                                       'class': 'position-relative triangle',
                                       'data-popoverid': id,
                                      });
      content.append(triangle_target);
      content.css('opacity', 0);
      $('body').append(content);
      var btn_width = button.outerWidth(true);
      var content_width = content.outerWidth(true);
      var offset = button.offset();
      var offset_top = offset.top - content.outerHeight(true) - 5;
      var offset_left = offset.left + (btn_width / 2) - (content_width / 2);
      content.offset({
          'top': offset_top,
          'left': offset_left
      });
      content.css({
          'opacity': ''
      });
  });
  
  //担当者にメール送信を開いている時に画面クリックでpopover削除
  $('#modalSendMail').on('click', function(e){
      if(e.target){
          var t_elm = $(e.target);
          if(!t_elm.hasClass('show-original-popover') && t_elm.closest('.show-original-popover').length === 0 && !t_elm.hasClass('triangle')){
              $('.original-popover').remove();
          }
      }
  });

  //担当者にメール送信画面のスクロールでpopover削除
  $('.modal-mail-table').on('scroll', function(){
      $('.original-popover').remove();
  });

  //画面のリサイズでpopover削除 //modal内のtd調整
  $(window).on('resize', function(){
      $('.original-popover').remove();
      if( $('#modalEditStatus').is(':visible') ){
          $('.modalEditStatus-vul-td-inner').outerWidth($('#modalEditStatus-vul-th').outerWidth() - 1.5);
      }
      if($('#modalEditSchedule').is(':visible')){
          $('.modalEditSchedule-vul-td-inner').outerWidth($('#modalEditSchedule-vul-th').outerWidth() - 1.5);
      }
  });

  //JSON/TSV出力
  $('#exec-download').on('click', function(){
      json_tsv_summary_table_progress_download($('#download_select').val(), $('#read-download-data-path').val());
  });

});
