/* coding: utf-8 */
/* Copyright (C) 2018 SofTek Systems, Inc. */

/* ホスト管理画面の処理 */

// 選択されたアプリケーションを出力する。
var cnt_id_for_product_elm = 0;
function select_item_append(pid, name, vid, fullname, prefix = '', is_lproduct = '') {
    var selected_item = $('<a></a>', {
        class: 'btn btn-light-nb mb-1 mr-1' + (is_lproduct ? ' selected-lproduct' :  ''),
        href: '#',
        onclick: 'deselect_item(' + pid + ',' + vid + ",'" + prefix + "','" + is_lproduct + "')",
        text: fullname.length > 0 ? fullname : name,
        id: prefix + 'select_item_' + pid + '_' + vid + is_lproduct
    });
    var icon = $('<i></i>', { class: 'fas fa-minus-circle ml-1' });
    selected_item.append(icon);
    var id = prefix + pid + '_' + vid + is_lproduct;
    var same_id_elm = $('#' + prefix + 'selected_list').find('[data-editid="' + id + '"]');
    if(same_id_elm.length === 1){
        id += String(cnt_id_for_product_elm);
        cnt_id_for_product_elm += 1;
    }
    var wrap = $('<div></div>', {
        'data-editid': id,
        class: 'mr-1'
    });
    var btn = $('<div></div>', {
        class: 'btn-selected-product' + (is_lproduct ? ' selected-lproduct' :  ''),
    }); 
    var div = $('<div></div>', {
        class: 'd-flex'
    });
    var selected_item = $('<span></span>', {
        'data-selectedid': id,
        'data-vid': vid, 
        text: fullname.length > 0 ? fullname : name,
        class: 'mr-auto'
    });
    var wrap_icons = $('<div></div>', {
        class: 'ml-auto'
    });
    var edit_icon = $('<i></i>', {
        class: 'fas fa-pen-square ml-3 edit-icon cursor-pointer',
        onclick: "edit_prod_version('" + id + "','" + pid + "','" + prefix + "','" + is_lproduct + "')",
        'data-iconid': id
    });
    var del_icon = $('<i></i>', { 
        class: 'fas fa-minus-circle ml-1 toggle-minus-circle cursor-pointer',
        onclick: "deselect_item('" + id + "'," + pid + ",'" + prefix + "','" + is_lproduct + "')",
    });
    wrap_icons.append(edit_icon, del_icon);
    div.append(selected_item, wrap_icons);
    btn.append(div);
    wrap.append(btn);
    $('#' + prefix + 'selected_list').append(wrap);
}

// アプリケーションを選択する。
function select_item(pid, name, vid, fullname, prefix = '', is_lproduct = '') {
    var max_products_size = parseInt($('#max-products-size').val());
    if ($('#' + prefix + 'selected_list [data-editid]').length >= max_products_size) {
        alert('手動登録アプリケーションは既に' + max_products_size + '個まで選択されています。' + (max_products_size + 1) + '個以上は登録できません。');
        return false;
    }
    var unregistrable_product_ids = JSON.parse($('#unregistrable-product-ids').val());
    if( ( !vid || parseInt(vid) == 0 ) && unregistrable_product_ids.includes(parseInt(pid)) ){
        alert('仕様により、このプロダクトの「全て」を登録することはできません。');
        return false;
    }
    if(is_lproduct.length > 0){
        var m_selected = JSON.parse($('#' + prefix + 'selected_lproducts').val());
    }else{
        var m_selected = JSON.parse($('#' + prefix + 'selected').val());
    }
    if (!m_selected[pid]) { m_selected[pid] = []; }
    for (var i = 0; i < m_selected[pid].length; i++) {
        if (m_selected[pid][i]['vid'] == vid) { return false; }
    }
    m_selected[pid].push({ pid: pid, name: name, vid: vid, fullname: fullname });
    if(is_lproduct.length > 0){
        $('#' + prefix + 'selected_lproducts').val(JSON.stringify(m_selected));
    }else{
        $('#' + prefix + 'selected').val(JSON.stringify(m_selected));
    }
    select_item_append(pid, name, vid, fullname, prefix, is_lproduct);
    /*$('#' + prefix + 'searched_list > *').remove();
    $('#' + prefix + 'inc_search').val('');
    $('#' + prefix + 'searched_lproducts_list > *').remove();
    toggle_searched_lproducts_area(false, prefix);
    toggle_support_end_products_statement(false, prefix); */
    return false;
}
/*function select_item(pid, name, vid, fullname, prefix = '') {
    if ($('#' + prefix + 'selected_list a').length >= 30) {
	alert('手動登録アプリケーションは既に30個まで選択されています。31個以上は登録できません。');
	return false;
    }
    var m_selected = JSON.parse($('#' + prefix + 'selected').val());
    if (!m_selected[pid]) { m_selected[pid] = []; }
    for (var i = 0; i < m_selected[pid].length; i++) {
	if (m_selected[pid][i]['vid'] == vid) { return false; }
    }
    m_selected[pid].push({ pid: pid, name: name, vid: vid, fullname: fullname });
    $('#' + prefix + 'selected').val(JSON.stringify(m_selected));
    select_item_append(pid, name, vid, fullname, prefix);
    $('#' + prefix + 'searched_list > *').remove();
    $('#' + prefix + 'inc_search').val('');
    toggle_support_end_products_statement(false, prefix) 
    return false;
}*/

// アプリケーションを非選択にする。
function deselect_item(id, pid, prefix = '', is_lproduct = '') {
    if(is_lproduct.length > 0){
        var m_selected = JSON.parse($('#' + prefix + 'selected_lproducts').val());
    }else{
        var m_selected = JSON.parse($('#' + prefix + 'selected').val());
    }
    if (!m_selected[pid]) { return false; }
    var del_prod_name = $('#' + prefix + 'selected_list').find('[data-selectedid="' + id + '"]');
    var vid = parseInt(del_prod_name.attr('data-vid'));
    m_selected[pid] = m_selected[pid].filter(function(v, i) {
        return vid != parseInt(v['vid']);
    });
    if (m_selected[pid].length == 0) { delete m_selected[pid]; }
    if(is_lproduct.length > 0){
        $('#' + prefix + 'selected_lproducts').val(JSON.stringify(m_selected));
    }else{
        $('#' + prefix + 'selected').val(JSON.stringify(m_selected));
    }
    $('#' + prefix + 'selected_list').find('[data-editid="' + id + '"]').remove();
    return false;  
}
/*function deselect_item(pid, vid, prefix = '', is_lproduct = '') {
    $('#' + prefix + 'select_item_' + pid + '_' + vid + is_lproduct).remove();
    if(is_lproduct.length > 0){
        var m_selected = JSON.parse($('#' + prefix + 'selected_lproducts').val());
    }else{
        var m_selected = JSON.parse($('#' + prefix + 'selected').val());
    }
    if (!m_selected[pid]) { return false; }
    m_selected[pid] = m_selected[pid].filter(function(v, i) {
        return vid != v['vid'];
    });
    if (m_selected[pid].length == 0) { delete m_selected[pid]; }
    if(is_lproduct.length > 0){
        $('#' + prefix + 'selected_lproducts').val(JSON.stringify(m_selected));
    }else{
        $('#' + prefix + 'selected').val(JSON.stringify(m_selected));
    }
    return false;
}*/

//アプリケーションのバージョン編集
function edit_prod_version(id, pid, prefix = '', is_lproduct = ''){
    var is_version_list = $('#edit-version-search-area[data-searchid="' + id + '"]').length === 1;
    $('#edit-version-search-area').remove();
    $('.modal:visible').find('.editing-icon').removeClass('editing-icon');
    if( !is_version_list ){
        $('[data-iconid="' + id + '"]').addClass('editing-icon');
        var search_area = $('<div></div>', {
            id: 'edit-version-search-area',
            class: 'edit-version-search-area',
            'data-searchid': id,
        });
        var label = $('<div></div>', {
            class: 'version-search-area-label d-flex'
        });
        label.append($('<div>').text('バージョン選択'));
        var version_list = $('<div></div>', {class: 'edit-version-searched-list scrollable-menu-150 border-top border-bottom mr-1 ml-1'});
        var path = $('#sidfm_internal_api_get_product_versions_path').val();
        is_lproduct = is_lproduct.length > 0;
        if( is_lproduct ){
            var data = {'lproduct_id': pid};
        }else{
            var data = {'product_id': pid};
        }
        $.post(path, data, function(prod_info){
            var elms = [];
            var prod = prod_info['product'];
            var lprod = prod_info['lproduct'];
            if(prod){
                var is_support_end_prod = false;
                var name = prod['name'];
                var versions = prod_info['versions'];
                var on_click = "exec_edit_prod_version('" + prefix + "','" + 
                               id + "','" + pid + "'," + "'0','" + sanitize_string(name) + "')";
                var is_prod_support_end = prod['is_support_end'];
                if( is_prod_support_end ){
                    is_support_end_prod = true;
                }
                elms.push(
                    $('<div></div>', {
                        class: 'searched-version-item' + (is_prod_support_end ? ' text-danger' : ''),
                        onclick: on_click,
                        text: '全て'
                    })
                ); 
                versions.forEach(function(v){
                    if(!v['vid']){
                        v['vid'] = 0;
                    }
                    var on_click = "exec_edit_prod_version('" + prefix + "','" +
                                   id + "','" + pid + "','" + v['vid'] + "','" + sanitize_string(name) + "','" + sanitize_string(v['fullname']) + "')";
                    var is_version_support_end = v['is_support_end'];
                    if( is_version_support_end ){
                        is_support_end_prod = true;
                    }
                    elms.push(
                        $('<div></div>', {
                            class: 'searched-version-item' + (is_version_support_end ? ' text-danger' : ''),
                            onclick: on_click,
                            text: v['fullname']
                        })
                    );
                });
                if( is_support_end_prod ){
                    label.append(
                        $('<div>').attr('class', 'ml-auto mr-2').append(
                            $('<span>').attr('class', 'font-size-small').text('※注意事項'),
                            $('<span>').append(
                                $('<a>').attr({
                                    'class': 'ml-1',
                                    'data-toggle': 'tooltip',
                                    'data-html': 'true',
                                    'data-title': '赤い文字で表記されているバージョンは、SIDfmでのサポートが終了しています。<br>SIDfmでのサポートが終了しているバージョンについては、脆弱性が公開されてもSIDfmコンテンツが作成されずSIDfm VMでも脆弱性が検出されません。',
                                    'data-boundary': 'window'
                                }).append($('<i>').attr('class', 'fas fa-question-circle c_gray_70'))
                            )
                        )
                    );
                }
            }else if(lprod){
                label.append(
                    $('<div>').attr('class', 'ml-auto mr-2').append(
                        $('<span>').attr('class', 'font-size-small').text('※注意事項'),
                        $('<span>').append(
                            $('<a>').attr({
                                'class': 'ml-1',
                                'data-toggle': 'tooltip',
                                'data-title': 'ローカルプロダクトについては、脆弱性が公開されてもSIDfmコンテンツが作成されずSIDfm VMでも脆弱性が検出されません。',
                                'data-boundary': 'window'
                            }).append($('<i>').attr('class', 'fas fa-question-circle c_gray_70'))
                        )
                    )
                );
                var name = lprod['name'];
                var lversions = prod_info['lversions'];
                var on_click = "exec_edit_prod_version('" + prefix + "','" +
                               id + "','" + pid + "'," + "'0','" + sanitize_string(name) + "',''," + "'true'" + ")";
                elms.push(
                    $('<div></div>', {
                        class: 'searched-version-item' + (lprod['is_support_end'] ? ' text-danger' : ''),
                        onclick: on_click,
                        text: '全て'
                    })
                );    
                lversions.forEach(function(v){
                    var on_click = "exec_edit_prod_version('" + prefix + "','" +
                                   id + "','" + pid + "','" + v['id'] + "','" + sanitize_string(name) + "','" + sanitize_string(v['fullname']) + "'," + "'true'" + ")";
                    elms.push(
                        $('<div></div>', {
                            class: 'searched-version-item' + ((lprod['is_support_end'] || v['is_support_end']) ? ' text-danger' : ''),
                            onclick: on_click,
                            text: v['fullname']
                        })
                    );
                });
            } 
            version_list.append(elms); 
            search_area.append(label, version_list);
            $('body').append(search_area.hide());
            search_area.find('[data-toggle="tooltip"]').tooltip();
            set_version_list_placement();
            search_area.show();
        });
    }
}

//バージョンの編集実行
function exec_edit_prod_version(prefix = '', id, pid, vid, name, fullname = '', is_lproduct = ''){
    vid = parseInt(vid);
    var target_prod_name = $('#' + prefix + 'selected_list').find('[data-selectedid="' + id + '"]');
    var prev_vid = parseInt(target_prod_name.attr('data-vid'));

    is_lproduct = is_lproduct.length > 0;
    var selected_prods = (is_lproduct ? $('#' + prefix + 'selected_lproducts') : $('#' + prefix + 'selected'));
    var prods_data = JSON.parse(selected_prods.val());
    var target_data = prods_data[pid];
    var filtered_data = [];
    var is_existing_ver = false;
    for(var i = 0; i < target_data.length; i++){
        var d = target_data[i];
        var d_vid = parseInt(d['vid']);
        if(d_vid == vid){
            is_existing_ver = true;
            break;
        }
        if(d_vid != prev_vid){
            filtered_data.push(d);
        }
    } 
    if(is_existing_ver){
        alert('既に登録済みのプロダクトです');
        return false;
    }
   
    var unregistrable_product_ids = JSON.parse($('#unregistrable-product-ids').val()); 
    if( ( !vid || parseInt(vid) == 0 ) && unregistrable_product_ids.includes(parseInt(pid)) ){
        alert('仕様により、このプロダクトの「全て」を登録することはできません。');
        return false;
    } 

    filtered_data.push({
        pid: parseInt(pid),
        vid: vid,
        name: name,
        fullname: fullname,
    });
    prods_data[pid] = filtered_data;
    selected_prods.val(JSON.stringify(prods_data));
    target_prod_name.attr('data-vid', vid);
    target_prod_name.text(fullname.length > 0 ? fullname : name);
    $('#edit-version-search-area').remove();
    $('.modal:visible').find('.editing-icon').removeClass('editing-icon');
}

//バージョン一覧の位置調整
function set_version_list_placement(){
    var elm = $('#edit-version-search-area');
    if( elm.length > 0 ){
        var id = elm.attr('data-searchid');
        var target_elm = $('.modal:visible').find('[data-editid="' + id + '"]');
        var offset = target_elm.offset();
        elm.offset({'left': offset.left, 'top': offset.top + target_elm.outerHeight() + $(window).scrollTop()});
    }
}
// アプリケーション検索の処理
/*function inc_search_keyup(prefix = '') {
    return (function() {
	var f = $(this);
	var old_f = $('#' + prefix + 'inc_search_old');
	if (f.val() != old_f.val()) {
	    old_f.val(f.val());
	    var path = $('#sidfm_licenses_api_substr_search_path').val();
	    $.get(path, { 'params[keyword]': f.val() }, function(data) {
		var pids = Object.keys(data);
		$('#' + prefix + 'searched_list > *').remove();
		for (var i = 0; i < pids.length; i++) {
		    var product = data[pids[i]]['product'];
		    
		    var p_item = $('<span></span>', {
			class: 'dropdown'
		    });
		    p_item.append($('<button></button>', {
			class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
			type: 'button',
			id: prefix + 'searched_item_' + pids[i],
			'data-toggle': 'dropdown',
			'aria-haspopup': 'true',
			'aria-expanded': 'false',
			text: product['name']
		    }));
		    var p_menu = $('<div></div>', {
			class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
			'aria-labelledby': prefix + 'searched_item_' + pids[i]
		    });
		    var p_onclick =
			'select_item(' +
			pids[i] +
			',\'' +
			product['name'] +
			'\',0,\'\',\'' + prefix + '\')';
		    p_menu.append($('<a></a>', {
			class: 'dropdown-item',
			text: '全て',
		    href: '#',
			onclick: p_onclick
		    }));
		    
		    var versions = data[pids[i]]['versions'];
		    if (versions) {
			for (var j = 0; j < versions.length; j++) {
			    var version = versions[j];
			    p_onclick = 'select_item(' +
				pids[i] +
				',\'' +
				product['name'] + '\',' +
				version['vid'] + ',\'' +
				version['fullname'] +
				'\',\'' + prefix + '\')';
			    var p_ver = $('<a></a>', {
				class: 'dropdown-item',
				text: version['fullname'],
				href: '#',
				onclick: p_onclick
			    });
			    p_menu.append(p_ver);
			}
		    }
		    p_item.append(p_menu);
		    $('#' + prefix + 'searched_list').append(p_item);
		}
	    })
	    return true;
	}
    });
}*/

//アプリケーション検索のsupport終了製品に関するメッセージの初期化・有効化
function toggle_support_end_products_statement(is_enable, prefix){
    if(is_enable){
        if($('#' + prefix + 'searched_list').find('[data-supportend]').length > 0){
            $('#' + prefix + 'support-end-products-statement').removeClass('invisible').addClass('visible');
        }else{
            $('#' + prefix + 'support-end-products-statement').removeClass('visible').addClass('invisible');
        }
    }else{
        $('#' + prefix + 'support-end-products-statement').removeClass('visible').addClass('invisible');
    }
}

//ローカルプロダクトの表示の切り替え
function toggle_searched_lproducts_area(is_enable, prefix){
    if(is_enable){
        if($('#' + prefix + 'searched_lproducts_list').find('.lproduct-dropdown').length > 0){
            $('#' + prefix + 'searched_lproducts_area').show();
            $('#' + prefix + 'local-product-statement').show();
        }else{
            $('#' + prefix + 'searched_lproducts_area').hide();
            $('#' + prefix + 'local-product-statement').hide();
        }
    }else{
        $('#' + prefix + 'searched_lproducts_area').hide();
        $('#' + prefix + 'local-product-statement').hide();
    }
}

$(function() {

    init_sidfm();
    init_paginator();
    enable_dropdown_balloon();

    activate_sidebar_item('sidebar-item-hostadmin');

    set_style_for_ActionArea_on_filter_dropdown_event();
    $('#pages_form').on('submit', function(){ set_summary_table_lines('hostadmin', $('#pages_per_page').val()) });

    //チェックボックスとpages_checkedの整合性を取る
    $(window).on('pageshow', function(){
        if( $('#HostTable').length === 1 ){
            var is_all_checked = $('#pages_all_checked').val();
            if(is_all_checked === 'true'){
                var all_hostnames = JSON.parse($('#all_hostnames').val());
                $('#HostTable').find('#allSelect, .hostSelect').prop('checked', true);
                $('#pages_checked').val(JSON.stringify(all_hostnames.filter(Boolean)));
            }else{
                $('#HostTable').find('#allSelect, .hostSelect').prop('checked', false);
                var pages_checked = JSON.parse($('#pages_checked').val());
                var target_elm = '';
                pages_checked.forEach(function(hostname){
                    target_elm += '.hostSelect[value="' + hostname + '"],';
                });
                target_elm = target_elm.slice(0, -1);
                $(target_elm).prop('checked', true);
            }
        }
    });

    //import画面のメモ・手動登録プロダクト・パッケージ・検出アプリのballoonを開く時に、初めからcssを入れると、一番最初に表示する時だけ表示位置がずれるため、表示後にcssをいれる 
    //原因は不明だが、これで解消される。
    $('.balloon-dropdown').on('shown.bs.dropdown', function(){
        setTimeout(function(){ $('.balloon-memo:visible, .balloon-host-item:visible').css({'white-space': 'normal', 'word-break': 'break-all'}) }, 10);
    });

    //プロダクト検索modalで、スクロール時に検索バージョンの一覧の表示位置修正
    $('.modal').on('scroll', function(){
        var product_modal = $('.product-modal:visible');
        if(product_modal.length > 0){
            set_version_list_placement();
        }  
    });  

    //プロダクト検索画面で、画面クリックでバージョン一覧消去
    $('.product-modal').on('click', function(e){
        var e = e.target
        if(e){
            e = $(e);
            if(e.attr('id') != 'edit-version-search-area' && e.closest('#edit-version-search-area').length == 0 && !e.hasClass('edit-icon')){
                $('#edit-version-search-area').remove();
                $(this).find('.editing-icon').removeClass('editing-icon');
            }
        }
    });
 
    //ブラウザバックだったらチェックボックスの表示を修正
    /*$.post($('#check_browser_back_path').val(), {'page_name': 'hostadmin'},function(info){
        if(info === 'browser_back'){
            var is_all_checked = $('#pages_all_checked').val();
            if(is_all_checked === 'true'){
                var all_hostnames = JSON.parse($('#all_hostnames').val());
                $('#HostTable').find('#allSelect, .hostSelect').prop('checked', true);
                $('#pages_checked').val(JSON.stringify(all_hostnames.filter(Boolean)));
            }else{
                $('#HostTable').find('#allSelect, .hostSelect').prop('checked', false);
                var pages_checked = JSON.parse($('#pages_checked').val());
                var target_elm = '';
                for (var hostname of pages_checked){
                    target_elm += '.hostSelect[value="' + hostname + '"],';
                }
                target_elm = target_elm.slice(0, -1);
                $(target_elm).prop('checked', true);
            }
        }
    });*/
   
    //アクションボタンのロード時の活性・非活性
    if($('#pages_checked').length > 0 ){
        if( JSON.parse($('#pages_checked').val()).length > 0 ){
            $('.action-btn').prop('disabled', false);
        }else{
            $('.action-btn').prop('disabled', true);
        }
    }

    // ホスト名検索
    $('.filter-keyword').on('click', function(e) {
  reset_pages_checked_values();
	var keyword = $('#filters_search_keyword').val();
	var filters = JSON.parse($('#pages_filters').val());
	filters['hostname'] = String(keyword);
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // ホスト名検索リセット
    $('.filter-keyword-reset').on('click', function(e) {
  reset_pages_checked_values();
	var filters = JSON.parse($('#pages_filters').val());
	filters['hostname'] = String('');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // カテゴリ検索
    $('.category-change').on('click', function(e) {
  reset_pages_checked_values();
	var button = $(this);
	var categoryid = button.data('categoryid');
	var filters = JSON.parse($('#pages_filters').val());
	filters['category_id'] = String(categoryid);
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // 検索リセット
    $('.filter-reset').on('click', function(e) {
  reset_pages_checked_values();
	var filters = JSON.parse($('#pages_filters').val());
	filters['hostname'] = String('');
	filters['category_id'] = String('0');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // ホスト名変更ボタンを押下した際に実行される初期化処理
    //$('#hostnameModal').on('show.bs.modal', function(e) {
	//var button = $(e.relatedTarget);
	//$('#hostnameModalOld').text(button.data('hostname'));
	//$('#inputOldHostname').val(button.data('hostname'));
	//$('#hostnameModalHostid').val(button.data('hostid'));
  //$('#inputHostname').val('');
	//return true;
   // });

    $('#categories_new_select_category').on('click', function() {
        return move_selected_items_for_new_host('#categories_new_selected_category_ids',
				   '#categories_new_unselected_categories',
				   '#categories_new_selected_categories', false);
    });
    $('#categories_new_unselect_category').on('click', function() {
        return move_selected_items_for_new_host('#categories_new_selected_category_ids',
				   '#categories_new_selected_categories',
				   '#categories_new_unselected_categories', true);
    });

    function rename_host_name(host_id, hostname, old_hostname, sidfmd_host_id){
        var progress_window = get_progress_bar();
        $('body').append(progress_window); 

        var err_message = '';
        var rename_host_path = $('#sidfm_licenses_rename_host_path').val();
        var rename_host = $.ajax({
            type: 'POST',
            url: rename_host_path,
            data: { 'hostid': host_id, 'hostname': hostname, 'old_hostname': old_hostname }
        }).done(function(data){
            err_message = data['err_message'];
        });

        var html_ids = [];
        var get_related_html_ids_path = $('#sidfm_internal_api_get_host_view_related_htmlids_path').val();
        var get_related_html_ids = $.ajax({
            type: 'POST',
            url: get_related_html_ids_path,
            data: { 'host_ids': JSON.stringify([ sidfmd_host_id ])}
        }).done(function(related_html_ids){
            html_ids = related_html_ids;
        });

        $.when(rename_host, get_related_html_ids).done(function(){
            if( err_message.length > 0 ){
                alert(err_message);
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit(); 
            }else{
                update_view([parseInt(sidfmd_host_id)], html_ids, true);
            }
        });
    }

    function set_display_name(sidfmd_host_id, display_name){
         var progress_window = get_progress_bar();
         $('body').append(progress_window);

         var err_message = '';
         var set_display_name_path = $('#sidfm_licenses_set_display_name_path').val();
         var set_name = $.post(
             set_display_name_path,
             { 'hostid': sidfmd_host_id, 'display_name': display_name },
             function(data){ err_message = data['err_message']; }
         );

        var html_ids = [];
        var get_related_html_ids_path = $('#sidfm_internal_api_get_host_view_related_htmlids_path').val();
        var get_related_html_ids = $.ajax({
            type: 'POST',
            url: get_related_html_ids_path,
            data: { 'host_ids': JSON.stringify([ sidfmd_host_id ])}
        }).done(function(related_html_ids){
            html_ids = related_html_ids;
        });

        $.when(set_name, get_related_html_ids).done(function(){
            if( err_message.length > 0 ){
                alert(err_message);
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit();
            }else{
                update_view([parseInt(sidfmd_host_id)], html_ids, true);
            }
        });
    }

    function update_categories(rule_info = '{}'){
        var sidfmd_host_id = $('#categories_sidfmdhostid').val();
        var hostname = $('#categories_hostname').val();
        var selected_category_ids = $('#categories_selected_category_ids').val();
        var system_category_id = $('#categories_system_categories').val();
    
        var progress_window = get_progress_bar();
        $('body').append(progress_window);

        var err_message = '';
        var update_categories_path = $('#sidfm_licenses_update_categories_path').val();
        var update_categories = $.post(
            update_categories_path,
            {  
                'sidfmdhostid': sidfmd_host_id,
                'hostname': hostname,
                'selected_category_ids': selected_category_ids,
                'system_category_id': system_category_id,
                'rule_info': rule_info 
            },
            function(data){ err_message = data['err_message']; }
        );

        var html_ids = [];
        var get_related_html_ids_path = $('#sidfm_internal_api_get_host_view_related_htmlids_path').val();
        var get_related_html_ids = $.ajax({
            type: 'POST',
            url: get_related_html_ids_path,
            data: { 'host_ids': JSON.stringify([ sidfmd_host_id ]) }
        }).done(function(related_html_ids){
            html_ids = related_html_ids;
        });

        $.when(update_categories, get_related_html_ids).done(function(){
            if( err_message.length > 0 ){
                alert(err_message);
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit();
            }else{
                update_view([parseInt(sidfmd_host_id)], html_ids, true);
            }
        });
    }

    function update_host_view_os(host_ids){
        if( host_ids.length > 0 ){
            var path = $('#sidfm_internal_api_update_host_view_os_path').val();
            var total_size = host_ids.length;
            var executed_size = 0;
            var execute_update_view = function(){
                $.ajax({
                    type: 'POST',
                    url: path,
                    data: { 'host_ids': JSON.stringify(host_ids) }
                }).done(function(data){
                    if( data['executed_size'] === 0 ){//progress barが満たされるまで待つ
                        setTimeout(function(){
                            $('#pages_checked').val('[]');
                            $('#pages_all_checked').val('false');
                            $('#pages_form').submit();
                        },500);
                    }else{
                        host_ids = data['unexecuted_host_ids'];
                        executed_size += data['executed_size'];
                        var percentage = (executed_size / total_size * 100);
                        if( percentage >= 99 && percentage < 100 ){
                            percentage = 99;
                        }else{
                            percentage = Math.round(percentage);
                        }
                        $('#progress-bar').attr('aria-valuenow', percentage)
                                          .css('width', percentage + '%')
                                          .text(percentage + '%');
                        execute_update_view();
                    }
                });
            };

            execute_update_view(); 
        }else{
            $('#pages_checked').val('[]');
            $('#pages_all_checked').val('false');
            $('#pages_form').submit();
        }
    }

    function modify_app(hostname, selected_prods, selected_lprods){
        var progress_window = get_progress_bar();
        $('body').append(progress_window);
        
        var err_message = '';
        var modify_app_path = $('#sidfm_licenses_update_applications_path').val();
        var modify_app = $.post(
            modify_app_path,
            {
                'hostname': hostname,
                'selected': selected_prods,
                'selected_lproducts': selected_lprods
            },
            function(data){ 
                if( data['err_message'] ){
                    err_message = data['err_message'];
                }
            }
        );

        var host_ids = [];
        var get_host_ids_by_hostnames_path = $('#sidfm_internal_api_get_host_ids_by_hostnames_path').val();
        var get_host_ids = $.post(
            get_host_ids_by_hostnames_path,
            { 'hostnames': JSON.stringify([ hostname ]) },
            function(ids){ host_ids = ids; }
        );
        
        $.when(modify_app, get_host_ids).done(function(){
            if( err_message.length > 0 ){
                alert(err_message);
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit();
            }else{
                update_host_view_os(host_ids);
            }
        });
    
    }

    function modify_app_bulk(hostnames, selected_prods, selected_lprods){
        var progress_window = get_progress_bar();
        $('body').append(progress_window);

        var err_message = '';
        var modify_app_path = $('#sidfm_licenses_update_applications_bulk_path').val();
        var modify_app = $.post(
            modify_app_path,
            {
                'hostnames': hostnames,
                'selected': selected_prods,
                'selected_lproducts': selected_lprods
            },
            function(data){
                if( data['err_message'] ){
                    err_message = data['err_message'];
                }
            }
        );

        var host_ids = [];
        var get_host_ids_by_hostnames_path = $('#sidfm_internal_api_get_host_ids_by_hostnames_path').val();
        var get_host_ids = $.post(
            get_host_ids_by_hostnames_path,
            { 'hostnames': hostnames },
            function(ids){ host_ids = ids; }
        );

        $.when(modify_app, get_host_ids).done(function(){
            if( err_message.length > 0 ){
                alert(err_message);
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit();
            }else{
                update_host_view_os(host_ids);
            }
        });
    }

    function alert_unchangeable_host_related_rules(process_name){
        alert('ログインユーザのカテゴリ範囲外のルールの条件、またはルール自体が削除されるため、処理を実行できません。\nどうしても' + process_name + 'が必要な場合は、SIDfmVM管理者権限のユーザで、再度実行してください。');
    };

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages').on('click', function(e) {
        var button = $(this);
        var target = $(button.data('target'));
        var dump = {
            'pages[offset]': $('#pages_offset').val(),
            'pages[per_page]': $('#pages_per_page').val(),
            'pages[order]' : $('#pages_order').val(),
            'pages[filters]': JSON.parse($('#pages_filters').val()),
            'pages[category_id]': $('#pages_category_id').val(),
            'pages[hostname]': $('#pages_hostname').val(),
            'pages[checked]': [],
            'pages[all_checked]': false
        };
        target.val(JSON.stringify(dump));
        var button_id = button.attr('id'); 
        //関連するルールのチェック
        if(button_id === 'host-category-change'){
            var hostid = $('#categories_sidfmdhostid').val();
            /*$('#submit-related-rules-item-form').attr({
                'data-submit': '#categories_form',
                'data-name':  'categories',
            });
            var form = $('#categories_form');*/
            var path = $('#sidfm_internal_api_check_related_rules_path').val();
            var category_ids = [];
            $('#categories_selected_categories option').each(function(){
                category_ids.push(parseInt($(this).val()));
            });
            if( !confirm_modify_categories(category_ids) ){
                return false;
            }
            category_ids.push(parseInt($('#categories_system_categories').val()));
            $.ajax({
                url: path,
                type: 'POST',
                data: {
                    'page_name': 'hostadmin', 
                    'host_ids': JSON.stringify([hostid]),
                    'action_idx': 'category_change',
                    'category_ids': JSON.stringify(category_ids)
                },
            }).done(function(data){
                if( data['is_unchangeable_host'] ){
                    alert_unchangeable_host_related_rules('カテゴリの変更');
                    return false; 
                }
                var rule_messages = data['rule_messages'];
                var rule_names = Object.keys(rule_messages);
                if(rule_names.length > 0){
                    delete data['rule_messages'];
                    $('#execute-action-with-related-rules').attr({
                        'data-ruleinfo': JSON.stringify(data),
                        'data-action': 'update_categories'
                    });
                    $('#RuleInfoArea > *').remove();
                    $('#modalConfRelatedRules').modal('show');
                    rule_names.sort();
                    for(var i = 0; i < rule_names.length; i++){
                        var rule_name = rule_names[i];
                        var rule_message = rule_messages[rule_name];
                        var item_name = rule_message['item_name'];
                        var content = rule_message['content'];
                        var reason = rule_message['reason'];
                        var tr = $('<tr>').attr('class', 'list_alternative');
                        var rule_name_td = $('<td>').attr('class', 'rule-name').text(rule_name);
                        var item_td = $('<td>').attr('class', 'rule-item').text(item_name);
                        var message_td = $('<td>').attr('class', 'rule-changes').text(content);
                        var reason_td = $('<td>').attr('class', 'rule-reason').text(reason);
                        tr.append(rule_name_td, item_td, message_td, reason_td);
                        $('#RuleInfoArea').append(tr);
                    }
                }else{                
                    update_categories();
                }
            });
        }else if(button_id === 'execute-change-name'){
            var submit_selector = button.attr('data-submit');
            if(submit_selector === '#hostnameModal-hostname-form'){
                var hostname = $('#inputHostname').val();
                var path = $('#sidfm_licenses_api_validate_new_host_path').val();
                $.ajax({
                    type: 'GET',
                    url: path
                }).done(function(existing_hostnames){
                    if(existing_hostnames.includes(hostname)){
                        $('#warning-change-hostname').text('同名のホストが登録されています。').show();
                    }else{
                        //$(submit_selector).submit(); 
                        var old_hostname = $('#inputOldHostname').val();
                        var host_id = $('#hostnameModalHostid').val();
                        var sidfmd_host_id = $('#hostnameModal-sidfm-host-id').val();
                        rename_host_name(host_id, hostname, old_hostname, sidfmd_host_id);
                    }
                });
            }else{
                var sidfmd_host_id = $('#hostnameModal-sidfm-host-id').val();
                var display_name = $('#input-display-name').val();
                set_display_name(sidfmd_host_id, display_name); 
            }
        }else if(button_id === 'exec-modify-app'){
            var hostname = $('#modifyapp_hostname').val();
            var selected_prods = $('#m_selected').val();
            var selected_lprods = $('#m_selected_lproducts').val();
            modify_app(hostname, selected_prods, selected_lprods);
        }else{
            return true;
        }
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages-confirm').on('confirm:complete', function(e, answer) {
	if (answer) {
	    var button = $(this);
	    var target = $(button.data('target'));
	    var dump = {
		'pages[offset]': $('#pages_offset').val(),
		'pages[per_page]': $('#pages_per_page').val(),
		'pages[order]' : $('#pages_order').val(),
		'pages[filters]': JSON.parse($('#pages_filters').val()),
		'pages[category_id]': $('#pages_category_id').val(),
		'pages[hostname]': $('#pages_hostname').val(),
		'pages[checked]': [],
		'pages[all_checked]': false
	    };
	    target.val(JSON.stringify(dump));
	}
	return true;
    });

    // メモ更新
    var memo_before_update = '';
    $('#memoModal').on('show.bs.modal', function(e) {
        $('#update-memo-label').hide();
        $('#execute-update-memo').prop('disabled', true);
	var button = $(e.relatedTarget);
        var host_memo = button.data('memo');
	$('#inputMemo_Hostname').val(button.data('hostname'));
	$('#inputMemo').val(host_memo);
  $('#tooltip_for_memo').attr('data-original-title', host_memo);
	$('#memoModalLabel').text(button.data('title'));
        memo_before_update = button.data('memo');
	return true;
    });

    // 基準日更新
    $('#refdateModal').on('show.bs.modal', function(e) {
	var button = $(e.relatedTarget);
	$('#inputRefdate_Hostname').val(button.data('hostname'));
	$('#inputRefdate').val(button.data('refdate'));
	$('#refdateModalLabel').text(button.data('title'));
	return true;
    });

    // カテゴリ編集
    $('#categoriesModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        var sidfmdhostid = button.data('sidfmdhostid');
        var hostname = button.data('hostname');
        var title = button.data('title');
        var syscategory = button.data('syscategory');
        var categories = button.data('categories');
        if (typeof sidfmdhostid === 'undefined' || sidfmdhostid == '' || sidfmdhostid == 0) {
            alert('不正な操作を確認したため、画面をリロードします。');
            location.reload(true);
            return false;
        }
        // hostid, hostnameの設定
        $('#categories_sidfmdhostid').val(sidfmdhostid);
        $('#categories_hostname').val(hostname);
        // タイトルの設定
        $(this).find('.modal-title').text(title);
        // システムカテゴリの設定
        $('#categories_system_categories > option').prop('selected', false);
        if (syscategory != null) {
            $('#categories_system_categories > option[value="' + syscategory['id'] + '"]').prop('selected', true);
        }
        // その他カテゴリの設定
        var not_system_categories = JSON.parse($('#not_system_categories').val());
        var not_system_category_ids = not_system_categories.map(x => x['id']);
        var category_ids = categories.map(x => x ['id']);
        $('#categories_selected_categories > option').remove();
        $('#categories_unselected_categories > option').remove();
        not_system_categories.sort(function(a, b){
            if(a['name'].toLowerCase() > b['name'].toLowerCase()){
                return 1;
            }else{
                return -1;
            }
        });
        for (var i = 0; i < not_system_categories.length; i++) {
            var cat = not_system_categories[i];
            $($.inArray(cat['id'], category_ids) != -1 ? '#categories_selected_categories' : '#categories_unselected_categories')
                .append(
                    $('<option>').attr({
                        'value': cat['id'],
                        'class': 'text-truncate g-max-width-21em',
                        'data-toggle': 'tooltip',
                        'data-title': cat['desc'],
                        'data-placement': 'right',
                        'data-boundary': 'window',
                    }).text(cat['name'])
                )
            ;
        }
        $('#categories_selected_categories, #categories_unselected_categories').find('[data-toggle="tooltip"]').tooltip();
        $('#categories_selected_category_ids').val(JSON.stringify(category_ids));
        return true;
    });


    // 選択されたカテゴリを選択済に移動
    $('#categories_select_category').on('click', function() {
	       move_selected_items('#categories_selected_category_ids',
				   '#categories_unselected_categories',
				   '#categories_selected_categories', false);
         $('#categories_selected_categories option').tooltip();
    });

    // 選択されたカテゴリを未選択に移動
    $('#categories_unselect_category').on('click', function() {
        move_selected_items('#categories_selected_category_ids',
            '#categories_selected_categories',
            '#categories_unselected_categories', true);
        $('#categories_unselected_categories option').tooltip();
    });

    // カテゴリ一括
    $('#categoriesBulkModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget); 
        var checked = $('#pages_checked').val();
        var hostnames = JSON.parse(checked);
        if (hostnames.length > 0) {
            var path = $('#sidfm_internal_api_get_hosts_display_name_path').val();
            $.post(path, {'hostnames': JSON.stringify(hostnames)}, function(data){
                $('#categories_bulk_hostnames').val(checked);
                $('#categoriesBulkTargetList > *').remove();
                for (var i = 0; i < hostnames.length; i++) {
                    var hostname = hostnames[i];
                    var ext_name = data[hostname];
                    var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
                    var c_td = $('<td></td>', { class: 'hostname' });
                    c_td.append(
                        $('<span>').attr({
                            'data-toggle': 'tooltip', 
                            'data-title': 'ホスト名: ' + hostname + '<br/>表示名: ' + (ext_name ? ext_name : '(未設定)'),
                            'data-html': 'true',
                            'data-placement': 'right',
                            'data-boundary': 'window'
                        }).text(ext_name ? ext_name : hostname)
                    );
                    c_tr.append(c_td);
                    $('#categoriesBulkTargetList').append(c_tr);
                }
                $('#categoriesBulkTargetList').find('[data-toggle="tooltip"]').tooltip();
            });
        } else {
            alert('対象ホストがチェックされておりません。');
            location.reload(true);
            return false;
        }
        return true;
    });
    $('#categories_bulk_select_category').on('click', function() {
        move_selected_items('#categories_bulk_selected_category_ids',
           '#categories_bulk_unselected_categories', 
           '#categories_bulk_selected_categories', false);
        $('#categories_bulk_selected_categories option').tooltip();
    });
    $('#categories_bulk_unselect_category').on('click', function() {
        move_selected_items('#categories_bulk_selected_category_ids',
           '#categories_bulk_selected_categories',
           '#categories_bulk_unselected_categories', true);
        $('#categories_bulk_unselected_categories option').tooltip();
    });

    function bulk_update_categories(rule_info = '{}'){
        var progress_window = get_progress_bar();
        $('body').append(progress_window);

        var hostnames = $('#categories_bulk_hostnames').val();
        var selected_category_ids = $('#categories_bulk_selected_category_ids').val();
        var system_category_id = $('#categories_bulk_system_categories').val();
  
        var err_message = '';
        var bulk_update_cats_path = $('#sidfm_licenses_update_categories_bulk_path').val();

        var bulk_update_cats = $.post(
            bulk_update_cats_path,
            { 
                'hostnames': hostnames,
                'selected_category_ids': selected_category_ids,
                'system_category_id': system_category_id,
                'rule_info': rule_info
            },
            function(data){ err_message = data['err_message']; }
        );

        var html_ids = [];
        var get_related_html_ids_path = $('#sidfm_internal_api_get_host_view_related_htmlids_path').val();
        var get_related_html_ids = $.ajax({
            type: 'POST',
            url: get_related_html_ids_path,
            data: { 'hostnames': hostnames }
        }).done(function(related_html_ids){
            html_ids = related_html_ids;
        });

        var host_ids = [];
        var get_host_ids_by_hostnames_path = $('#sidfm_internal_api_get_host_ids_by_hostnames_path').val();
        var get_host_ids = $.post(
            get_host_ids_by_hostnames_path,
            { 'hostnames': hostnames },
            function(ids){ host_ids = ids; }
        );

        $.when(update_categories, get_related_html_ids, get_host_ids).done(function(){
            if( err_message.length > 0 ){
                alert(err_message);
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit();
            }else{
                update_view(host_ids, html_ids, true);
            }
        });
    }

    function confirm_modify_categories(custom_category_ids){
        var self_user_roles = JSON.parse($('#self_user_role').val());
        if( custom_category_ids.length == 0 && !self_user_roles.includes('admin') ){
            alert('少なくとも一つはカスタムカテゴリを指定する必要があります。');
            return false;
        }
        return true;
    }

    //カテゴリ一括変更時に関連するルールをチェック
    $('#hosts-bulk-category-change').on('click', function(){
        var hostnames = JSON.parse($('#categories_bulk_hostnames').val());
        /*$('#submit-related-rules-item-form').attr({
            'data-submit': '#categories_bulk_form',
            'data-name':  'categories',
        }); 
        var form = $('#categories_bulk_form');*/
        var path = $('#sidfm_internal_api_check_related_rules_path').val();
        var category_ids = [];
        $('#categories_bulk_selected_categories option').each(function(){
            category_ids.push(parseInt($(this).val()));
        });
        if( !confirm_modify_categories(category_ids) ){
            return false;
        }
        category_ids.push(parseInt($('#categories_bulk_system_categories').val()));
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'page_name': 'hostadmin',
                'hostnames': JSON.stringify(hostnames),
                'action_idx': 'bulk_category_change',
                'category_ids': JSON.stringify(category_ids)
            },
        }).done(function(data){
            if( data['is_unchangeable_host'] ){
                alert_unchangeable_host_related_rules('カテゴリの変更');
                return false;
            }
            var rule_messages = data['rule_messages'];
            var rule_names = Object.keys(rule_messages);
            if(rule_names.length > 0){
                delete data['rule_messages'];
                $('#execute-action-with-related-rules').attr({
                    'data-ruleinfo': JSON.stringify(data),
                    'data-action': 'bulk_update_categories'
                });
                $('#RuleInfoArea > *').remove();
                $('#modalConfRelatedRules').modal('show');
                //for(rule_name in rule_messages){
                rule_names.sort();
                for(var i = 0; i < rule_names.length; i++){
                    var rule_name = rule_names[i];
                    var rule_message = rule_messages[rule_name];
                    var item_name = rule_message['item_name'];
                    var content = rule_message['content'];
                    var reason = rule_message['reason'];
                    var tr = $('<tr>').attr('class', 'list_alternative');
                    var rule_name_td = $('<td>').attr('class', 'rule-name').text(rule_name);
                    var item_td = $('<td>').attr('class', 'rule-item').text(item_name);
                    var message_td = $('<td>').attr('class', 'rule-changes').text(content);
                    var reason_td = $('<td>').attr('class', 'rule-reason').text(reason);
                    tr.append(rule_name_td, item_td, message_td, reason_td);
                    $('#RuleInfoArea').append(tr);
                }
            }else{
                //form.submit();
                bulk_update_categories();
            }
        });
    });

    // プロダクト一括
    $('#modalModifyAppBulk').on('show.bs.modal', function(event) {
        //$('#bulk_inc_search').val('');
        //$('#bulk_searched_list > *').remove();
        //$('#bulk_selected_list > *').remove();
        toggle_searched_lproducts_area(true, 'bulk_');
        toggle_support_end_products_statement(true, 'bulk_');
        var button = $(event.relatedTarget);
        var checked = $('#pages_checked').val();
        var hostnames = JSON.parse(checked);
        if (hostnames.length > 0) {
            $('#modifyappbulk_hostnames').val(checked);
            $('#appBulkTargetList > *').remove();
            var path = $('#sidfm_internal_api_get_hosts_display_name_path').val();
            $.post(path, {'hostnames': JSON.stringify(hostnames)}, function(data){
                for (var i = 0; i < hostnames.length; i++) {
                    var hostname = hostnames[i];
                    var ext_name = data[hostname];
                    var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
                    var c_td = $('<td></td>', { class: 'hostname' });
                    c_td.append(
                        $('<span>').attr({
                            'data-toggle': 'tooltip',
                            'data-title': 'ホスト名: ' + hostname + '<br/>表示名: ' + (ext_name ? ext_name : '(未設定)'),
                            'data-html': 'true',
                            'data-placement': 'right',
                            'data-boundary': 'window'
                        }).text(ext_name ? ext_name : hostname)
                    );
                    c_tr.append(c_td);
                    $('#appBulkTargetList').append(c_tr);
                }
                $('#appBulkTargetList').find('[data-toggle="tooltip"]').tooltip();
            });
        } else {
            alert('対象ホストがチェックされておりません。');
            location.reload(true);
            return false;
        }	
        return true;
    });

    $('#exec-modify-app-bulk').on('click', function(){
        var conf = confirm('指定したホスト全ての登録プロダクトが変更されます。実行してもよろしいですか？');
        if( conf ){
            var hostnames = $('#modifyappbulk_hostnames').val();
            var selected_prods = $('#bulk_selected').val();
            var selected_lprods = $('#bulk_selected_lproducts').val();
            modify_app_bulk(hostnames, selected_prods, selected_lprods);
        }
    });
    // 基準日一括
    $('#refdateBulkModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        var checked = $('#pages_checked').val();
        var hostnames = JSON.parse(checked);
        if (hostnames.length > 0) {
            $('#refdate_bulk_hostnames').val(checked);
            $('#refdateBulkTargetList > *').remove();
            var path = $('#sidfm_internal_api_get_hosts_display_name_path').val();
            $.post(path, {'hostnames': JSON.stringify(hostnames)}, function(data){
                for (var i = 0; i < hostnames.length; i++) {
                    var hostname = hostnames[i];
                    var ext_name = data[hostname];
                    var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
                    var c_td = $('<td></td>', { class: 'hostname' });
                    c_td.append(
                        $('<span>').attr({
                            'data-toggle': 'tooltip',
                            'data-title': 'ホスト名: ' + hostname + '<br/>表示名: ' + (ext_name ? ext_name : '(未設定)'),
                            'data-html': 'true',
                            'data-placement': 'right',
                            'data-boundary': 'window'
                        }).text(ext_name ? ext_name : hostname)
                    );
                    c_tr.append(c_td);
                    $('#refdateBulkTargetList').append(c_tr);
                }
                $('#refdateBulkTargetList').find('[data-toggle="tooltip"]').tooltip();
            });
        } else {
            alert('対象ホストがチェックされておりません。');
            location.reload(true);
            return false;
        }
        return true;
    });

    // メモ一括
    $('#memoBulkModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        var checked = $('#pages_checked').val();
        var hostnames = JSON.parse(checked);
        if (hostnames.length > 0) {
            $('#memo_bulk_hostnames').val(checked);
            $('#memoBulkTargetList > *').remove();
            var path = $('#sidfm_internal_api_get_hosts_display_name_path').val();
            $.post(path, {'hostnames': JSON.stringify(hostnames)}, function(data){
                for (var i = 0; i < hostnames.length; i++) {
                    var hostname = hostnames[i];
                    var ext_name = data[hostname];
                    var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
                    var c_td = $('<td></td>', { class: 'hostname' });
                    c_td.append(
                        $('<span>').attr({
                            'data-toggle': 'tooltip',
                            'data-title': 'ホスト名: ' + hostname + '<br/>表示名: ' + (ext_name ? ext_name : '(未設定)'),
                            'data-html': 'true',
                            'data-placement': 'right',
                            'data-boundary': 'window'
                        }).text(ext_name ? ext_name : hostname)
                    );
                    c_tr.append(c_td);
                    $('#memoBulkTargetList').append(c_tr);
                }
                $('#memoBulkTargetList').find('[data-toggle="tooltip"]').tooltip();
            });
        } else {
            alert('対象ホストがチェックされておりません。');
            location.reload(true);
            return false;
        }
        return true;
    });

    $('#offlineModal').on('show.bs.modal', function(event) {
	$('#offlineInput').fileinput({uploadExtraData: {
	    'system_category_id':'1',
	    'custom_category_id':$($('#offlineCustomCategory > option')[0]).val()
	} });
	$('#offlineInput').on('fileloaded', function(event, file, previewId, index, reader) {
	    var captions = $('#offlineModal tbody.file-preview-thumbnails > tr.file-preview-frame > td.file-details-cell > div.explorer-caption');
	    var previewIds = previewId.split('-');
	    var previewIdNum = parseInt(previewIds[2]);
	    var caption = $(captions[previewIdNum]);
	    var is_valid = false;
	    var hostname = '';
	    try {
		var data = JSON.parse(reader['result']);
		hostname = data['hostname'];
		if (hostname) { is_valid = true; }
	    } catch (e) {
		console.log(e);
	    }
	    caption.find('span').remove();
	    if (is_valid) {
		// JSON正常、hostname正常
		var path = $('#sidfm_internal_api_check_hostname_path').val();
		$.get(path, { 'params[hostname]':hostname }, function(data) {
		    caption.find('span').remove();
		    if (!data['exist'] && data['accessable']) {
			var msg_invalid = $('<span></span>', {
			    text: '新ホストとして登録されます',
			    class: 'bg-warning text-black g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
			});
			caption.append(msg_invalid);
		    } else if (data['exist'] && !data['accessable']) {
			var msg_invalid = $('<span></span>', {
			    text: 'アクセス不可',
			    class: 'bg-danger text-white g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
			});
			caption.append(msg_invalid);
		    } else if (!data['accessable']) {
			var msg_invalid = $('<span></span>', {
			    text: 'アクセス不可',
			    class: 'bg-danger text-white g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
			});
			caption.append(msg_invalid);
		    }
		    return true;
		});
	    } else {
		// JSON不正もしくはhostname不正
		var msg_invalid = $('<span></span>', {
		    text: 'データが不正ですので確認してください',
		    class: 'bg-danger text-white g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
		});
		caption.append(msg_invalid);
	    }
	    return true;
	});
	return true;
    });
    $('#offlineModal').on('hidden.bs.modal', function(event) {
	$('#offlineInput').fileinput('clear');
	return true;
    });
    $('#offlineSystemCategory').on('change', function() {
	($('#offlineInput').data('fileinput').uploadExtraData)['system_category_id'] = '' + $('#offlineSystemCategory').val();
    });
    $('#offlineCustomCategory').on('change', function() {
	($('#offlineInput').data('fileinput').uploadExtraData)['custom_category_id'] = '' + $('#offlineCustomCategory').val();
    });

    // ホスト毎のcheckboxを変更した際の処理
    $('.hostSelect').on('change', function() {
        var checkbox = $(this);
        var hostname = checkbox.val(); 
        var checked = JSON.parse($('#pages_checked').val());
        var all_hostnames = JSON.parse($('#all_hostnames').val());
        var all_host_size = all_hostnames.length;
        if (checkbox.prop('checked')) {
            if (!checked.includes(hostname)) {
                checked.push(hostname);
                if (checked.length == all_host_size) {
                    $('.allHostSelect').prop('checked', true);
                    $('#pages_all_checked').val('true');
                } else {
                    $('.allHostSelect').prop('checked', false);
                    $('#pages_all_checked').val('false');
                }
                $('#pages_checked').val(JSON.stringify(checked));
            } 
        } else {
            var idx = checked.indexOf(hostname);
            if (idx == 0) {
                checked = checked.slice(1, all_host_size);
            } else if (idx == all_host_size - 1) {
                checked = checked.slice(0, all_host_size - 1);
            } else if (idx > 0) {
                var c_left = checked.slice(0, idx);
                var c_right = checked.slice(idx + 1, all_host_size);
                checked = c_left.concat(c_right);
            }
            $('#pages_checked').val(JSON.stringify(checked));
            $('.allHostSelect').prop('checked', false);
            $('#pages_all_checked').val('false');
        }
        if( checked.length > 0 ){
            $('.action-btn').prop('disabled', false);
        }else{
            $('.action-btn').prop('disabled', true);
        }
        return true;
    });

    // 全ホストチェックのcheckboxを変更した際の処理
    $('.allHostSelect').on('change', function() {
        var checkbox = $(this);
        if (checkbox.prop('checked')) {
            $('#pages_checked').val($('#all_hostnames').val());
            $('#pages_all_checked').val('true');
            $('.hostSelect').prop('checked', true);
            $('.action-btn').prop('disabled', false);
        } else {
            $('#pages_checked').val(JSON.stringify([]));
            $('#pages_all_checked').val('false');
            $('.hostSelect').prop('checked', false);
            $('.action-btn').prop('disabled', true);
        }
        return true;
    });
  
    // ホスト登録ボタンを押下した際に実行される初期化処理
    $('.btn-registhost').on('click', function() {
        $('#form_hostname').val('');
        $('#form_display_name').val('');
        $('#form_categories > option').prop('selected', false);
        $('#inc_search').val('');
        $('#selected, #selected_lproducts').val('{}');
        $('#categories_new_selected_category_ids').val('[]');
        var category_elms = [];
        $('#categories_new_selected_categories option').each(function(){
            category_elms.push($(this));
        });
        $('#categories_new_unselected_categories option').each(function(){
            category_elms.push($(this));
        });
        category_elms.sort(function(a, b){
            if(a.text() > b.text()){
                return 1
            }else{
                return -1;
            }
        });
        $('#categories_new_unselected_categories').append(category_elms);

        $('#searched_list > *').remove();
        $('#selected_list > *').remove();
        $('#new_host_regist_btn').prop('disabled', true);
        $('#warning-hostname').hide();
        $('#warning-display-name-of-register').hide();
        $('#warning-no-category').hide();
        $('#warning-memo').hide();
        $('#form_memo').val('');
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var day = date.getDate();
        if( String(month).length === 1 ){
          month = '0' + month;
        }
        if( String(day).length === 1){
          day = '0' + day;
        }
        $('#inputRefdateNew').val(year + '/' + month + '/' + day);
        toggle_searched_lproducts_area(false, '');
        toggle_support_end_products_statement(false, '');
        var is_admin = JSON.parse($('#self_user_role').val()).includes('admin');
        if( !is_admin ){
            $('#warning-no-category').show();
        } 
    });

    // アプリケーション変更ボタンを押下した際に実行される初期化処理
    $('.btn-modifyapp').on('click', function() {
        var hostname = $(this).data('hostname');
        var display_name = $(this).data('displayname');
        $('.modifyapp_hostname').text(display_name);
        $('#modifyapp_hostname').val(hostname);
        $('#m_inc_search').val('');
        $('#m_searched_list > *').remove();
        $('#m_selected_list > *').remove();
        toggle_support_end_products_statement(false, 'm_');
        toggle_searched_lproducts_area(false, 'm_');
	      var path = $('#sidfm_licenses_api_get_apps_by_hostname_path').val();
        $.get(path, { 'params[hostname]': hostname }, function(data) {
            //var m_selected = data;
            //$('#m_selected').val(JSON.stringify(data));
            var lproducts = data['lproducts'];
            delete data['lproducts'];
            var products = data;
            var keys = Object.keys(data);
            for (var i = 0; i < keys.length; i++) {
                var items = products[keys[i]];
                for (var j = 0; j < items.length; j++) {
                    var item = items[j];
                    if( !item['vid'] ){
                        var vid = 0;
                        products[keys[i]][j]['vid'] = vid;
                    }else{
                        var vid = item['vid'];
                    }
                    select_item_append(item['pid'], item['name'], vid, item['fullname'], 'm_');
                }
            };
            var keys = Object.keys(lproducts);
            for(var i = 0; i < keys.length; i++){
                var items = lproducts[keys[i]];
                for (var j = 0; j < items.length; j++) {
                    var item = items[j];
                    select_item_append(item['pid'], item['name'], item['vid'], item['fullname'], 'm_','lproduct');
                } 
            }
            $('#m_selected').val(JSON.stringify(data));
            $('#m_selected_lproducts').val(JSON.stringify(lproducts));
            return true; 
        });
    });

    //アプリケーション検索でdropdownを押した時にサポート終了を示すtooltipを消す
    /*function hide_is_support_end_tooltip(searched_list_selector){
        $(searched_list_selector).find('[data-toggle="tooltip"]').tooltip('hide');
    }
    $(document).on('shown.bs.dropdown', '#searched_list .dropdown', function(){hide_is_support_end_tooltip('#searched_list')});
    $(document).on('shown.bs.dropdown', '#m_searched_list .dropdown', function(){hide_is_support_end_tooltip('#m_searched_list')});
    $(document).on('shown.bs.dropdown', '#bulk_searched_list .dropdown', function(){hide_is_support_end_tooltip('#bulk_searched_list')});
    //このようにイベントを取ってtooltipの操作をしないと、dropdownが消えた後に変な位置(画面左上)にtooltipが残る
    function bind_support_end_btn(){
        $('[data-supportend]').on('mouseenter',function(){
            $('[data-supportend]').tooltip('hide');
            if($(this).find('.dropdown-menu') && !$(this).find('.dropdown-menu').hasClass('show')){
                $(this).tooltip('show');
            }
        });
        $('[data-supportend]').on('mouseleave',function(){
            $('[data-supportend]').tooltip('hide');
        });
        $('[data-supportend]').on('mousedown',function(){
            $('[data-supportend]').tooltip('hide');
        });
    }*/
    //アプリケーション検索のバージョン一覧作成
    /*function create_versions_list(pids, versions_array, menu_elm){
        versions_array.sort(function(a, b){
            var a_is_support_end = a['is_support_end'] ? -1 : 1;
            var b_is_support_end = b['is_support_end'] ? -1 : 1;
            if(a_is_support_end > b_is_support_end){
                 return -1;
            }else{
                 return 1;
            }
        });
        for (var j = 0; j < versions_array.length; j++) {
            var version = versions_array[j];
            p_onclick = 'select_item(' +
                        pids[i] +
                        ',\'' +
                        product['name'] + '\',' +
                        version['vid'] + ',\'' +
                        version['fullname'] +
                        '\',\'' + prefix + '\')';
            var p_ver = $('<a></a>', {
                            class: 'dropdown-item',
                            href: '#',
                            onclick: p_onclick
                        });
            if(version['is_support_end']){
                p_ver.attr({
                   'data-supportend': 'true',
                }).html('<span>&times;</span><span class="text-danger">' + version['fullname'] + '</span>');
            }else{
                p_ver.text(version['fullname']);
            }
            menu_elm.append(p_ver);
        }
        return menu_elm;
    }*/
    //アプリケーション検索
    var jqxhr = null;
    function display_products(prefix = ''){
        return function(){
            $('#edit-version-search-area').remove();
            $('.modal:visible').find('.editing-icon').removeClass('editing-icon');
            $('[data-toggle="tooltip"]').tooltip('hide');
            if(jqxhr){
                jqxhr.abort();
            }
            var keyword = $('#' + prefix + 'inc_search').val();
            var path = $('#sidfm_licenses_api_substr_search_path').val();
            jqxhr = $.get(path, { 'params[keyword]': keyword }, function(data) {
                if(keyword.length < 2){
                    $('#' + prefix + 'searched_list > *').remove();
                    $('#' + prefix + 'searched_lproducts_list > *').remove();
                    toggle_support_end_products_statement(false, prefix);
                    toggle_searched_lproducts_area(false, prefix);
                    if(keyword.length != 0){
                        $('#' + prefix + 'inc_search-tooltip').attr('data-original-title', '2文字以上入力して下さい').tooltip('show');
                    }else{
                        $('#' + prefix + 'inc_search-tooltip').tooltip('hide');
                    }
                }else{
                    var lproducts = data['lproducts'];
                    delete data['lproducts'];
                    var pids = Object.keys(data);
                    if(pids.length === 0 && lproducts.length === 0){
                        $('#' + prefix + 'inc_search-tooltip').attr('data-original-title', '該当するプロダクトはありません').tooltip('show');
                        toggle_support_end_products_statement(false, prefix);
                        toggle_searched_lproducts_area(false, prefix);
                    }else{
                        $('#' + prefix + 'inc_search-tooltip').tooltip('hide');
                        pids.sort(function(a, b){
                            var a_is_support_end = data[a]['product']['is_support_end'] ? -1 : 1;
                            var b_is_support_end = data[b]['product']['is_support_end'] ? -1 : 1;
                            if(a_is_support_end > b_is_support_end){
                                return -1;
                            }else{
                                return 1;
                            }
                        });
                    }
                    $('#' + prefix + 'searched_list > *').remove();
                    $('#' + prefix + 'searched_lproducts_list > *').remove();
                    for (var i = 0; i < pids.length; i++) {
                        var product = data[pids[i]]['product'];
                        var p_item = $('<span></span>', {
                            class: 'dropdown'
                        });
                        let prod_item = $('<button>').attr({
                            'class': 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                            'type': 'button',
                            'data-toggle': 'dropdown',
                            'aria-haspopup': 'true',
                            'aria-expanded': 'false',
                        });
                        if(product['is_support_end']){
                            p_item.attr({
                                'data-supportend': 'true',
                            });
                            prod_item.append(
                                $('<span>').html('&times;'),
                                $('<span>').attr('class', 'text-danger').text(product['name'])
                            );
                        }else{     
                            prod_item.text(product['name']);
                        }
                        p_item.append(prod_item);
                        var p_menu = $('<div></div>', {
                            class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                                   'aria-labelledby': 'm_searched_item_' + pids[i]
                        });
                        var p_onclick =
                            'select_item(' +
                             pids[i] +
                            ',\'' +
                            sanitize_string(product['name']) +
                            '\',0,\'\',\'' + prefix + '\')';
                        p_menu.append($('<a></a>', {
                            class: 'dropdown-item' + (product['is_support_end'] ? ' text-danger' : ''),
                            html: (product['is_support_end'] ? '<span class="text-dark">&times;</span>' : '') + '全て',
                            href: '#',
                            onclick: p_onclick
                        }));
                        var versions = data[pids[i]]['versions'];
                        if (versions) {
                            versions.sort(function(a, b){
                                var a_is_support_end = a['is_support_end'] ? -1 : 1;
                                var b_is_support_end = b['is_support_end'] ? -1 : 1;
                                if(a_is_support_end > b_is_support_end){
                                    return -1;
                                }else{
                                    return 1;
                                }
                            });
                            for (var j = 0; j < versions.length; j++) {
                                var version = versions[j];
                                p_onclick = 'select_item(' +
                                pids[i] +
                                ',\'' +
                                sanitize_string(product['name']) + '\',' +
                                version['vid'] + ',\'' +
                                sanitize_string(version['fullname']) +
                                '\',\'' + prefix + '\')';
                                var p_ver = $('<a></a>', {
                                    class: 'dropdown-item',
                                    href: '#',
                                    onclick: p_onclick
                                });
                                if(version['is_support_end']){
                                    p_ver.attr({
                                        'data-supportend': 'true',
                                    }).append(
                                        $('<span>').html('&times;'),
                                        $('<span>').attr('class', 'text-danger').text(version['fullname'])
                                    );
                                }else{
                                    p_ver.text(version['fullname']);
                                }
                                p_menu.append(p_ver);
                            }
                        }
                        p_item.append(p_menu);
                        $('#' + prefix + 'searched_list').append(p_item); 
                    }
                    //ローカルプロダクト
                    for (var i = 0; i < lproducts.length; i++) {
                        var lproduct_data = lproducts[i];
                        var lproduct = lproduct_data['product'];
                        var lversions = lproduct_data['versions'];
                        var p_item = $('<span></span>', {
                            class: 'dropdown lproduct-dropdown'
                        });
                        let lprod_item = $('<button>').attr({
                            class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle text-primary',
                            type: 'button',
                            'data-toggle': 'dropdown',
                            'aria-haspopup': 'true',
                            'aria-expanded': 'false',
                        });
                        if( lproduct['is_support_end'] ){
                            p_item.attr('data-supportend', 'true');
                            lprod_item.append(
                                $('<span>').attr('class', 'text-dark').html('&times;'),
                                $('<span>').attr('class', 'text-danger').text(lproduct['name'])
                            );
                        }else{
                            lprod_item.text(lproduct['name']);
                        }
                        p_item.append(lprod_item);
                        var p_menu = $('<div></div>', {
                            class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                                   'aria-labelledby': 'm_searched_item_' + lproduct['id']
                        });
                        var p_onclick =
                            'select_item(' +
                             lproduct['id'] +
                            ',\'' +
                            sanitize_string(lproduct['name']) +
                            '\',0,\'\',\'' + prefix + '\'' + ' ,\'true\')';
                        p_menu.append($('<a></a>', {
                            class: 'dropdown-item text-primary' + (lproduct['is_support_end'] ? ' text-danger' : ''),
                            html: (lproduct['is_support_end'] ? '<span class="text-dark">&times;</span>' : '') + '全て',
                            href: '#',
                            onclick: p_onclick
                        }));
                        if (lversions.length > 0) {
                            for (var j = 0; j < lversions.length; j++) {
                                var lversion = lversions[j];
                                p_onclick = 'select_item(' +
                                lproduct['id'] +
                                ',\'' +
                                sanitize_string(lproduct['name']) + '\',' +
                                lversion['id'] + ',\'' +
                                sanitize_string(lversion['fullname']) +
                                '\', \'' + prefix + '\'' + ', \'true\')';
                                var p_ver = $('<a></a>', {
                                    class: 'dropdown-item text-primary',
                                    href: '#',
                                    onclick: p_onclick
                                })
                                if( lproduct['is_support_end'] || lversion['is_support_end'] ){
                                    p_ver.addClass('text-danger');
                                    p_ver.append(
                                        $('<span>').attr('class', 'text-dark').html('&times;'),
                                        $('<span>').text(lversion['fullname'])
                                    );
                                }else{
                                    p_ver.text(lversion['fullname']);
                                }
                                p_menu.append(p_ver);
                            }
                        }
                        p_item.append(p_menu);
                        $('#' + prefix + 'searched_lproducts_list').append(p_item);
                    }
                    toggle_support_end_products_statement(true, prefix);
                    toggle_searched_lproducts_area(true, prefix);
                }
            });
        };
    }
		//return true;
	  //  }
	//});

    //})();


    // ホスト登録時のアプリケーション検索
   /* (function() {

	$('#inc_search').on('keyup', function() {
	    var f = $(this);
	    var old_f = $('#inc_search_old');
	    if (f.val() != old_f.val()) {
		old_f.val(f.val());
		var path = $('#sidfm_licenses_api_substr_search_path').val();
		$.get(path, { 'params[keyword]': f.val() }, function(data) {
        console.log(data)
		    var pids = Object.keys(data);
		    $('#searched_list > *').remove();
		    for (var i = 0; i < pids.length; i++) {
			var product = data[pids[i]]['product'];

			var p_item = $('<span></span>', {
			    class: 'dropdown'
			});
			p_item.append($('<button></button>', {
			    class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
			    type: 'button',
			    id: 'searched_item_' + pids[i],
			    'data-toggle': 'dropdown',
			    'aria-haspopup': 'true',
			    'aria-expanded': 'false',
			    text: product['name']
			}));
			var p_menu = $('<div></div>', {
			    class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
			    'aria-labelledby': 'searched_item_' + pids[i]
			});
			var p_onclick =
			    'select_item(' +
			    pids[i] +
			    ',\'' +
			    product['name'] +
			    '\',0,\'\')';
			p_menu.append($('<a></a>', {
			    class: 'dropdown-item',
			    text: '全て',
			    href: '#',
			    onclick: p_onclick
			}));

			var versions = data[pids[i]]['versions'];
			if (versions) {
			    for (var j = 0; j < versions.length; j++) {
				var version = versions[j];
				p_onclick = 'select_item(' +
				    pids[i] +
				    ',\'' +
				    product['name'] + '\',' +
				    version['vid'] + ',\'' +
				    version['fullname'] +
				    '\')';
				var p_ver = $('<a></a>', {
				    class: 'dropdown-item',
				    text: version['fullname'],
				    href: '#',
				    onclick: p_onclick
				});
				p_menu.append(p_ver);
			    }
			}
			p_item.append(p_menu);
			$('#searched_list').append(p_item);
		    }
		})
		return true;
	    }
	});
	return true;
    });*/

    // ソート
    $('.sort-hostname').on('click', sort_toggle('hostname'));
    $('.sort-category').on('click', sort_toggle('category'));
    $('.sort-os').on('click', sort_toggle('os'));
    $('.sort-agentprds').on('click', sort_toggle('agentprds'));
    $('.sort-prds').on('click', sort_toggle('prds'));
    $('.sort-refdate').on('click', sort_toggle('refdate'));
    $('.sort-memo').on('click', sort_toggle('memo'));
    $('.sort-manual').on('click', sort_toggle('manual'));
    $('.sort-agent').on('click', sort_toggle('agent'));

    // アプリケーション検索処理
    $('#inc_search').on('input', display_products(''));
    $('#m_inc_search').on('input', display_products('m_'));
    $('#bulk_inc_search').on('input', display_products('bulk_'));
    //$('#inc_search').on('keyup', inc_search_keyup(''));
    //$('#m_inc_search').on('keyup', inc_search_keyup('m_'));
    //$('#bulk_inc_search').on('keyup', inc_search_keyup('bulk_'));
   
    //メモ更新時の文字チェック
    $('#inputMemo').on('input', function(){
        var memo = $(this).val();
        var memo_max_size = parseInt($('#max-memo-size').val());
        if(memo.length > memo_max_size){
            $('#update-memo-label').text(memo_max_size + '文字以内で入力して下さい').css('color', 'red').show();
            $('#execute-update-memo').prop('disabled', true);
        }else{
           $('#update-memo-label').hide();
           $('#execute-update-memo').prop('disabled', false);
        }
        if(memo_before_update === memo){
           $('#execute-update-memo').prop('disabled', true);
        } 
    });
    $('#form_update_memo').on('submit', function(){
        if($('#execute-update-memo').attr('disabled')){
            return false;
        }
    });
    $('#form_regist_host').on('submit', function(){
        if($('#new_host_regist_btn').attr('disabled')){
            return false;
        }
    });
    $('#execute-update-memo').on('click', function(){
         $('#form_update_memo').submit();
    });

    //メモ一括更新の文字数チェック
    $('#inputMemoBulk').on('input', function(){
        var memo = $(this).val();
        var memo_max_size = parseInt($('#max-memo-size').val());
        if(memo.length > memo_max_size){
            $('#update-bulk-memo-notice').text(memo_max_size + '文字以内で入力して下さい').css('color', 'red').show();
            $('#update-bulk-memo-submit-button').prop('disabled', true);
        }else{
           $('#update-bulk-memo-notice').hide();
           $('#update-bulk-memo-submit-button').prop('disabled', false);
        }
    });

    $('#new_host_regist_btn').on('click', function(){
        var conf = true;
        var date = new Date($('#inputRefdateNew').val());
        var today = new Date();
        if(date.getFullYear() === today.getFullYear() && date.getMonth() === today.getMonth() && date.getDate() === today.getDate()){
            conf = confirm('基準日が本日に設定されているため、このまま登録すると昨日以前に公開された脆弱性については検出されません。\nこのままホストを登録する場合はOKを、基準日を変更する場合はキャンセルを選択して下さい。');
        } 
        if(conf){
            $('#form_regist_host').submit();
        }else{
            return false;
        }
    });
    
    //ホスト新規登録時に登録可能かチェック
    $('#categories_new_unselect_category, #categories_new_select_category').on('click',check_register_validity);        
    $('#form_hostname, #form_memo, #form_display_name').on('input',check_register_validity);
    $('#inputRefdateNew').on('change',check_register_validity);

    const max_hostname_byte_length = $('#max-hostname-byte-length').val();
    const max_display_name_length = $('#max-display-name-length').val();
    function check_register_validity(){
            var path = $('#sidfm_licenses_api_validate_new_host_path').val();
             $.get(path)
            .done(function(data) {
            var existing_hostnames = data;
            var err_flag = 0;
            var same_hostname_flag = 0;
            var is_admin = JSON.parse($('#self_user_role').val()).includes('admin');
            var hostname = $('#form_hostname').val();
            var display_name = $('#form_display_name').val();
            var memo = $('#form_memo').val();
            var date = $('#inputRefdateNew').val();
            var date_for_validation = new Date(date);
            date = date.replace(/\//g, ',');
            var month = date.split(',')[1] - 1;
            if(date_for_validation.getMonth() != month){
                err_flag = 1;
                $('#warning-date').show();
            }else{
                $('#warning-date').hide();
            }
            existing_hostnames.forEach(function(e_hostname){
                if(e_hostname === hostname){
                    $('#warning-hostname').text('同名のホストが登録されています').show();
                    same_hostname_flag = 1;
                    err_flag = 1;
                }
            });
            if(hostname === ''){
                err_flag = 1;
                $('#warning-hostname').hide();
            }else if(!hostname.match(/^[\x20-\x7e]*$/)){
                $('#warning-hostname').text('半角英数字で入力して下さい').show();
                err_flag = 1;
            }else if(hostname.match(/\s/)){
                $('#warning-hostname').text('空白文字は使用できません').show();
                err_flag = 1;
            }else if(!hostname.match(/^[0-9a-zA-Z._-]*$/)){
                $('#warning-hostname').text('使用できない文字が含まれています').show();
                err_flag = 1;
            }else if(encodeURIComponent(hostname).replace(/%../g,"x").length > max_hostname_byte_length){
                $('#warning-hostname').text(max_hostname_byte_length + 'バイトを超えるホスト名は登録できません').show();
                err_flag = 1;
            }else{
                if(same_hostname_flag === 0){
                    $('#warning-hostname').hide();
                }
            }
            if(display_name.match(/<|>|"|'/)){
                $('#warning-display-name-of-register').text('使用できない文字(<>"' + "'" + ')が含まれています').show();
                err_flag = 1;
            }else if(display_name.length > 0 && display_name.trim().length === 0){
                $('#warning-display-name-of-register').text('空白文字のみだけの表示名は登録できません').show();
                err_flag = 1;
            }else if(display_name.length > max_display_name_length){
                $('#warning-display-name-of-register').text(max_display_name_length + '文字を超える表示名は登録できません').show();
                err_flag = 1;
            /*}else if(display_name.length === 0){
                $('#warning-display-name-of-register').hide();
                err_flag = 1;*/
            }else if(display_name.match(/&&&&&/)){
                $('#warning-display-name-of-register').text('「&&&&&」の文字列(5つ連なるアンド)は使用できません' ).show();
                err_flag = 1;
            }else{
                $('#warning-display-name-of-register').hide();
            }
            var memo_max_size = parseInt($('#max-memo-size').val());
            if(memo.length > memo_max_size){
                err_flag = 1;
                $('#warning-memo').text(memo_max_size + '文字以内で入力して下さい').show();
            }else{
                $('#warning-memo').hide();
            }
            if(!is_admin){
                if($('#categories_new_selected_categories option').length === 0){
                    err_flag = 1;
                    $('#warning-no-category').show();
                }else{
                    $('#warning-no-category').hide();
                 
                }
            } 
            if(err_flag === 1){
                $('#new_host_regist_btn').prop('disabled', true);
            }else{
                 $('#new_host_regist_btn').prop('disabled', false);
            }
       });
    }
    function move_selected_items_for_new_host(p_selected_ids, p_current_selected, p_opposite_selected, flg_reverse) {
        var selected_ids = JSON.parse($(p_selected_ids).val());
        var options = $(p_current_selected + ' > option:selected');
        for (var i = 0; i < options.length; i++) {
            var option = $(options[i]);
            var s_id = parseInt(option.val());
            var s_text = option.text();
            var desc = option.data('title');
            if (flg_reverse) {
                selected_ids = selected_ids.filter(function(x, i, self) {
                    return x != s_id;
                });
                selected_ids = selected_ids.filter(function(x, i, self) {
                    return self.indexOf(x) == i;
                });
            } else {
               selected_ids.push(s_id);
               selected_ids = selected_ids.filter(function(x, i, self) {
                   return self.indexOf(x) == i;
               });
            }
            $(p_selected_ids).val(JSON.stringify(selected_ids));
            $(p_opposite_selected).append(
                 $('<option></option>', { value: s_id, text: s_text, class: 'text-truncate g-max-width-21em', 'data-toggle': 'tooltip', 'data-title': desc, 'data-placement': 'right', 'data-boundary': 'window' })
            );
        }
        $(p_current_selected + ' > option:selected').remove();
        $(p_opposite_selected).find('option').tooltip();
        return false;
    }
    //クリップボードのコピー
    const clipboard = new ClipboardJS('.copybtn');
    const clipboard_supported = ClipboardJS.isSupported();
    //クリップボードがサポートされていなければアラートを表示
    $(document).on('mousedown', '.copybtn', function(e) {
        if(clipboard_supported === false) {
            alert('このブラウザではコピー機能はサポートされておりません');
            return false;
        }
    });
        
    var isSuccess = false;   
    /*$('.action-open-list').on('click', function(e){
        $(this).on('hide.bs.dropdown', function(){
            if(isSuccess === true){
                var btn = $(this).find('.product-btn').tooltip('show');
                isSuccess = false;
                setTimeout(function (){
                    btn.tooltip('hide');
                },1000);
            }
        });
    });*/
    $('.action-open-list').on('click', function(e){
        $(this).closest('.balloon-dropdown').on('hide.bs.dropdown', function(){
            if(isSuccess === true){
                var btn = $(this).find('.copy-tooltip-btn').tooltip('show');
                isSuccess = false;
                setTimeout(function (){
                    btn.tooltip('hide');
                },1000);
            }
        });
    });
    

    $('#new-export-btn').on('click', function(){
        var conf = confirm('ファイルをダウンロードします');
        if( !conf ){
            return false;
        }
        var is_err = false;
        var message = '';
        var progress_window = get_progress_bar('get');
        $('body').append(progress_window);
        var export_path = $('#sidfm_licenses_new_export_path').val();
        var checked = $('#pages_checked').val();
        var total_hosts = 0;
        var executed_hosts = 0;
        var export_file = $.ajax({
            url: export_path ,
            type: 'POST',
            data: { 'checked': checked, 'process': 'start_export' },
        }).done(function(res){
            if( res['err'] ){
                is_err = true;
                message = res['message']
            }else{
                total_hosts = res['total_hosts'];
            }
        }).fail(function(){
            message = 'ファイルのエクスポートに失敗しました。';
            $('#pages_checked').val('[]');
            $('#pages_all_checked').val('false');
            $('#pages_form').submit();
        });

        $.when(export_file).done(function(){
            if( is_err ){
                alert(message + '画面をリロードします。');
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit();
                return false;
            }

            var is_end = false;
            var progress_export = function(){
                $.ajax({
                    url: export_path ,
                    type: 'POST',
                    data: { 'process': 'progress_export', 'executed_size': executed_hosts },
                }).done(function(res){
                    if( res['err'] ){
                        is_err = true;
                        message = res['message'];
                        alert(message + '画面をリロードします。');
                        $('#pages_checked').val('[]');
                        $('#pages_all_checked').val('false');
                        $('#pages_form').submit();
                    }else if( res['executed_hosts'] == 0 ){
                        is_end = true;
                        $('#form-new-export').submit();
                        $('#progress-bar-label').text('ファイル送信中...');
                        var timer = setInterval(function(){
                            if( $.cookie('export_flg') ){
                                setTimeout(function(){//probress barのbarが満たされるまで待つ
                                    $.cookie('export_flg',"",{path:"/",expires:-1});
                                    $('#progress-window').remove();
                                },500);
                                clearInterval(timer);
                            }     
                        },10);
                    }else{
                        executed_hosts += res['executed_hosts'];
                        var percentage = (executed_hosts / total_hosts * 100);
                        if( percentage >= 99 && percentage < 100 ){
                            percentage = 99;
                        }else{
                            percentage = Math.round(percentage);
                        }
                        $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                    }
                    if( !is_err && !is_end ){
                        progress_export();
                    }
                }).fail(function(){
                    is_err = true
                    message = 'ファイルのエクスポートに失敗しました。';
                });
            };
     
            progress_export();
  
            if( is_err ){
                alert(message + '画面をリロードします。');
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('false');
                $('#pages_form').submit();
            }
        });
    });

    /*$(document).on('click', '.close-list', function(e){
        isSuccess = false;
        $(e.target).closest('.popover').popover('hide');
    });*/
 
    clipboard.on('success', function(e) {
        isSuccess = true;
        $(e.trigger).closest('.popover').popover('hide'); 
        e.clearSelection();
    });

    clipboard.on('error', function(e) {
        alert('コピーに失敗しました');
        e.clearSelection();
    });
    
    if($('#HostTable').length === 1){
        sticky_control('HostTable', 'licence');
    }
 /* $('.synchronize-status-btn').on('show.bs.dropdown',function(){
      $(this).tooltip('hide');
      $(this).tooltip('disable');
      $(this).find('.select-synchro-time').addClass('synchro-time-show');
  });
  $('.synchronize-status-btn').on('hidden.bs.dropdown',function(){
      $(this).tooltip('enable');
      $(this).find('.select-synchro-time').removeClass('synchro-time-show');
  });
  $('.synchronize-status-btn option').on('click', function(e){
      e.stopPropagation();
  });*/
  
   //同期ボタンを押した時に設定時間を表示する。bootstrapのdropdown等で実装したが、不具合になるため独自に実装
   $('.synchronize-status-btn').on('click', function(){
       $('.synchronize-status-btn').removeClass('selected-sync-btn');
       var sync_button = $(this);
       var hostid = sync_button.attr('data-value');
       sync_button.closest('[data-toggle="tooltip"]').tooltip('hide');
       if($('#select-synchro-time').attr('data-syncid') === hostid){
           $('#select-synchro-time').remove();
           return false;
       }else{
           $('#select-synchro-time').remove();
           sync_button.addClass('selected-sync-btn');
           var wrap = $('<div>').attr({
               'id': 'select-synchro-time',
               'class': 's-shadow-v7 position-fixed z-index-100 sync-times-menu g-bg-gray-v4',
               'data-syncid': hostid
           }).hide();
           var menu = $('<select>').attr({
               'class': 'w-100 g-brd-none',
               'multiple': true,
           });
           var op = $('<option>').attr('class', 'sync-time-item').text('0～10分後').val('-1');
           menu.append(op);
           for(var i = 0; i < 24; i++){
               var op = $('<option>').attr('class', 'sync-time-item').text(i + '時').val(String(i));
               menu.append(op);
           }
           var set_btn = $('<div>').append(
                             $('<button>').attr({
                                 'type': 'button',
                                 'id': 'execute-set-last-checked-at', 
                                 'class': 'btn btn-sm btn-primary float-right pt-0',
                                 'value': hostid
                             }).css({'margin': '0 2px 2px', 'height': '20px'})
                               .prop('disabled', true)
                               .text('設定')
                         );
           wrap.append(menu, set_btn);
           $('body').append(wrap);
           var offset = sync_button.offset();
           var ActionArea_top = $('#wrap-ActionArea').offset().top;
           wrap.offset({
               'top': (ActionArea_top < (offset.top + wrap.outerHeight() + sync_button.outerHeight())) ? offset.top - wrap.outerHeight() : offset.top + sync_button.outerHeight(),
              'left': offset.left
           }).show();
           /*wrap.offset({
               'top': offset.top + sync_button.outerHeight(),
               'left': offset.left
           }).show();*/
           bind_synchro_elms();
       }
   });
   
  function bind_synchro_elms(){        
      $('#select-synchro-time').on('change',function(){
          if($(this).find('option:selected').length > 0){
               $('#execute-set-last-checked-at').prop('disabled', false);
          }else{
              $('#execute-set-last-checked-at').prop('disabled', true);
          }
      });           

      $('#execute-set-last-checked-at').on('click', function(e){
          $('.popover').css('z-index', '500');
      //var synchro_status_btn = $(this).closest('.synchronize-status-btn');
          var hostid = $(this).val();
          var time = $('#select-synchro-time option:selected').val();
          var value = {'hostid':hostid, 'time':time}
          $('#param_set_last_checked_at').val(JSON.stringify(value));
          var path = $('#sidfm_licenses_api_get_new_last_checked_at_path').val();
          $.post(path, {'time_with_hostid': JSON.stringify(value)})
          .done(function(data){
              var set_time = data[0];
              var synchro_time = data[1];
              var backdrop = $('<div>').attr('class', 'backdrop');
              $('body').append(backdrop);
              var alert_window = $('<div>').attr('class', 'synchro-alert');
              var message = $('<div>').attr('class', 'd-flex');
              var wrap_ex_mark = $('<div>').attr('class', 'mr-3 ml-2');
              var ex_mark = $('<i>').attr('class', 'fas fa-exclamation-circle fa-3x ex-mark');
              wrap_ex_mark.append(ex_mark);
              message.append(wrap_ex_mark);
              if(set_time == 'now'){
                  var message_text = $('<div>').attr('class', 'mr-1')
                                               .html('<div class="mb-2">次の同期を <span class="font-weight-bold">0～10分後</span>に実行します。<br>よろしいですか？</div><div class="g-font-size-13 g-line-height-1_4 mb-3">※複数のホストでの同期処理による不具合を避ける処理を行っているため、複数のホストの同期時刻を同じに設定すると実際の同期時刻が遅れる場合があります。</div>'); 
                  alert_window.addClass('');
              }else{
                  var message_text = $('<div>').attr('class', 'mr-1')
                                               .html('<div class="mb-2">次の同期を <span class="font-weight-bold">' + synchro_time + ' </span>に実行します。<br>よろしいですか？</div><div class="g-font-size-13 g-line-height-1_4 mb-1">※現在、設定されている脆弱性更新日時から 24時間経過した後のタイミングで日時が設定されます。</div><div class="g-font-size-13 g-line-height-1_4 mb-3">※複数のホストでの同期処理による不具合を避ける処理を行っているため、複数のホストの同期時刻を同じに設定すると実際の同期時刻が遅れる場合があります。</div>' );
                 // alert_window.addClass('');
              }
              message.append(message_text);
              alert_window.append(message);
              var div = $('<div>').attr('class', 'd-flex justify-content-end');
              var ok_btn = $('<button>').attr({
                               'class': 'g-font-size-13 alert-ok-btn btn btn-xs btn-primary text-nowrap',
                               'type': 'button'
                           }).text('実行');
              var cancel_btn = $('<button>').attr({
                                   'class': 'g-font-size-13 ml-1 alert-cancel-btn btn btn-xs btn-secondary text-nowrap',
                                   'type':'button'
                               }).text('キャンセル');
              div.append(ok_btn);
              div.append(cancel_btn);
              alert_window.append(div);
              $('body').append(alert_window.hide());
              alert_window.offset({
                  'top': ($(window).height() / 2 - alert_window.height() / 2) + $(window).scrollTop(), 
                  'left': $(window).width() / 2 - alert_window.width() / 2
              }).show();
              $('body').css('overflow', 'hidden');
              //var offset = $('#select-synchro-time').offset();
              //alert_window.offset({'top':offset.top - alert_window.height() - 3, 'left':offset.left - 10});
              $('#wrap-ActionArea').css('z-index', '500'); 
              $('#floating-scroll').css('z-index', '500');
          });
          e.stopPropagation();
      });
  }
   
  $(document).on('click', function(e){
      if(e.target){
          var t_elm = $(e.target);
          if(!t_elm.hasClass('synchronize-status-btn') &&
             t_elm.attr('id') != 'select-synchro-time' &&
             t_elm.closest('#select-synchro-time').length === 0
          ){
              $('#select-synchro-time').remove();
          }
      }
  });

  $(window).on('resize', function(){
      if($('.synchro-alert').length === 1){
          var alert_window = $('.synchro-alert');
          alert_window.offset({
              'top': ($(window).height() / 2 - alert_window.height() / 2) + $(window).scrollTop(), 
              'left': $(window).width() / 2 - alert_window.width() / 2
          });
      }
      if($('#select-synchro-time').length === 1){
          var target = $('.selected-sync-btn');
          var offset = target.offset();
          $('#select-synchro-time').offset({
              'top': offset.top + target.outerHeight(),
              'left': offset.left
          });
      }
      set_version_list_placement();
  });

  $(document).on('click', '.backdrop', function(e){
      e.stopPropagation();
  });

  $(document).on('click', '.synchro-alert', function(e){
      e.stopPropagation();
  });
  
  $(document).on('click', '.alert-ok-btn', function(){
      $('#form_set_last_checked_at').submit();
  });

  $(document).on('click', '.alert-cancel-btn', function(e){
      $('body').css('overflow', ''); 
      $('.synchro-alert').remove();
      $('.backdrop').remove();
      $('#wrap-AcrionArea').css('z-index', '1045');
      $('#floating-scroll').css('z-index', '1060');
      $('.popover').css('z-index', '1060');
      e.stopPropagation();
  });


  $(window).on('load', function() {
      if($('[data-outertable="scroll"]').length > 0){
          setTimeout(function(){
              set_scroll();
              $(window).on('resize scroll', set_scroll);
          },200);
      }
  });

  $('.modal').on('show.bs.modal', function(){
      $('.popover').css('z-index', '100');
  });
  $('.modal').on('hidden.bs.modal',function(){
      $('.popover').css('z-index', '1060');
  });

  $('.close-messages').on('click', function(){
      var remove_target = $(this).attr('data-remove');
      $('[data-message="' + remove_target + '"]').remove();
  });

  $('#submit-new-import-file').on('click', function(){
      var import_path = $('#sidfm_licenses_new_import_path').val();
      var progress_opts_path = $('#sidfm_licenses_progress_import_opts_path').val();
      var progress_hosts_path = $('#sidfm_licenses_progress_import_hosts_path').val();
      var fd = new FormData();
      var file_elm = $('#new-import-file');
      var file = file_elm.get(0).files[0];
      if( !file ){
          alert('ファイルを選択して下さい。');
          return false;
      }
      fd.append(file_elm.attr('name'), file);
      var progress_window = get_progress_bar();
      $('body').append(progress_window);
      var percentage = 0;
      var total_size = 0;
      var executed_size = 0;
      var is_err = false;
      var import_file = $.ajax({
          url: import_path, 
          type: 'POST',
          data: fd,
          processData: false,
          contentType: false,
      }).done(function(res){
          if( res['err'] ){
              is_err = true;
              alert('ファイルのインポートに失敗しました。画面をリロードします。');
              $('#pages_checked').val('[]');
              $('#pages_all_checked').val('false');
              $('#pages_form').submit();
          }
          total_size = res['total_size'];
      }).fail(function(){
          alert('ファイルのインポートに失敗しました。画面をリロードします。');
          $('#pages_checked').val('[]');
          $('#pages_all_checked').val('false');
          $('#pages_form').submit();
      });

      var exec_progress_import_hosts = function(){
          $.ajax({
              url: progress_hosts_path,
              type: 'GET',
          }).done(function(res){
              if( res['err'] ){
                  if( !is_err ){
                      is_err = true;
                      alert('ファイルのインポートに失敗しました。画面をリロードします。');
                      $('#pages_checked').val('[]');
                      $('#pages_all_checked').val('false');
                      $('#pages_form').submit();
                  }
              }else{
                  if( res['executed_size'] == 0 ){
                      if( res['is_change'] ){
                          setTimeout(function(){//probress barのbarが満たされるまで待つ
                              window.location = $('#sidfm_licenses_import_path').val();
                          },800);
                      }else{
                          $('#pages_checked').val('[]');
                          $('#pages_all_checked').val('false');
                          $('#pages_form').submit();
                      }
                  }else{
                      executed_size += res['executed_size'];
                      var percentage = (executed_size / total_size * 100);
                      if( percentage >= 99 && percentage < 100 ){
                          percentage = 99;
                      }else{
                           percentage = Math.round(percentage);
                      }
                      $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                      if( !is_err ){
                          exec_progress_import_hosts();
                      }
                  }
              }
          });
      };

      var exec_progress_import_opts = function(){
          var req = $.ajax({
              url: progress_opts_path,    
              type: 'GET',
          }).done(function(res){
              if( res['err'] ){
                  if( !is_err ){
                      is_err = true;
                      alert('ファイルのインポートに失敗しました。画面をリロードします。');
                      $('#pages_checked').val('[]');
                      $('#pages_all_checked').val('false');
                      $('#pages_form').attr('action', $('#sidfm_licenses_index_r_path').val()), submit();
                  }
              }else{
                  if( !res['is_complete'] ){
                      executed_size += res['executed_size'];
                      var percentage = (executed_size / total_size * 100);
                      if( percentage >= 99 && percentage < 100 ){
                          percentage = 99;
                      }else{
                          percentage = Math.round(percentage);
                      }
                      $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                      if( !is_err ){
                          $.when(req).done(function(){ exec_progress_import_opts() });
                      }
                  }else{
                      //optsのデータ読み込み完了後
                      exec_progress_import_hosts();    
                  }
              }
          }).fail(function(){
              is_err = true;
          });
      }
      $.when(import_file).done(function(){
          if( !is_err ){
              exec_progress_import_opts();
              if(is_err){
                  alert('ファイルのインポートに失敗しました。画面をリロードします。');
                  $('#pages_checked').val('[]');
                  $('#pages_all_checked').val('false');
                  $('#pages_form').attr('action', $('#sidfm_licenses_index_r_path').val()), submit();
              }
          }
      });
      
  });

 
  //popoverのバルーンが、サマリー表の一番上もしくは一番下に到達したらバルーンを非表示にする
  $(window).on('scroll', function(){
      if($('#select-synchro-time').length === 1){
          var target = $('.selected-sync-btn');
          var offset = target.offset();
          $('#select-synchro-time').offset({
              'top': offset.top + target.outerHeight(),
              'left': offset.left
          });
      }
      var bottom_of_header = $('#HEADnavi').outerHeight(true);
      if($('#wrap-ActionArea').length > 0){
          var bottom_of_summary_table = $('#wrap-ActionArea').offset().top - 10;
          $('.popover[class*="show"]').each(function(){
              var balloon_offset_top = $(this).offset().top;
              if(balloon_offset_top - $(window).scrollTop() <= bottom_of_header || balloon_offset_top + $(this).outerHeight(true) >= bottom_of_summary_table){
                  $('[data-toggle="popover"]').popover('hide');
                  return false;
              }
          });
      }
  });

  function execute_toggle_delete_host(host_id, sidfmd_host_id, rule_info = '{}', is_undelete_host = false){
      var html_ids = [];
      var err_message = '';
      var toggle_host_path = $('#sidfm_licenses_toggle_host_delete_path').val();
      var get_related_html_ids_path = $('#sidfm_internal_api_get_host_view_related_htmlids_path').val();

      function start_execute_toggle_delete_host(){
          var toggle_host = $.ajax({
              type: 'POST',
              url: toggle_host_path,
              data: { 'host_id': host_id, 'sidfmd_host_id': sidfmd_host_id, 'rule_info': rule_info }
          }).done(function(data){
              err_message = data['err_message'];
          });
 
          if( !is_undelete_host ){
              var get_related_html_ids = $.ajax({
                  type: 'POST',
                  url: get_related_html_ids_path,
                  data: { 'host_ids': JSON.stringify([ sidfmd_host_id ]) }
              }).done(function(related_html_ids){
                  html_ids.push(...related_html_ids);
              });

              $.when(toggle_host, get_related_html_ids).done(function(){
                  if( err_message.length > 0 ){
                      alert(err_message);
                      $('#pages_checked').val('[]');
                      $('#pages_all_checked').val('false');
                      $('#pages_form').submit(); 
                  }else{
                      if( !is_undelete_host ){
                          update_view([parseInt(sidfmd_host_id)], Array.from(new Set(html_ids)), true);
                      }else{
                          $('#pages_checked').val('[]');
                          $('#pages_all_checked').val('false');
                          $('#pages_form').submit();
                      }
                  }
              });
          }else{
              $.when(toggle_host).done(function(){
                  $('#pages_checked').val('[]');
                  $('#pages_all_checked').val('false');
                  $('#pages_form').submit();
              });
          }
      }

      if( !is_undelete_host ){
          //削除の場合は、削除前と削除後の両方でホストに関連するhtml_idsを取得する必要がある
          var progress_window = get_progress_bar();
          $('body').append(progress_window);
          var get_related_html_ids = $.ajax({
              type: 'POST',
              url: get_related_html_ids_path,
              data: { 'host_ids': JSON.stringify([ sidfmd_host_id ]) }
          }).done(function(related_html_ids){
              html_ids = related_html_ids;
          });
          start_execute_toggle_delete_host();
      }else{
          start_execute_toggle_delete_host();
      }
  }

  //ホスト復元
  $('[data-undelhost]').on('click', function(){
      var conf = confirm('復元してよろしいですか?');
      if( conf ){
          var host_id = $(this).attr('data-hostid');
          var sidfmd_host_id = $(this).attr('data-sidfmdhostid');
          execute_toggle_delete_host(host_id, sidfmd_host_id, '{}', true);
      }
  });
  
  //ホスト削除時にルールをチェック
  $('[data-delhost]').on('click', function(){
      var button = $(this);
      var sidfmd_host_id = button.attr('data-sidfmdhostid');
      var host_id = button.attr('data-hostid');
      //var submit_target = '[data-formdel="host_' + del_hostid + '"]';
      $('#execute-action-with-related-rules').attr({
          //'data-submit': submit_target,
          'data-name':  'params',
          'data-hostid': host_id,
          'data-sidfmdhostid': sidfmd_host_id
      }); 
      //var form = $(submit_target);
      var path = $('#sidfm_internal_api_check_related_rules_path').val();
      $.ajax({ 
          url: path,
          type: 'POST',
          data: {'page_name': 'hostadmin', 'delete_id': sidfmd_host_id, 'action_idx': 'delete_one_host'}
      }).done(function(data){
          if( data['is_unchangeable_host'] ){
              alert_unchangeable_host_related_rules('ホストの削除');
              return false;
          }
          var rule_messages = data['rule_messages'];
          var rule_names = Object.keys(rule_messages);
          if(rule_names.length > 0){
            delete data['rule_messages'];
            $('#execute-action-with-related-rules').attr({
                'data-ruleinfo': JSON.stringify(data),
                'data-action': 'toggle_delete_host'
            });
            $('#RuleInfoArea > *').remove();
            $('#modalConfRelatedRules').modal('show');
            rule_names.sort();
            for(var i = 0; i < rule_names.length; i++){
                var rule_name = rule_names[i];
                var rule_message = rule_messages[rule_name];
                var item_name = rule_message['item_name'];
                var content = rule_message['content'];
                var reason = rule_message['reason'];
                var tr = $('<tr>').attr('class', 'list_alternative');
                var rule_name_td = $('<td>').attr('class', 'rule-name').text(rule_name);
                var item_td = $('<td>').attr('class', 'rule-item').text(item_name);
                var message_td = $('<td>').attr('class', 'rule-changes').text(content);
                var reason_td = $('<td>').attr('class', 'rule-reason').text(reason);
                tr.append(rule_name_td, item_td, message_td, reason_td);
                $('#RuleInfoArea').append(tr);
            }
          }else{
              var conf = confirm('削除してもよろしいですか?');
              if(!conf){
                  return false;
              }else{
                  //form.submit();
                  execute_toggle_delete_host(host_id, sidfmd_host_id, '{}');
              }
          }
      });
  });

  //インポートページで実行するときに、progress_bar表示
  function execute_import_with_progress_bar(actions){
      var percentage = 0;
      var progress_window = get_progress_bar();
      $('body').append(progress_window);
      var import_apply_path = $('#sidfm_licenses_new_import_apply_path').val();
      var executed_actions = 0;
      var total_actions = actions.length;
      var err_messages = new Set();
      var err_cnt = 0;
      var cnt = 0;
      var is_exec_synchro_hosts = $('#is-exec-synchro-hosts').prop('checked');
      var send_data_of_import = function(send_action_data){
          $.ajax({
              type: 'POST',
              url: import_apply_path,
              data: send_action_data,
         }).done(function(result){
              err_message = result['err_message'];
              if( err_message.length > 0 ){
                  err_messages.add(err_message);
                  err_cnt += 1;
              }
              executed_actions += 1;
              var percentage = (executed_actions / total_actions) * 100;
              if( percentage >= 99 && percentage < 100 ){
                  percentage = 99;
              }else{
                  percentage = Math.round(percentage);
              }
              $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
              if( percentage == 100 ){
                  setTimeout(function(){//progress barのbarが満たされるまで待つ
                      if(err_messages.size > 0){
                          err_messages = Array.from(err_messages);
                          alert(err_messages.join('\n') + (err_cnt == total_actions ? '' : '\n※他のデータ登録は完了しています。') + '\nホスト設定画面に移動します。');
                          location.href = $('#sidfm_licenses_index_path').val();
                      }else{
                          location.href = $('#sidfm_licenses_index_path').val();
                      }
                  },800);
              }else{
                  var action = actions[cnt];
                  cnt += 1;
                  send_data_of_import({
                      'action_data': JSON.stringify(action),
                      'is_exec_synchro_hosts': is_exec_synchro_hosts
                  });
              }
          })
      };

      var action = actions[cnt];
      cnt += 1;
      send_data_of_import({
          'action_data': JSON.stringify(action),
          'is_exec_synchro_hosts': is_exec_synchro_hosts,
          'rule_info': $('#submit-related-rules-item-form').attr('data-ruleinfo')
      });

  }
 
  //インポートページで変更するホストに関連するルールのチェック
  $('.execute-submit-import_apply-form').on('click', function(){
      var progress = $('<div>').attr('class', 'progress-wait-area').append(
          $('<div>').attr({'class': 'progress-wait-area-label'}).text('お待ちください...')
      );
      var progress_window = $('<div>').attr({'id': 'progress-window', 'class': 'progress-window'}).append(progress);
      $('body').append(progress_window);

      var button = $(this);
      //var is_new_import = $('#is-new-import').val() === 'true' ? true : false;
      var actions_data = JSON.parse($('#actions').val());
      var del_host_ids = JSON.parse($('#rule-del-host-ids').val());
      var cat_change_hostnames = JSON.parse($('#rule-cat-change-hostnames').val());
      var del_hostid = button.attr('data-delhost');
      var submit_target = '#import_apply';
      $('#submit-related-rules-item-form').attr({
          'data-submit': submit_target,
          'data-name': 'params',
      });
      var form = $(submit_target);
      var path = $('#sidfm_internal_api_check_related_rules_path').val();
      $('#submit-related-rules-item-form').attr('data-ruleinfo', '{}');
      $.ajax({
          url: path,
          type: 'POST',
          data: {
              'page_name': 'hostadmin', 
              'host_ids': JSON.stringify(del_host_ids), 
              'hostnames': JSON.stringify(cat_change_hostnames), 
              'action_idx': 'import'
          },
      }).done(function(data){
          if( data['is_unchangeable_host'] ){
              alert_unchangeable_host_related_rules('インポート');
              $('#progress-window').remove();
              return false;
          }
          var rule_messages = data['rule_messages'];
          var rule_names = Object.keys(rule_messages);
          if(rule_names.length > 0){
              delete data['rule_messages'];
              $('#submit-related-rules-item-form').attr('data-ruleinfo', JSON.stringify(data));
              $('#RuleInfoArea > *').remove();
              $('#progress-window').remove();
              $('#modalConfRelatedRules').modal('show');
              rule_names.sort();
              for(var i = 0; i < rule_names.length; i++){
                  var rule_name = rule_names[i];
                  var rule_message = rule_messages[rule_name];
                  var item_name = rule_message['item_name'];
                  var content = rule_message['content'];
                  var reason = rule_message['reason'];
                  var tr = $('<tr>').attr('class', 'list_alternative');
                  var rule_name_td = $('<td>').attr('class', 'rule-name').text(rule_name);
                  var item_td = $('<td>').attr('class', 'rule-item').text(item_name);
                  var message_td = $('<td>').attr('class', 'rule-changes').text(content);
                  var reason_td = $('<td>').attr('class', 'rule-reason').text(reason);
                  tr.append(rule_name_td, item_td, message_td, reason_td);
                      $('#RuleInfoArea').append(tr);
              }
          }else{
              $('#progress-window').remove();
              execute_import_with_progress_bar(actions_data);
          }
      });
  });

    //関連するルールを確認するmodalでOKボタンを押した時にformをsubmitする
    //(import確認画面用)
    $('#submit-related-rules-item-form').on('click', function(){
        var button = $(this);
        var target = button.attr('data-submit');
        var name = button.attr('data-name');
        //var is_new_import = $('#is-new-import').val() === 'true' ? true : false;
        //if( is_new_import ){
            var actions_data = JSON.parse($('#actions').val());
            execute_import_with_progress_bar(actions_data);
        //}else{
        //    var ruleinfo = button.attr('data-ruleinfo');
        //    var form = $(target);
        //    form.append(
        //        $('<input>').attr({'type': 'hidden', 'name': name + '[rule_info]'}).val(ruleinfo)
        //    ).submit();
        //}
    });

    //(index_rページ用)
    $('#execute-action-with-related-rules').on('click', function(){
        var button = $(this);
        var action = button.attr('data-action');
        var rule_info = button.attr('data-ruleinfo');
        if( action === 'toggle_delete_host' ){ 
            var host_id = button.attr('data-hostid');
            var sidfmd_host_id = button.attr('data-sidfmdhostid');
            execute_toggle_delete_host(host_id, sidfmd_host_id, rule_info); 
        }else if( action === 'update_categories' ){
            update_categories(rule_info);
        }else if( action === 'bulk_update_categories' ){
            bulk_update_categories(rule_info);
        }
    });

    //表示名変更modal
    $('.change-name-btn').on('click', function(){
        var button = $(this);
        $('#hostnameModalOld').text(button.data('hostname'));
        $('#inputOldHostname').val(button.data('hostname'));
        $('#hostnameModalHostid').val(button.data('hostid'));
        $('#inputHostname').val('');
        var display_name = button.attr('data-displayname');
        var sidfm_host_id = button.attr('data-value');
        $('#hostnameModal-sidfm-host-id').val(sidfm_host_id);
        $('#input-display-name').val('');
        $('#execute-change-name').attr({
            'data-target': '#hostnameModal-displayname-dump',
            'data-submit': '#hostnameModal-displayname-form'
        });
        $('#execute-change-name').prop('disabled', true);
        $('#input-display-name').prop('disabled', false);
        $('#input-delete-display-name').prop('disabled', true);
        $('#display-name-caution').hide();
        $('#warning-change-hostname').hide();
        $('.change-name-field').addClass('unselected-change-name-field');
        $('#change-displayname-field').removeClass('unselected-change-name-field');
        $('#inputHostname').prop('disabled', true);
        $('#input-display-name').prop('disabled', false);
        $('[name="change-name-radio"][value="displayname"]').prop('checked', true);
        $('[name="change-name-radio"][value="hostname"]').prop('checked', false);
        if(display_name.length == 0){
            $('#delete-display-name-area').hide();
            $('#old-display-name-area').hide();
            $('#display-name-label').text('設定する表示名');
        }else{
            $('#delete-dispaly-name-text').hide();
            $('#delete-display-name-button').removeClass('btn-secondary')
            .addClass('btn-danger')
            .text('表示名を削除');
            $('#delete-display-name-area').show();
            $('#display-name-old').text(display_name);
            $('#old-display-name-area').show();
            $('#display-name-label').text('変更する表示名');
        }
        $('#hostnameModal').modal('show');
    });


    //表示名を削除ボタンを押した時
    $('#delete-display-name-button').on('click', function(){
        var del_btn = $(this);
        if(del_btn.attr('data-delete') === 'true'){
             del_btn.attr({
                 'data-delete': 'false',
             }).removeClass('btn-secondary')
             .addClass('btn-danger')
             .text('表示名を削除');
             $('#delete-dispaly-name-text').hide();
             $('#input-display-name').prop('disabled', false);
             $('#input-delete-display-name').prop('disabled', true);
             check_diaplay_name_is_registerable();
        }else{
            del_btn.attr({
                'data-delete': 'true',
            }).removeClass('btn-danger')
            .addClass('btn-secondary')
            .text('戻す');
            $('#delete-dispaly-name-text').show();
            $('#input-display-name').prop('disabled', true);
            $('#input-delete-display-name').prop('disabled', false);
            $('#execute-change-name').prop('disabled', false);
        }
    });
    //表示名に使用できない文字を弾く
    $('#input-display-name').on('input', function(){
        check_diaplay_name_is_registerable();
    });
    
    function check_diaplay_name_is_registerable(){
        var input_val = $('#input-display-name').val();
        if(input_val.match(/<|>|"|'/)){
            $('#display-name-caution').text('使用できない文字(<>"' + "'" + ')が含まれています').show(); 
            $('#execute-change-name').prop('disabled', true);
        }else if(input_val.match(/&&&&&/)){
            $('#display-name-caution').text('「&&&&&」の文字列(5つ連なるアンド)は使用できません').show();
            $('#execute-change-name').prop('disabled', true);
        }else if(input_val.length > 0 && input_val.trim().length === 0){
            $('#display-name-caution').text('空白文字のみだけの表示名は登録できません').show();
            $('#execute-change-name').prop('disabled', true);
        }else if(input_val.length > max_display_name_length){
            $('#display-name-caution').text(max_display_name_length + '文字を超える表示名は登録できません').show();
            $('#execute-change-name').prop('disabled', true);
        }else if(input_val.length === 0){
            $('#display-name-caution').hide();
            $('#execute-change-name').prop('disabled', true);
        }else{
            $('#display-name-caution').hide();
            $('#execute-change-name').prop('disabled', false);
        }
        if($('#delete-display-name-button').attr('data-delete') === 'true'){
            $('#execute-change-name').prop('disabled', false);
        }
    }
    function check_hostname_is_registerable(){
        var hostname = $('#inputHostname').val();
        if(hostname === ''){
            $('#execute-change-name').prop('disabled', true);
            $('#warning-change-hostname').hide();
        }else if(!hostname.match(/^[\x20-\x7e]*$/)){
            $('#warning-change-hostname').text('半角英数字で入力して下さい').show();
            $('#execute-change-name').prop('disabled', true);
        }else if(hostname.match(/\s/)){
            $('#warning-change-hostname').text('空白文字は使用できません').show();
            $('#execute-change-name').prop('disabled', true);
        }else if(!hostname.match(/^[0-9a-zA-Z._-]*$/)){
            $('#warning-change-hostname').text('使用できない文字が含まれています').show();
            $('#execute-change-name').prop('disabled', true);
        }else if(encodeURIComponent(hostname).replace(/%../g,"x").length > max_hostname_byte_length){
            $('#warning-change-hostname').text(max_hostname_byte_length + 'バイトを超えるホスト名は登録できません').show();
            $('#execute-change-name').prop('disabled', true);
        }else{
            $('#warning-change-hostname').hide();
            $('#execute-change-name').prop('disabled', false);
        }
    }

    $('[name="change-name-radio"]').on('change', function(){
        var selected_radio = $(this);
        if(selected_radio.val() === 'hostname'){
            $('[name="change-name-radio"][value="displayname"]').prop('checked', false);
            $('#execute-change-name').attr({
                'data-target': '#hostnameModal-hostname-dump',
                'data-submit': '#hostnameModal-hostname-form'
            });
            $('#change-hostname-field').removeClass('unselected-change-name-field');
            $('#change-displayname-field').addClass('unselected-change-name-field');
            $('#inputHostname').prop('disabled', false);
            $('#input-display-name').prop('disabled', true);
            check_hostname_is_registerable();
        }else{
            $('[name="change-name-radio"][value="hostname"]').prop('checked', false);
            $('#execute-change-name').attr({
                'data-target': '#hostnameModal-displayname-dump',
                'data-submit': '#hostnameModal-displayname-form'
            });
            $('#change-hostname-field').addClass('unselected-change-name-field');
            $('#change-displayname-field').removeClass('unselected-change-name-field');
            $('#inputHostname').prop('disabled', true);
            $('#input-display-name').prop('disabled', false);
            check_diaplay_name_is_registerable();
        }
    });

    $('#inputHostname').on('input', function(){
        check_hostname_is_registerable();
    });

    //enterキーでsubmitさせないようにする
    $('#input-display-name, #inputHostname').on('keypress', function(e){
        var key_code = e.keyCode || e.charCode || 0;
        if(key_code === 13){
            return false;
        }
    });

    //インポート確認画面でキャンセルボタンを押した時
    $('.cancel-import').on('click', function(){
        $('#form-to-index_r-page').submit();
    });

    //enterでformが送信されるのを防ぐ
    $('.modal input').on('keydown', function(e) {
        if( (e.which && e.which === 13) || (e.keyCode && e.keyCode === 13) ){
            return false;
        } else {
            return true;
        } 
    });
});
