/* coding: utf-8 */
/* Copyright (C) 2020 SofTek Systems, Inc. */

$(function(){
    init_sidfm();
    init_paginator();
    enable_dropdown_balloon();
    sticky_control('SummaryTable', 'products');
    activate_sidebar_item('sidebar-item-products-manip');
    set_style_for_ActionArea_on_filter_dropdown_event();
    $('#pages_form').on('submit', function(){ set_summary_table_lines('products', $('#pages_per_page').val()) });   

    $(window).on('load', function() {
        setTimeout(function(){
            set_scroll();
            $(window).on('resize scroll', set_scroll);
        },200);
        $('.modal').on('show.bs.modal', function(){
            $('#floating-scroll').css('z-index', '10');
        });
        $('.modal').on('hidden.bs.modal', function(){
            if($('[data-slidemodal]').length === 0){
                $('#floating-scroll').css('z-index', '1060');
            }else{
                $('#floating-scroll').css('z-index', '10');
            }
        });
    });

    //サマリーテーブルの検索
    function submit_search_item(search_item, keyword){
        if(keyword.length > 0){
            reset_pages_checked_values();
            var filters = JSON.parse($('#pages_filters').val());
            filters[search_item] = String(keyword);
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
        }
    }

    function reset_search_item(search_item){
        return (function () {
            reset_pages_checked_values();
            var filters = JSON.parse($('#pages_filters').val());
            filters[search_item] = '';
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
        });
    }
    $('#search-product-name-form').on('submit', function(){
        submit_search_item('search_products', $('#search_product_name_field').val());
        return false;
    });

    $('#search-product-versions-form').on('submit', function(){
        submit_search_item('search_versions', $('#search_version_field').val());
        return false;
    });

    $('#search-hosts-form').on('submit', function(){
        submit_search_item('search_hosts', $('#search_hosts_field').val());
        return false;
    });

    $('.search-host-by-display-name').on('click', function(e){
        e.preventDefault();
        submit_search_item('search_hosts', $(this).attr('data-displayname'));
    });

    $('#filter_product_name_reset').on('click', reset_search_item('search_products'));
    $('#filter_version_reset').on('click', reset_search_item('search_versions'));
    $('#filter_hosts_reset').on('click', reset_search_item('search_hosts'));

    $('#filter-clear').on('click', function() {
        reset_pages_checked_values();
        $('#pages_filters').val('{}')
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    });

    //サマリーテーブルのソート
    $('.sort-products-name').on('click', sort_toggle('product-name'));
    $('.sort-products-is-support-end').on('click', sort_toggle('product-is-support-end'));
    $('.sort-products-version-name').on('click', sort_toggle('product-version-name'));

    //ロード時のサマリーテーブルのチェックボックス
    //if ($('#pages_all_checked').val() === 'false'){ $('#allSelect').prop('checked', false);}

    $(window).on('pageshow', function(){
        var pages_checked = JSON.parse($('#pages_checked').val());
        var all_product_ids = JSON.parse($('#all-product-ids').val());
        if(pages_checked.length === all_product_ids.length && all_product_ids.length > 0){
            $('#allSelect').prop('checked', true);
        }else{
           $('#allSelect').prop('checked', false);
        }

        $('#ProductTable').find('.SelectProduct').prop('checked', false);
        for(var i = 0; i < pages_checked.length; i++){
            var id = pages_checked[i];
            var pid = id['pid'];//どれか１つ
            var vid = id['vid'];
            var lpid = id['lpid'];
            var lvid = id['lvid'];
            $('#ProductTable').find('.SelectProduct').each(function(){
                var elm = $(this);
                var elm_val = JSON.parse(elm.val());
                var is_hit = false
                if(pid && (elm_val['pid'] == pid) ||
                    vid && (elm_val['vid'] == vid) ||
                    lpid && (elm_val['lpid'] == lpid) ||
                    lvid && (elm_val['lvid'] == lvid)
                ){
                    $(this).prop('checked', true);
                    return false;
                }
            });
        }
    });
    //サマリーテーブルのチェックボックス
    $('#allSelect').on('change', function(){
        var chk_box = $(this);
        if(chk_box.prop('checked')){
            $('.SelectProduct').prop('checked', true);
            $('#pages_checked').val($('#all-product-ids').val());
            $('#pages_all_checked').val('true');
            //$('.bulk-btn').prop('disabled', false);
        }else{
            $('.SelectProduct').prop('checked', false);
            $('#pages_checked').val('[]');
            $('#pages_all_checked').val('false');
            //$('.bulk-btn').prop('disabled', true);
        }
    });

    $('.SelectProduct').on('change', function(){
        var chk_box = $(this);
        var prod_id = JSON.parse(chk_box.val());
        var selected_ids = JSON.parse($('#pages_checked').val());
        var all_prod_ids = JSON.parse($('#all-product-ids').val());
        if(chk_box.prop('checked')){
            selected_ids.push(prod_id);
        }else{
            var pid = prod_id['pid'];
            var vid = prod_id['vid'];
            var lpid = prod_id['lpid'];
            var lvid = prod_id['lvid'];
            for(var i = 0; i < selected_ids.length; i++){
                var elm_val = selected_ids[i];
                var is_hit = false
                if(pid && (elm_val['pid'] == pid) ||
                    vid && (elm_val['vid'] == vid) ||
                    lpid && (elm_val['lpid'] == lpid) ||
                    lvid && (elm_val['lvid'] == lvid)
                ){
                    selected_ids.splice(i, 1);
                    break;
                }
            }
        }
        $('#pages_checked').val(JSON.stringify(selected_ids));
        if(all_prod_ids.length === selected_ids.length){
            $('#allSelect').prop('checked', true);
            $('#pages_all_checked').val('true');
        }else{
            $('#allSelect').prop('checked', false);
            $('#pages_all_checked').val('false');
        }
    }); 

    //ダウンロード
    $('#execute-download').on('click', function(){
        $('#download-order').val($('#pages_order').val());
        $('#download-filters').val($('#pages_filters').val());
        $('#download-product-ids').val($('#pages_checked').val());
        $('#form_download').submit();
    });
});
