/* coding: utf-8 */
/* Copyright (C) 2019 SofTek Systems, Inc. */


$(function() {
    
    init_paginator();
    enable_dropdown_balloon();
  
    set_style_for_ActionArea_on_filter_dropdown_event();
    $('#pages_form').on('submit', function(){ set_summary_table_lines('users', $('#pages_per_page').val()) });   
 
    if( $.cookie('import_err') ){
        $('html,body').animate({ scrollTop: 0 }, '1');
    }
    $.removeCookie('import_err');
   
    //ソート処理
    $('.sort-loginname').on('click', sort_toggle('loginname'));
    $('.sort-lastname').on('click', sort_toggle('lastname'));
    $('.sort-authway').on('click', sort_toggle('authway'));
    $('.sort-mail-notification').on('click', sort_toggle('mail-notification'));
    $('.sort-last-login-on').on('click', sort_toggle('last-login-on'));
    $('.sort-users-lock').on('click', sort_toggle('users-lock'));
    
    //検索処理
    function search_users(selector, search_item) {
        return (function () {
            reset_pages_checked_values();
            var filters = JSON.parse($('#pages_filters').val());
            if (selector != '#search-self-user' && search_item === 'search_login' || search_item === 'search_name'){
                var kwd = $(selector).val();
            }else if( selector === 'search_last_login_on'){
                if( $('#search-not-login-users').prop('checked') ){
                    kwd = JSON.stringify([ 'not-login-users' ]);
                }else{
                    var begin_date = $('#filters_search_last_login_on_begin').val();
                    var end_date = $('#filters_search_last_login_on_end').val();
                    if( begin_date.length > 0 || end_date.length > 0 ){
                        kwd = JSON.stringify([ begin_date, end_date ]);
                    }else{
                        kwd = '[]';
                    }
                }
            } else {
                var kwd = $(this).data('value');
            }
            filters[search_item] = String(kwd);
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
            return false;
        });
    }
    if ($('#pages_all_checked').val() === 'false'){ $('#allSelect').prop('checked', false);} 
 
    $('#filter_login').on('click', search_users('#filters_search_login', 'search_login'));
    $('#filter_name').on('click', search_users('#filters_search_name', 'search_name'));
    $('.filter_auth').on('click', search_users('#filters_search_auth', 'search_auth'));
    $('.filter_users_auth').on('click', search_users('.filter_users_auth', 'search_users_auth'));
    $('.filter_category').on('click', search_users('.filter_category', 'search_category'));
    $('#filter-last-login-on').on('click', search_users('search_last_login_on', 'search_last_login_on'));
    $('#search-self-user').on('click', search_users('#search-self-user', 'search_login'));
    $('.filter_mail_notification').on('click', search_users('.filter_mail_notification', 'search_mail_notification'));
    $('.filter_locked_users').on('click', search_users('.filter_locked_users', 'search_locked_users'));

    $(document).on('click', '[data-search="category"]', function(event){
        event.preventDefault();
        reset_pages_checked_values();
        var category_id = $(this).attr('data-value');
        var filters = JSON.parse($('#pages_filters').val());
        filters['search_category'] = String(category_id);
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
    });

    //プリセットでの最終ログイン日時の設定
    $('.filter-last-login-on-preset').on('click', function(){
        var begin_date = $(this).attr('data-begindate');
        var end_date = $(this).attr('data-enddate');
        if( begin_date ){
            $('#filters_search_last_login_on_begin').val(begin_date);
        }
        if( end_date ){
            $('#filters_search_last_login_on_end').val(end_date);
        }
    });

    function toggle_search_last_login_on_items(){
        var selectors = [ 
          '#filters_search_last_login_on_begin',
          '#filters_search_last_login_on_end',
          '.filter-last-login-on-preset'
        ].join(', ');
        if( $('#search-not-login-users').prop('checked') ){
            $(selectors).prop('disabled', true);
        }else{
            $(selectors).prop('disabled', false);
        }
    }
    $('#search-not-login-users').on('change', function(){
        toggle_search_last_login_on_items();
    });

    $('#search_last_login_on_btn').on('show.bs.dropdown', function(){
        toggle_search_last_login_on_items();
    });
    //検索リセット処理
    
    function reset_search_item(reset_item){
        return (function(){
            reset_pages_checked_values();
            var filters = JSON.parse($('#pages_filters').val());
            if( reset_item === 'search_last_login_on' ){
                filters[reset_item] = String('[]');
            }else{
                filters[reset_item] = String('');
            }
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
            return false;
         });
    }
    $('#filter_login_reset').on('click', reset_search_item('search_login'));
    $('#filter_name_reset').on('click', reset_search_item('search_name'));
    $('#reset-filter-last-login-on').on('click', reset_search_item('search_last_login_on')); 
        
    $('#filter-clear').on('click', function() {
        reset_pages_checked_values();
        $('#pages_filters').val('{}') 
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    });
    
    //全ユーザチェックのcheckboxのリセット処理
    if($('#all_userids_names').length){ 
        var all_users_param = JSON.parse($('#all_userids_names').val());
        var count_userids = 0;
        for (id in all_users_param){
            count_userids += 1;
        } 
        if (JSON.parse($('#pages_checked').val()).length === count_userids){
            $('.allUserSelect').prop('checked', true);
        }else{
            $('.allUserSelect').prop('checked', false);
        }
    } 
    
    //モーダルでのカテゴリ編集処理
    $('#categoriesModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        var title = button.data('title');
        var userid = parseInt(button.data('userid'));
        $(this).find('.modal-title').text(title);
        $('#categories_userid').val(userid);
        var cats = button.data('categories');
        var user_cats = button.data('user_category_ids');
        set_paginator_parameter("#cat_per_page", "#cat_filters", "#cat_offset", "#cat_order");
        $('#selected_categories > option').remove();
        $('#unselected_categories > option').remove();
        var cat_names = Object.values(cats).sort(function(a, b){ 
            if(a.toLowerCase() > b.toLowerCase()){
                return 1;
            }else{
                return -1;
            }
        });
        var categories_desc = JSON.parse($('#categories-desc').val());
        for(var i = 0; i < cat_names.length; i++){
            var cat_name = cat_names[i];
            for(cat_id in cats){
                var t_cat_name = cats[cat_id];
                if(t_cat_name === cat_name){
                    $($.inArray(parseInt(cat_id), user_cats) != -1 ? '#selected_categories' : '#unselected_categories')
                        .append(
                            $('<option>').attr({ 
                                'value': cat_id,
                                'class': 'text-truncate g-max-width-21em', 
                                'data-toggle': 'tooltip',
                                'data-title': categories_desc[cat_id],
                                'data-placement': 'right',
                                'data-boundary': 'window'
                            }).text(cat_name)
                        )
                    ;
                }
            }
        }
        $('#selected_category_ids').val(JSON.stringify(user_cats));
        $('#selected_categories, #unselected_categories').find('[data-toggle="tooltip"]').tooltip();
        return true;
    });
      
    $('#select_category').on('click', function() {
        move_selected_items('#selected_category_ids',
                            '#unselected_categories',
                            '#selected_categories', false);
       $('#selected_categories option').tooltip();
    });
    
    $('#unselect_category').on('click', function() {
        move_selected_items('#selected_category_ids',
                            '#selected_categories',
                            '#unselected_categories', true);
        $('#unselected_categories option').tooltip();
    });

    //変更できないユーザを表示
    //メッセージは今のところカテゴリ一括変更の時のみ表示する。
    //削除時とカテゴリ変更はアラートを出す。
    //インポートの時の処理は、インポートのファイルで行う。
    function display_unchangeable_users(users){
        $('#UnchangeableUsersModalTbody > *').remove();
        $('#UnchangeableUsersModalDescription').html(
            '以下のユーザのカテゴリの変更を行うと、ログインユーザのカテゴリ範囲外のルールの条件、操作もしくはルール自体が削除されるため、カテゴリ変更の処理を実行できません。'
        );
        var num = 15;
        var append_row = function(user){
            var tr = $('<tr>').append(
                $('<td>').text(user['login']),
                $('<td>').text(user['lastname'] + ' ' + user['firstname']),
                $('<td>').text(user['mail'])
            );
            $('#UnchangeableUsersModalTbody').append(tr);
        };
        users.slice(0, num).forEach(function(user){ //すぐに表示されるように、はじめに表示分だけappend
            append_row(user);
        });

        $('#UnchangeableUsersModal').modal('show');

        users.slice(num, users.length).forEach(function(user){
            append_row(user);
        });
    }

    //カテゴリ更新時に確認ウィンドウを表示
    $('#cat_submit').on('click', function() {
        var self_userid = parseInt($('#self_user_id').val());
        var is_admin = $('#is-admin-usr').val() == 'true';
        var categories = $('#selected_categories option').val();
        var userid = parseInt($('#categories_userid').val());
        if ( !is_admin ) {
            if( categories === undefined && userid  === self_userid ){
                alert('ログインユーザのカテゴリを0にすることはできません。');
                return false;
            } else if ( categories === undefined ){
                var conf = confirm('このままカテゴリを変更すると\n更新対象のユーザがページに表示されなくなります。\nページに表示されないユーザは操作できません。\n更新してもよろしいですか?'); 
                if( !conf ){
                    return false;
                }
            }
        }
        $('body').append(create_loading_window);
        var path = $('#sidfm_internal_api_check_related_rules_path').val();
        $('#submit-related-rules-item-form').attr({
            'data-submit': '#categories_form',
        });
        var form = $('#categories_form');
        var selected_category_ids = $('#selected_category_ids').val();
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'page_name': 'user',
                'action_idx': 'category_change',
                'user_categoryids': JSON.stringify( { [userid] : JSON.parse(selected_category_ids) })
            },
        }).done(function(data){
            if( data['is_unchangeable_user'] ){
                $('#checking-users-realted-rules-window').find('.progress-wait-area-label').text('');
                setTimeout(function(){
                    alert(
                        'ログインユーザのカテゴリ範囲外のルールの条件、操作もしくはルール自体が削除されるため、カテゴリの変更をすることができません。\n' +
                        '※カテゴリの変更がどうしても必要な場合は、SIDfmVM管理者権限のユーザで、再度実行してください。'
                    );
                    $('#checking-users-realted-rules-window').remove();
                },100);
                return false;
            }else{
               if(Object.keys(data['rule_messages']).length > 0){
                   $('#checking-users-realted-rules-window').remove();
                   display_related_rules(data);
               }else{
                   form.submit();
               }
            }
        });
        
    });
    
     $('#bulk_cat_submit').on('click', function() {
        var self_userid = parseInt($('#self_user_id').val());
        var is_admin = $('#is-admin-usr').val() == 'true';
        var bulk_categories = $('#bulk_selected_categories option').val();
        var userids = JSON.parse($('#categories_bulk_userids').val());
        if ( !is_admin ){
            if ( bulk_categories === undefined && $.inArray(self_userid, userids) != -1){
                alert('ログインユーザのカテゴリを0にすることはできません。');
                return false;
            } else if (bulk_categories === undefined){
                var conf = confirm('このままカテゴリを変更すると\n更新対象のユーザがページに表示されなくなります。\nページに表示されないユーザは操作できません。\n更新してもよろしいですか?');
                if ( !conf ){
                    return false;
                }
            }
        }
        $('body').append(create_loading_window);
        var path = $('#sidfm_internal_api_check_related_rules_path').val();
        $('#submit-related-rules-item-form').attr({
            'data-submit': '#categories_bulk_form',
        });
        var form = $('#categories_bulk_form');
        var selected_category_ids = JSON.parse($('#bulk_selected_category_ids').val());
        var user_categoryids = {};
        userids.forEach(function(user_id){
            user_categoryids[user_id] = selected_category_ids; 
        });
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'page_name': 'user',
                'action_idx': 'bulk_category_change',
                'user_categoryids': JSON.stringify(user_categoryids)
            },
        }).done(function(data){
            if( data['is_unchangeable_user'] ){
                $('#checking-users-realted-rules-window').remove();
                display_unchangeable_users(data['unchangeable_users']);
            }else{
               if(Object.keys(data['rule_messages']).length > 0){
                   $('#checking-users-realted-rules-window').remove();
                   display_related_rules(data);
               }else{
                   var conf = confirm('指定したユーザ全てのカテゴリが更新されます。実行してもよろしいですか?');
                   if ( !conf ){
                       $('#checking-users-realted-rules-window').remove();
                       return false;
                   }
                   form.submit();
               }
            }
        });
         

    });
    
    //モーダルでのユーザ新規登録・変更処理     
    /*var funcval;  
    var loginval;
    var fname;
    var lname;
    var emailval;
    var psw;
    var pswconf;
    var authval;
    var auth_text;
    var roleidval;
    var pj_auth_text;
    var mailNotificationVal;
    var is_force_password_change_val;*/
    $('#modal-form').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        var func = button.data('func');
        //user_data['func'] = func
        var userid = parseInt(button.data('userid'));
        var title = button.data('title');
        var login = button.data('login');
        //loginval = login; 
        var firstname = button.data('firstname');
        //fname = firstname;
        var lastname = button.data('lastname');
        //lname = lastname;
        var email = button.data('email');
        //emailval = email;
        var pw = button.data('pw');
        //psw = pw;
        var pwconf = button.data('pwconf');
        //pswconf = pwconf;
        var auth = button.data('auth');
        //authval = auth;
        var roleid = button.data('roleid');
        //roleidval = roleid;
        var redmine_admin = button.data('redmineadmin');
	var user_admin = button.data('useradmin');
        var mailNotification = button.data('mailnotification').toString();
        //mailNotificationVal = mailNotification;
        if (typeof userid === 'undefined' || (userid == "")) {
            userid = '0';
        }
        var is_force_password_change = button.data('pwchange');
        //is_force_password_change_val = is_force_password_change;
        var user_lock_status = button.data('status');
        var user_data = {
          'func': func,
          'user_id': userid,
          'login': login,
          'firstname': firstname,
          'lastname': lastname,
          'email': email,
          'auth': auth,
          'role_id': roleid,
          'is_admin': redmine_admin,
          'mail_notification': mailNotification,
          'is_force_password_change': is_force_password_change
        };
        var modal = $(this);
        modal.find('.modal-title .text-truncate').text(title);
        $('#form_userid').val(userid);
        $('#form_login').val(login);
        $('#form_login_disabled').val(login);
        $('#form_firstname').val(firstname);
        $('#form_lastname').val(lastname);
        $('#form_email').val(email);
        $('#form_pw').val(pw);
        $('#form_pwconf').val(pwconf);
        $('#form_func').val(func);
        $('#mail_notification').val(mailNotification);
        if( user_lock_status && parseInt(user_lock_status) === parseInt($('#status-lock-value').val()) ){
            $('#user-lock-chkbox').prop('checked', true);
            user_data['is_locked'] = true;
        }else{
            $('#user-lock-chkbox').prop('checked', false);
            user_data['is_locked'] = false;
        }
        $('#form-user-data').val(JSON.stringify(user_data));
        $('#loginlabel').hide();
        $('#user_pwlabel').hide();
        $('#pwlabel').hide();
        $('#lastname_label').hide();
        $('#firstname_label').hide();
        $('#emaillabel').hide();
        if (redmine_admin === true){
            $('#form_sel').prop('disabled', true);
            $('#pj_auth_sel').prop('disabled', true);
        } else {
	    if (user_admin === true) {
		$('#form_sel').prop('disabled', false);
		$('#pj_auth_sel').prop('disabled', false);
	    } else {
		$('#form_sel').prop('disabled', true);
		$('#pj_auth_sel').prop('disabled', true);
	    }
        }
        $('#form_login').prop('readonly', false);
        $('#form_sel option').prop('selected', false);
        $('#form_sel  option[value="' + auth  + '"]').prop('selected', true);
        var op = $('#pj_auth_sel option[value="-1"]')
        op.text('権限を削除する');
        op.prop('hidden', true);
        op.prop('selected', false);
        $('#pj_auth_sel option[value="' + roleid + '"]').prop('selected', true);
        $('#hidden_auth').prop('disabled', true);
        $('#hidden_pj_auth').prop('disabled', true);
        if ($('#is-view-usr').val() === 'true') {
            $('#form_sel, #pj_auth_sel').prop('disabled', true);
            
        }
        if(login === 'sidfmadm'){
            $('#form_login').prop('readonly', true);
            $('#pj_auth_sel').prop('disabled', true);
        }
        if ($('#form_sel').attr('disabled') != undefined) {
            $('#hidden_auth').prop('disabled', false);
            $('#hidden_auth').val(auth);
        }
        if ($('#pj_auth_sel').attr('disabled') != undefined) {
            $('#hidden_pj_auth').prop('disabled', false);
            $('#hidden_pj_auth').val(roleid);
        }
        if (mailNotification === 'true'){
            $('#mail_notification').prop('checked', true);
        }else{
            $('#mail_notification').prop('checked', false);
        }
        if( $('#force-change-password-chkbox').length === 1 ){ //この要素は管理者権限の時のみある)
            $('#force-change-password-chkbox').prop('checked', is_force_password_change);
        }
        auth_text = $('#form_sel option:selected').text();
        pj_auth_text = $('#pj_auth_sel option:selected').text();   
        $('#form_submit').prop('disabled', true);
        if (func === "new") {
            $('#test-mail-btn, #reset-change-user-info').hide();
            $('#form_func').val('new');
            $('#form_submit').text('登録');
            $('#form').attr('action', $('#url_new').val());
        } else {
            set_paginator_parameter("#form_per_page", "#form_filters", "#form_offset", "#form_order")
            $('#form_id').val(userid);
            $('#form_func').val('mod');
            $('#reset-change-user-info').show();
            if (userid === parseInt($('#self_user_id').val())){
                op.prop('hidden', true);
                $('#test-mail-btn').show();
                $('#form-user-lock-section').hide();
            }else{
               op.prop('hidden', false);
               $('#test-mail-btn').hide();
               if (parseInt(roleid) === -1){
                 op.text('必要な場合は選択');
               }
               $('#form-user-lock-section').show();
            }
            $('#form_submit').text('更新');
            $('#form').attr('action', $('#url_mod').val());
        }
        toggle_pw_fields();
    });
  
    //formの内容をリセット  
    $('#reset-change-user-info').on('click', function(){
        var user_data = JSON.parse($('#form-user-data').val());
        $('#form_login').val(user_data['login']);
        $('#form_firstname').val(user_data['firstname']);
        $('#form_lastname').val(user_data['lastname']);
        $('#form_email').val(user_data['email']);   
        $('#form_pw, #form_pwconf').val('');
        $('#form_sel').val(user_data['auth']);
        $('#pj_auth_sel').val(user_data['role_id']);
        $('#mail_notification').val(user_data['mail_notification']).prop('checked', user_data['mail_notification'] === 'true' ? true : false);
        $('#force-change-password-chkbox').prop('checked', user_data['is_force_password_change']);
        $('#user-lock-chkbox').prop('checked', user_data['is_locked']);
        $('#form_submit').prop('disabled',true);
        $('#loginlabel').hide();
        $('#user_pwlabel').hide();
        $('#pwlabel').hide();
        $('#lastname_label').hide();
        $('#firstname_label').hide();
        $('#emaillabel').hide();
        toggle_pw_fields();
    });

    $('#mail_notification').on('change', function () {
            if($(this).prop('checked')) {
                $(this).val('true');
            }else {
                $(this).val('false');
            }
            btn_status_change();
    });

    $('#force-change-password-chkbox').change(function() {
        btn_status_change();
    });
    $('#form_login').on('input',function(){ 
        if (!$('#form_login').val().match(/^[a-zA-Z0-9_\-@\.]*$/)){
            $('#loginlabel').text('ログイン名に使用できない文字が含まれています。\n※半角英数字及び _.-@ のみ使用可能です')
                            .show();
        } else {
            $('#loginlabel').hide();
        }
        btn_status_change();
    });

    function check_password(){
        var conffd = $('#form_pwconf').val();
        var pwfd = $('#form_pw').val();
        $('#user_pwlabel, #pwlabel').text('パスワードが一致しません');
        if ((pwfd.length > 0 && conffd.length > 0)  && (conffd != pwfd)) {
            $('#pwlabel, #user_pwlabel').show();
        } else {
            $('#pwlabel, #user_pwlabel').hide();
        }
    }

    $('#form_pw').on('input',function() {
        check_password();
        btn_status_change();
    });
 

    $('#form_lastname').on('input',function() {
        btn_status_change();
    });
    
    $('#form_firstname').on('input',function() {
        btn_status_change();
    });

    
    $('#form_pwconf').on('input',function(){
        check_password();
        btn_status_change();
           
    });
    
    $('#form_email').on('input',function(){
        if (!$('#form_email').val().match(/^[\x20-\x7e¥]*$/)){
            $('#emaillabel')
                .text('半角英数字記号で入力してください')
                .show();
        } else {
            $('#emaillabel').hide();
        }
        btn_status_change();
    });
  
    $('#mod-body select').change(function() {
        var user_data = JSON.parse($('#form-user-data').val());
        if ( user_data['func'] != "new" ){
            btn_status_change(); 
        }
    });

    $('#user-lock-chkbox').on('change', function(){
        var user_data = JSON.parse($('#form-user-data').val());
        if ( user_data['func'] != "new" ){
            btn_status_change();
        }
    });

    $('#form_sel').on('change', function(){
        btn_status_change();
        toggle_pw_fields();
        var openid_connect_auth_id = $('#openid-connect-auth-id').val();
        if( parseInt(openid_connect_auth_id) === parseInt($('#form_sel').val()) ){
            $('#pwlabel, #user_pwlabel').hide();  
        }else{
            check_password();
        }
    });

    function toggle_pw_fields(){
        var pw_fields = $('#form_pw, #form_pwconf');
        var openid_connect_auth_id = $('#openid-connect-auth-id').val();
        if( parseInt(openid_connect_auth_id) === parseInt($('#form_sel').val()) ){
            pw_fields.prop('disabled', true);
        }else{
             pw_fields.prop('disabled', false);
        }
    }    

    function btn_status_change() {     
        var user_data = JSON.parse($('#form-user-data').val());
        if ( user_data['func'] != "new") {
            if ( $('#form_login').val() != user_data['login'] || $('#form_firstname').val() != user_data['firstname'] || 
                 $('#form_lastname').val() != user_data['lastname'] || $('#form_email').val() != user_data['email'] || 
                 ($('#form_pw').val() != '' && $('#form_pwconf').val() != '') || $('#form_sel').val() != user_data['auth'] || 
                 $('#pj_auth_sel').val() != user_data['role_id'] || $('#mail_notification').val() != user_data['mail_notification'] || 
                 $('#force-change-password-chkbox').prop('checked') != user_data['is_force_password_change'] ||
                 $('#user-lock-chkbox').prop('checked') != user_data['is_locked'] ) {
                 $('#form_submit').prop('disabled', false);
            }else{
                $('#form_submit').prop('disabled', true);
            }
            /*if($('#form_pw').val() != '' && $('#form_pwconf').val() != ''){
                $('#form_submit').prop('disabled', false);
            }else{
                $('#form_submit').prop('disabled', true);
            }*/
        } else {
            var openid_connect_auth_id = $('#openid-connect-auth-id').val();
            if($('#form_login').val() != '' && $('#form_firstname').val() != '' && $('#form_lastname').val() != '' && $('#form_email').val() != ''){
                if( parseInt(openid_connect_auth_id) === parseInt($('#form_sel').val()) ){
                    $('#form_submit').prop('disabled', false);
                }else if( $('#form_pw').val() != '' && $('#form_pwconf').val() != '' ){   
                    $('#form_submit').prop('disabled', false);
                }else{
                    $('#form_submit').prop('disabled', true);
                }
            } else if($('#form_login').val() === '' || $('#form_firstname').val() === '' || $('#form_lastname').val() === '' || $('#form_pw').val() === '' || $('#form_pwconf').val() === '' || $('#form_email').val() === ''){
                $('#form_submit').prop('disabled', true);
            }  
        }
    } 
       
  //更新ボタン押した後にエラーメッセージを消す処理(入力が空白の時にエラーメッセージを表示するため、入力されたら消す）
    $('#form_lastname').on('input',function (){
    $('#lastname_label').hide();
    });
    $('#form_firstname').on('input',function (){
       $('#firstname_label').hide();
    });
     
   
    //submit処理
    const password_min_length = parseInt($('#password_min_length').val());
   $('#form_submit').on('click', function() {
        var func = $('#form_func').val();
        var openid_connect_auth_id = $('#openid-connect-auth-id').val();
        var is_openid_connect_auth = (parseInt(openid_connect_auth_id) == parseInt($('#form_sel').val()));
        //var filtered_mailaddress = $('#form_email').val().replace(/\r?\n/g, '');
        f_err = false;
        if ($('#form_login').val() == '') {
            $('#loginlabel').text('ログイン名が入力されていません').show();
            f_err = true;
        }
        /*if (!$('#form_login').val().match(/^[\x20-\x7e]*$/)){
              f_err = true;
        }*/
        if ($('#form_lastname').val() == '' || $('#form_firstname').val() == ''){
            if ($('#form_lastname').val() == ''){
                $('#lastname_label').text('姓が入力されていません').show();
            }
            if ($('#form_firstname').val() == ''){
                $('#firstname_label').text('名が入力されていません').show();
            }
            f_err = true;
        }
        if ($('#form_email').val() == ''){ 
            $('#emaillabel').text('メールアドレスが入力されていません').show();
            f_err = true;
        }
        /*if (!filtered_mailaddress.match(/^([^@\s]+)@(([-a-z0-9]+\.)+[a-z]{2,})$/i)){
            $('#emaillabel').text('メールアドレスに誤りがあります。').show();
            f_err = true;
        }*/
        if ($('#form_login').val().length > 60) {
              $('#loginlabel').text('ログイン名は60文字以内で入力してください').show();
              f_err = true;
        }  
        if ($('#form_lastname').val().length > 30) {
              $('#lastname_label').text('姓は30文字以内で入力してください').show();
              f_err = true;
        } 
        if ($('#form_firstname').val().length > 30) {
              $('#firstname_label').text('名は30文字以内で入力してください').show();
              f_err = true;
        }
        if ((func === 'new') && $('#form_pw').val() == '' && !is_openid_connect_auth) {
              $('#user_pwlabel').text('パスワードを入力してください').show();
              f_err = true;
        }
        if ($('#form_pw').val() != $('#form_pwconf').val() && !is_openid_connect_auth) {
              $('#user_pwlabel, #pwlabel').text('パスワードが一致しません').show();
              f_err = true;
        } 
        if ($('#form_pw').val().length > 0 && $('#form_pw').val().length < password_min_length && !is_openid_connect_auth) {
              $('#user_pwlabel, #pwlabel').text('パスワードは' + password_min_length + '文字以上で入力してください').show();
              f_err = true;
        } 
        /*if ((func == 'mod') && $('#form_pw').val().length >= 1 && $('#form_pw').val().length < password_min_length) {
              $('#user_pwlabel, #pwlabel').text('パスワードは' + password_min_length + '文字以上で入力してください').show();
              f_err = true;
        }*/ 
        /*if ($('#form_login').val().indexOf('/') != -1) {
              $('#loginlabel').text('(ログイン名に「/」は使えません)').show();
              f_err = true;
        }*/
        var path = $('#check_user_info_registerable_path').val();
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'user_id': $('#form_userid').val(),
                'login': $('#form_login').val(), 
                'mail_address': $('#form_email').val(), 
                'password': is_openid_connect_auth ? '' : $('#form_pw').val(),
                'func': func
            }
        }).done(function(err_data){
            if( Object.keys(err_data).length > 0 ){
                f_err = true;
                login_err_message = err_data['login'];
                address_err_message = err_data['address'];
                pw_err_message = err_data['password'];
                if(login_err_message){
                    $('#loginlabel').text(login_err_message).show();
                }
                if(address_err_message){
                    $('#emaillabel').text(address_err_message).show();
                }
                if(pw_err_message){
                    $('#user_pwlabel, #pwlabel').text(pw_err_message).show();
                }
                return false;
            }
            if( !f_err ){
                $('#form').submit();
            }else{
                return false;
            }
        });
        /*
            if (func === 'mod'){
                var messages = '';
                if ($('#form_login').val() != loginval){ 
                    messages += '「ログイン名」: ' + loginval + ' ⇨ ' + $('#form_login').val() + '\n';}
                if ($('#form_firstname').val() != fname){
                    messages += '「名」: ' + fname + ' ⇨ ' + $('#form_firstname').val() + '\n';}
                if ($('#form_lastname').val() != lname){ 
                    messages += '「姓」: ' + lname + ' ⇨ ' + $('#form_lastname').val() + '\n';}
                if ($('#form_email').val() != emailval){
                    messages += '「メールアドレス」: ' + emailval + ' ⇨ ' + $('#form_email').val() + '\n';}
                if ($('#form_pw').val() != psw){
                    messages += '「パスワード」: 非表示\n';}
                if ($('#form_sel').val() != authval){
                    messages += '「認証方式」: ' + auth_text + ' ⇨ ' + $('#form_sel option:selected').text() + '\n';}
                if ($('#pj_auth_sel').val() != roleidval){
                     messages += '「ユーザ権限」: ' + pj_auth_text + ' ⇨ ' + $('#pj_auth_sel option:selected').text() + '\n';}
                if ($('#mail_notification').val() != mailNotificationVal){
                     var validity = mailNotificationVal == 'true' ? '有効 ⇨ 無効' : '無効 ⇨ 有効';
                     messages += '「メール通知設定」: ' + validity + '\n'}
                return confirm('以下の項目が変更されます。\n' + messages + 'よろしいでしょうか?');
            } else {
                return confirm('登録します。よろしいでしょうか?');
            }
        }*/      
    });

        
    //ユーザ毎のcheckboxを変更した際の処理
    $('.userSelect').on('change', function() {
        var checkbox = $(this);
        var userid = checkbox.val() - 0;
        var checked = JSON.parse($('#pages_checked').val());
        var all_userids = JSON.parse($('#all_userids').val());
        var all_userids_size = all_userids.length;
        if (checkbox.prop('checked')){
            if (!checked.includes(userid)) {
                checked.push(userid);
                if (checked.length == all_userids_size) {
                    $('.allUserSelect').prop('checked', true);
                    $('#pages_all_checked').val('true');
                } else {
                    $('.allUserSelect').prop('checked', false);
                    $('#pages_all_checked').val('false');
                }
                $('#pages_checked').val(JSON.stringify(checked));
            }
        } else {
            var idx = checked.indexOf(userid);
            if (idx == 0) {
                checked = checked.slice(1, all_userids_size);
            } else if (idx == all_userids_size - 1) {
                checked = checked.slice(0, all_userids_size - 1 );
            } else if (idx > 0) {
                var c_left = checked.slice(0, idx);
                var c_right = checked.slice(idx + 1, all_userids_size);
                checked = c_left.concat(c_right);
            }
            $('#pages_checked').val(JSON.stringify(checked));
            $('.allUserSelect').prop('checked', false);
            $('#pages_all_checked').val('false');
        }
        if(checked.length > 0){
            $('.action-btn').prop('disabled', false);
        }else{
            $('.action-btn').prop('disabled', true);
        }    
        return true;
    });

    //全ユーザチェックのcheckboxの処理
    $('.allUserSelect').on('change', function() {
        var checkbox = $(this);
        if (checkbox.prop('checked')) {
            $('#pages_checked').val($('#all_userids').val());
            $('#pages_all_checked').val('true');
            $('.userSelect').prop('checked', true);
            $('.action-btn').prop('disabled', false);
        } else {
            $('#pages_checked').val(JSON.stringify([]));
            $('#pages_all_checked').val('false');
            $('.userSelect').prop('checked', false);
            $('.action-btn').prop('disabled', true);
        }
        return true;
    });
    
    //認証方式一括処理
    $('#authenticateBulkModal').on('show.bs.modal', function(event) {
         make_bulk_data("#authenticate_bulk_userids", "#authenticateBulkTargetList");
         set_paginator_parameter("#authenticate_bulk_per_page", "#authenticate_bulk_filters", "#authenticate_bulk_offset", "#authenticate_bulk_order");
    });
                         
    // ユーザ権限一括処理
    $('#authorityBulkModal').on('show.bs.modal', function(event) {
        make_bulk_data("#authority_bulk_userids", "#authorityBulkTargetList");
        set_paginator_parameter("#authority_bulk_per_page", "#authority_bulk_filters", "#authority_bulk_offset", "#authority_bulk_order");
    });
    // メール通知設定一括処理
    $('#MailNotificationBulkModal').on('show.bs.modal', function(event) {
      make_bulk_data("#mail_notification_bulk_userids", "#MailNotificationBulkTargetList");
      set_paginator_parameter("#mail_notification_bulk_per_page", "#mail_notification_bulk_filters", "#mail_notification_bulk_offset", "#mail_notification_bulk_order");
    });

    //パスワード強制変更一括
    $('#PasswordChangeBulkModal').on('show.bs.modal', function(event) {
      make_bulk_data("#bulk_force_password_change_user_ids", "#PasswordChangeBulkTargetList");
      set_paginator_parameter("#bulk_force_password_change_pages_per_page", "#bulk_force_password_change_pages_filters", "#bulk_force_password_change_pages_offset", "#bulk_force_password_change_pages_order");
    });
    
    $('#mail_notification_bulk').change(function () {
        if($(this).prop('checked')) {
            $(this).val('true');
        }else {
            $(this).val('false');
       }
    }); 

    //アクションボタンのmodalを開くとき
    $('.action-btn').on('click', function(){
        var checked = JSON.parse($('#pages_checked').val());
        if(checked.length === 0){
            alert('対象ユーザがチェックされておりません。');
            return false;
        }
        var target_modal = $(this).attr('data-target');
        //カテゴリ一括更新の時に、管理者権限のユーザを対象から外す
        if(target_modal === 'categoriesBulkModal'){
            var user_roles = JSON.parse($('#users_role_names').val());
            var filtered_userids = [];
            var untargeted_users = [];
            for(var i = 0; i < checked.length; i++){
                var user_id = checked[i];
                if(user_roles[user_id] != 'SIDfmVM管理者'){
                    filtered_userids.push(user_id);
                }else{
                  untargeted_users.push('.userSelect[value="' + user_id + '"]');
                }
            }
            if(filtered_userids.length === 0){
                alert('対象となるユーザは存在しません。\n※管理者権限のユーザのカテゴリは変更できません。');
                return false;
            }
            if(untargeted_users.length > 0){
                $('#pages_checked').val(JSON.stringify(filtered_userids));
                $(untargeted_users.join(', ')).prop('checked', false);
                $('#allSelect').prop('checked', false);
                $('#bulk-categories-caution').show();
            }else{
                $('#bulk-categories-caution').hide();
            }
        }
        //$('#wrap-ActionArea').css('z-index', '10');
        $('#' + target_modal).modal('show');
    });
    
    //一括処理時のテーブル作成処理
    function make_bulk_data(bulk_userids, TargetList) {
        var checked = JSON.parse($('#pages_checked').val());
        var userids_names = JSON.parse($('#all_userids_names').val());
        if (checked.length > 0) {
            $(bulk_userids).val(JSON.stringify(checked));
            $(TargetList + ' > *').remove();
            for (var i = 0; i < checked.length; i++){
                userid = checked[i];
                if (userids_names[userid] != null){
                    var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
                    var c_td = $('<td></td>', { class: 'hostname' });
                    c_td.text(userids_names[userid]);
                    c_tr.append(c_td);
                    $(TargetList).append(c_tr);
                }
            }
        } else {
            alert('対象ユーザがチェックされておりません。');
            location.reload(true);
            return false;
        }
        return true;
        
    } 

    //カテゴリ一括処理
     $('#categoriesBulkModal').on('show.bs.modal', function(event) {
        var button =$(event.relatedTarget);
        make_bulk_data("#categories_bulk_userids", "#categoriesBulkTargetList");
        set_paginator_parameter("#cat_bulk_per_page", "#cat_bulk_filters", "#cat_bulk_offset", "#cat_bulk_order");
        $('#selected_categories > option').remove();
        $('#unselected_categories > option').remove();
  
        return true;
    });

    $('#bulk_select_category').on('click', function() {
        move_selected_items('#bulk_selected_category_ids',
                            '#bulk_unselected_categories',
                            '#bulk_selected_categories', false);
        $('#bulk_selected_categories option').tooltip();
    });

    $('#bulk_unselect_category').on('click', function() {
        move_selected_items('#bulk_selected_category_ids',
                            '#bulk_selected_categories',
                            '#bulk_unselected_categories', true);
        $('#bulk_unselected_categories option').tooltip();
    });

    function set_paginator_parameter(p_per_page, p_filters, p_offset, p_order){
        var offset = $('#pages_offset').val();
        var filters = JSON.parse($('#pages_filters').val());
        var per_page = $('#pages_per_page').val();
        var order = $('#pages_order').val();
        $(p_per_page).val(per_page);
        $(p_filters).val(JSON.stringify(filters));
        $(p_offset).val(offset);
        $(p_order).val(order);
    }
    
    $('#TestEmailModal').on('show.bs.modal', function(){
        var email = $('#user_email').val()
        $('#test_email_recipient').text(email);
        $('#hidden_email_address').val(email);
        $('#modal-form').css('z-index','500');
        set_paginator_parameter("#test_mail_pages_per_page", "#test_mail_pages_filters", "#test_mail_pages_offset", "#test_mail_pages_order");
    });
 
    $('#TestEmailModal').on('hidden.bs.modal',function(){
        $('#modal-form').css('z-index', '1050');
    });

    sticky_control('UsersTable', 'users');
    $(window).on('load', function() {
        setTimeout(function(){
            set_scroll();
            $(window).on('resize scroll', set_scroll);
        },200);
    });
    
    //ブラウザバックだったらチェックボックスの表示を修正
    /*$.post($('#check_browser_back_path').val(), {'page_name': 'user'},
        function(info){
            if(info === 'browser_back'){
                var is_all_checked = $('#pages_all_checked').val();
                if(is_all_checked === 'true'){
                    var all_ids = JSON.parse($('#all_userids').val());
                    $('#UsersTable').find('#allSelect, .userSelect').prop('checked', true);
                    $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
                }else{
                    $('#UsersTable').find('#allSelect, .userSelect').prop('checked', false);
                    var pages_checked = JSON.parse($('#pages_checked').val());
                    var target_elm = '';
                    for (var id of pages_checked){
                        target_elm += '#table_selected' + id + ',';
                    }
                    target_elm = target_elm.slice(0, -1);
                    $(target_elm).prop('checked', true);
                }
            }
    });*/

    //サマリー表のチェックボックスとpages_checkedの整合性を取る
    $(window).on('pageshow', function(){
        var is_all_checked = $('#pages_all_checked').val();
        if(is_all_checked === 'true'){
            var all_ids = JSON.parse($('#all_userids').val());
            $('#UsersTable').find('#allSelect, .userSelect').prop('checked', true);
            $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
        }else{
            $('#UsersTable').find('#allSelect, .userSelect').prop('checked', false);
            var pages_checked = JSON.parse($('#pages_checked').val());
            var target_elm = '';
            pages_checked.forEach(function(id){
                target_elm += '#table_selected' + id + ',';
            });
            target_elm = target_elm.slice(0, -1);
            $(target_elm).prop('checked', true);
        }
    });
    
    //アクションボタンの活性・非活性
    if( JSON.parse($('#pages_checked').val()).length > 0 ){
        $('.action-btn').prop('disabled', false);
    }else{
        $('.action-btn').prop('disabled', true);
    }

    //ユーザ削除時に関連するルールをチェック
    $('[data-deluser]').on('click', function(){
      var button = $(this);
      var path = $('#sidfm_internal_api_check_related_rules_path').val();
      var del_user_id = button.attr('data-deluser');
      var submit_target = '[data-formdel="user_' + del_user_id + '"]';
      $('#submit-related-rules-item-form').attr({
          'data-submit': submit_target,
      });
      $('body').append(create_loading_window); 
      var form = $(submit_target);
      $.ajax({
          url: path,
          type: 'POST',
          data: {'page_name': 'user', 'delete_id': del_user_id, 'action_idx': 'delete'},
      }).done(function(data){
          if( data['is_unchangeable_user'] ){
              $('#checking-users-realted-rules-window').find('.progress-wait-area-label').text('');
              setTimeout(function(){
                  alert(
                      'ログインユーザのカテゴリ範囲外のルールの条件、操作もしくはルール自体が削除されるため、ユーザを削除することができません。\n' +
                      '※ユーザの削除がどうしても必要な場合は、SIDfmVM管理者権限のユーザで、再度実行してください。'
                  );
                  $('#checking-users-realted-rules-window').remove();
              }, 100);
              return false;
          }else{
              if(Object.keys(data['rule_messages']).length > 0){
                  $('#checking-users-realted-rules-window').remove();
                  display_related_rules(data);
              }else{
                  var conf = confirm(button.attr('data-conftext'));
                  if(!conf){
                      $('#checking-users-realted-rules-window').remove();
                      return false;
                  }else{
                      form.submit();
                  }
              }
          }
      });

  });
 
  //関連するルールを確認するmodalでOKボタンを押した時にformをsubmitする
  $('#submit-related-rules-item-form').on('click', function(){
      var button = $(this);
      var target = button.attr('data-submit');
      $(target).submit();
  });

  //エクスポート
  $('#exec-download').on('click', function(){
      $('#download-target').val('tsv');
      json_tsv_summary_table_progress_download($('#download-target').val(), $('#read-download-data-path').val());
  });

  //インポート
  $('#submit-import-data').on('click', function(){
      var userinfo_file = $('#userinfo-file').get(0).files[0];
      if( !userinfo_file ){
          alert('ファイルが選択されておりません。');
          return false;
      }

      var fd = new FormData();
      fd.append('userinfo_file', userinfo_file);

      var read_import_data_path = $('#read-import-data-path').val();
      var progress_import_path = $('#progress-import-path').val();
      var progress_window = get_progress_bar();
      $('body').append(progress_window);
      var percentage = 0;
      var total_size = 0;
      var executed_size = 0;

      var progress_import = function(){
          $.ajax({
              url: progress_import_path ,
              type: 'GET',
          }).done(function(res){
              if( res['executed_size'] > 0 ){
                  executed_size += res['executed_size'];
                  var percentage = (executed_size / total_size * 100);
                  if( percentage >= 99 && percentage < 100 ){
                      percentage = 99;
                  }else{
                      percentage = Math.round(percentage);
                  }
                  $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                  progress_import();    
              }else{
                 setTimeout(function(){//probress barのbarが満たされるまで待つ
                     location.href = $('#import-path').val();
                 }, 500);
              }
          }).fail(function(){
              alert('ファイルのインポートに失敗しました。画面をリロードします。');
              $('#pages_form').submit(); 
          });
      };

      $.ajax({
          url: read_import_data_path,
          type: 'POST',
          data: fd,
          processData: false,
          contentType: false,
      }).done(function(res){
          if( res['err'] ){
              alert('ファイルのインポートに失敗しました。画面をリロードします。');
              $.cookie('import_err', 'true');
              $('#pages_form').submit();
          }else{
              total_size = res['total_size'];
              progress_import();
          }
      }).fail(function(){
          alert('ファイルのインポートに失敗しました。画面をリロードします。');
          $('#pages_form').submit();
      });
  });
  
    activate_sidebar_item('sidebar-item-user-manip')     
});
