/* coding: utf-8 */
/* Copyright (C) 2021 SofTek Systems, Inc. */

$(function(){
    init_sidfm();
    enable_dropdown_balloon();

    $('.cancel-import').on('click', function(){
        location.href = $('#index-page-path').val()
    });

    function display_unchangeable_users(users){
        $('#UnchangeableUsersModalTbody > *').remove();
        $('#UnchangeableUsersModalDescription').text(
            '以下のユーザのインポートを行うと、ログインユーザのカテゴリ範囲外のルールの条件、操作もしくはルール自体が削除されるため、インポートの処理を実行することができません。'
        );
        var num = 15;
        var append_row = function(user){
            var tr = $('<tr>').append(
                $('<td>').text(user['login']),
                $('<td>').text(user['lastname'] + ' ' + user['firstname']),
                $('<td>').text(user['mail'])
            );
            $('#UnchangeableUsersModalTbody').append(tr);
        };
        users.slice(0, num).forEach(function(user){ //すぐに表示されるように、はじめに表示分だけappend
            append_row(user);
        });

        $('#UnchangeableUsersModal').modal('show');

        users.slice(num, users.length).forEach(function(user){
            append_row(user);
        });
    }

    function exec_import(){
        var import_apply_path = $('#import-apply-path').val();
        var actions = JSON.parse($('#actions').val());

        var progress_window = get_progress_bar();
        $('body').append(progress_window);

        var percentage = 0;
        var executed_actions = 0;
        var total_actions = actions.length;
        var err_messages = new Set();
        var err_cnt = 0;
        var cnt = 0;
        var process_rules = true;

        var delete_user_ids = $('#delete_user_ids').val();
        var category_change_user_categoryids = $('#category_change_user_categoryids').val();

        var import_apply = function(){
            var action = actions[cnt];
            if ( process_rules ){
                var param_data = {
                    'action_data' : JSON.stringify(action),
                    'process_rules': process_rules,
                    'delete_user_ids': delete_user_ids,
                    'category_change_user_categoryids': category_change_user_categoryids
                };
            }else{
                var param_data = { 'action_data' : JSON.stringify(action) };
            }
            $.ajax({
                url: import_apply_path,
                type: 'POST',
                data: param_data
            }).done(function(res){
                process_rules = false; //ルールは初めに処理する。
                if( res['rules_error'] ){
                    alert(res['err_message']);
                    location.href = $('#index-page-path').val();
                    return false;
                }
                cnt += 1;
                err_message = res['err_message'];
                if( err_message.length > 0 ){
                    err_messages.add(err_message);
                    err_cnt += 1;
                }
                executed_actions += 1;
                var percentage = (executed_actions / total_actions) * 100;
                if( percentage >= 99 && percentage < 100 ){
                    percentage = 99;
                }else{
                    percentage = Math.round(percentage);
                }
                $('#progress-bar').attr('aria-valuenow', percentage).css('width', (percentage < 3 ? 3 : percentage) + '%').text(percentage + '%');
                if( percentage == 100 ){
                    setTimeout(function(){//progress barのbarが満たされるまで待つ
                        if(err_messages.size > 0){
                            err_messages = Array.from(err_messages);
                            alert(err_messages.join('\n') + (err_cnt == total_actions ? '' : '\n※他のデータ登録は完了しています。') + '\nユーザ管理画面に移動します。');
                            location.href = $('#index-page-path').val();
                        }else{
                            location.href = $('#index-page-path').val();
                        }
                    },800);
                }else{
                    import_apply();
                }
            });
        };

        import_apply();
    }

    //インポート実行時に、関連するルールを表示
    $('.execute-import').on('click', function(){
        var check_rules_path = $('#sidfm_internal_api_check_related_rules_path').val();
        $('body').append(create_loading_window());
        var delete_user_ids = $('#delete_user_ids').val();
        var category_change_user_categoryids = $('#category_change_user_categoryids').val();

        $.ajax({
            url: check_rules_path,
            type: 'POST',
            data: { 
                'page_name': 'user',
                'user_ids': delete_user_ids, 
                'user_categoryids': category_change_user_categoryids,
                'action_idx': 'import'
            },
        }).done(function(data){
            $('#checking-users-realted-rules-window').remove();
            if( data['is_unchangeable_user'] ){
                display_unchangeable_users(data['unchangeable_users']);
            }else{
                if(Object.keys(data['rule_messages']).length > 0){
                    display_related_rules(data);
                }else{
                    exec_import();
                }
            }
        });

    });

    $('#submit-related-rules-item-form').on('click', function(){
        exec_import();
    });

});
