#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class CreateSidfmdProductsVersions < ActiveRecord::Migration
  def change
    create_table :sidfmd_products do |t|
      t.integer :pid, :null => false, :unique => true, :index => true
      t.string :name, :null => false
      t.string :category
      t.boolean :deleted, :null => false
    end

    create_table :sidfmd_versions do |t|
      t.integer :vid, :null => false, :unique => true, :index => true
      t.string :version, :null => false
      t.string :fullname, :null => false
      t.boolean :deleted, :null => false
      t.boolean :deprecated, :null => false
      t.integer :position, :null => false, :index => true
      t.datetime :create_datetime, :index => true
      t.datetime :update_datetime, :index => true
      t.references :sidfmd_product, :null => false, :index => true
    end
  end
end
