/* coding: utf-8 */
/* Copyright(C) 2018- SofTek Systems, Inc. */

// 脆弱性情報画面

$(function() {

    init_paginator();
    enable_hosts_list_balloon();
    enable_categories_list_balloon('vulnerabilities');
    enable_display_cve_ids();
    set_style_for_ActionArea_on_filter_dropdown_event();
    enable_filter_main_category_menu();
    //enable_dropdown_balloon();
    $('#pages_form').on('submit', function(){ set_summary_table_lines('vulnerabilities', $('#pages_per_page').val()) });   

    // 左袖メニューのactivate
    (function() {
	var t_filters = $('#pages_filters');
	if (t_filters.length) {
	    var filters = JSON.parse(t_filters.val());
	    if (filters['warning'] == 'warning') {
		activate_sidebar_item('sidebar-item-warningvuls');
	    } else {
		activate_sidebar_item('sidebar-item-vulnerabilities');
	    }
	} else {
	    activate_sidebar_item('sidebar-item-vulnerabilities');
	}
    })();

  sticky_control('SummaryTable','vulnerabilities');

    // グラフの描画とリサイズ(navbar-btnのクリックイベントも含む)
    (function() {
	var timer = false;
	var action = function() {
	    if (timer !== false) {
		clearTimeout(timer);
	    }
	    timer = setTimeout(function() {
		var opt = {
		    grp: $('#pages_grp').val(),
		    idx: $('#pages_idx').val(),
		    risks: JSON.parse($('#risks').val()),
		    statuses: JSON.parse($('#statuses').val())
		};
		vul_heatmap(opt);
		risk_graph(opt);
		status_graph(opt);
	    }, 200);
	};

  $(window).on('load', function(){
      var loading_window = $('<div>').attr('id', 'wrap-loading-heatmap-window').append(
          $('<div>').attr({'id': 'loading-heatmap-window'}).append(
              $('<div>').attr({
                  'id': 'loading-heatmap-mark',
                  'class': 'spinner-border text-secondary',
                  'role': 'status',
              }).append(
                  $('<span>').attr('class', 'sr-only').text('Loading...')
              )
          )
      );
      $('#wrap-graph-heatmap').append(loading_window);
      setTimeout(function() {
          var opt = {
             grp: $('#pages_grp').val(),
             idx: $('#pages_idx').val(),
             risks: JSON.parse($('#risks').val()),
             statuses: JSON.parse($('#statuses').val())

          };
          vul_heatmap(opt);
          risk_graph(opt);
          status_graph(opt);
      });
  });
	$(window).on('resize', action);
	$('.navbar-btn').on('click', action);
    })();

  //サマリーテーブルにスクロール
  $(window).on('load', function() {
      setTimeout(function(){
          set_scroll();
          $(window).on('resize scroll', set_scroll);
      },200);
  });
    // ソート
    $('.sort-warning').on('click', sort_toggle('warning'));
    $('.sort-statuses').on('click', sort_toggle('statuses'));
    $('.sort-maxsri').on('click', sort_toggle('maxsri'));
    $('.sort-cvss').on('click', sort_toggle('cvss'));
    $('.sort-area').on('click', sort_toggle('area'));
    $('.sort-exploitable').on('click', sort_toggle('exploitable'));
    $('.sort-elapseddays').on('click', sort_toggle('elapseddays'));
    $('.sort-title').on('click', sort_toggle('title'));
    $('.sort-hostnames').on('click', sort_toggle('hostnames'));
    $('.sort-categories').on('click', sort_toggle('categories'));
    $('.sort-duedates').on('click', sort_toggle('duedates'));
    $('.sort-finished').on('click', sort_toggle('finished'));

    // カテゴリ名の差し替え(最初の表示時)
    $('.category-selector').text($('#category_name').val());

    //対象のカテゴリのtooltip表示
    //細工しないとdropdownの中のカテゴリを選択した時に、tooltipが２つ表示されてしまう 
    $('#selected-main-category').on('mouseenter', function(){
        $(this).tooltip('show');
    });

    $('#selected-main-category').on('mouseleave', function(){
        $(this).tooltip('hide');
    });

    $('#selected-main-category a').on('mouseenter', function(e){
        $('#selected-main-category').tooltip('hide');
        e.stopPropagation();
    });

    // カテゴリ変更
    $('.category-change').on('click', function() {
        reset_pages_checked_values();
        var e = $(this);
        var category_id = e.data('categoryid');
        $('#pages_category_id').val(category_id);
        $('#pages_offset').val('0');
        var form = $('#pages_form');
        form.attr('action', remove_anchor(form.attr('action')));
        form.submit();
        return true;
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages').on('click', function(e) {
	var button = $(this);
	var target = $(button.data('target'));
	var dump = {
	    'pages[offset]': $('#pages_offset').val(),
	    'pages[per_page]': $('#pages_per_page').val(),
	    'pages[order]' : $('#pages_order').val(),
	    'pages[filters]': JSON.parse($('#pages_filters').val()),
	    'pages[category_id]': $('#pages_category_id').val(),
	    'pages[grp]': $('#pages_grp').val(),
	    'pages[idx]': $('#pages_idx').val(),
	    'pages[checked]': [],
	    'pages[all_checked]': false
	};
	target.val(JSON.stringify(dump));
	return true;
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages-confirm').on('confirm:complete', function(e, answer) {
	if (answer) {
	    var button = $(this);
	    var target = $(button.data('target'));
	    var dump = {
		'pages[offset]': $('#pages_offset').val(),
		'pages[per_page]': $('#pages_per_page').val(),
		'pages[order]' : $('#pages_order').val(),
		'pages[filters]': JSON.parse($('#pages_filters').val()),
		'pages[category_id]': $('#pages_category_id').val(),
		'pages[grp]': $('#pages_grp').val(),
		'pages[idx]': $('#pages_idx').val(),
		'pages[checked]': [],
		'pages[all_checked]': false
	    };
	    target.val(JSON.stringify(dump));
	}
	return true;
    });

    // グラフ、評価指標初期化
    (function() {
	$('.gtpbtns-change').removeClass('active');
	$('.grpbtns-change > input').prop('checked', false);
	var grp = $('#pages_grp').val();
	if (grp) {
	    $('#grpbtns-' + grp).addClass('active');
	    $('#grpbtns-' + grp + ' > input').prop('checked', true);
	}
	$('.idxbtns-change').removeClass('active');
	$('.idxbtns-change > input').prop('checked', false);
	var idx = $('#pages_idx').val();
	if (idx) {
	    $('#idxbtns-' + idx).addClass('active');
	    $('#idxbtns-' + idx + ' > input').prop('checked', true);
	}
    })();

    // グラフ変更
    $('.grpbtns-change').on('click', function() {
	var button = $(this);
	var target = button.data('target');
	$('#pages_grp').val(target);
	var form = $('#pages_form');
	form.attr('action', remove_anchor(form.attr('action')));
	form.submit();
	return true;
    });

    // 評価指標変更
    $('.idxbtns-change').on('click', function() {
	var button = $(this);
	var target = button.data('target');
	$('#pages_idx').val(target);
	$('#pages_offset').val('0');
	var form = $('#pages_form');
	form.attr('action', remove_anchor(form.attr('action')));
	form.submit();
	return true;
    });

    $('.filter-change').on('click', function() {
  reset_pages_checked_values();
	var link = $(this);
	var name = link.data('name');
	var value = link.data('value');
	var filters = JSON.parse($('#pages_filters').val());
	// 強制的に文字列として設定。dataメソッドが、属性値をJSON.parse
	// してから返すため、数値の文字列を数値として解釈しまうため。
	filters[name] = String(value);
	if (name == 'sri' || name == 'cvss' || name == 'risk' || name == 'area') {
	    filters['warning'] = 'all';
	}
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

/*    $('.filter-change-exclusion').on('click', function() {
	var link = $(this);
	var name = link.data('name');
	var value = link.data('value');
	var filters = JSON.parse($('#pages_filters').val());
	filters['warning'] = String('all');
	filters['status'] = String('0');
	filters['sri'] = String('');
	filters['cvss'] = String('');
	filters['area'] = String('');
	filters['exploitable'] = String('');
	filters['due_date'] = '::';
	filters['date'] = '::'
	filters['keyword'] = String('');
  filters['product'] = {};
  filters['cvss_vector'] = {};
	// $('#pages_category_id').val('0');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_checked').val(JSON.stringify([]));
	$('#pages_all_checked').val('');
	$('#pages_offset').val('0');
	// 強制的に文字列として設定。dataメソッドが、属性値をJSON.parse
	// してから返すため、数値の文字列を数値として解釈しまうため。
	filters[name] = String(value);
	if (name == 'sri' || name == 'cvss') {
	    filters['status'] = String('1:2');
	}
	if (name == 'sri' || name == 'cvss' || name == 'risk' || name == 'area') {
	    filters['warning'] = 'all';
	}
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });
*/
    enable_filter_by_score_status();

    $('.filter-duedate-preset').on('click', function(e) {
	var button = $(this);
	var begindate = button.data('begindate');
	var enddate = button.data('enddate');
	var notset = button.data('notset');
	$('#filters_search_duedate_begin').val(begindate);
	$('#filters_search_duedate_end').val(enddate);
	$('#filters_search_duedate_notset').prop('checked', ('notset' === notset));
	return false;
    });

    $('.filter-duedate').on('click', function(e) {
  reset_pages_checked_values();
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	var begindate = $('#filters_search_duedate_begin').val();
	var enddate = $('#filters_search_duedate_end').val();
	var notset = $('#filters_search_duedate_notset').prop('checked');
	filters['due_date'] = String((notset ? 'notset' : '') + ':' + begindate + ':' + enddate);
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-duedate-reset').on('click', function(e) {
  reset_pages_checked_values();
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	filters['due_date'] = '::';
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-duedate-notset').on('click', function(e) {
	if ($(this).prop('checked')) {
	    $('#filters_search_duedate_begin').val('');
	    $('#filters_search_duedate_end').val('');
	}
	return true;
    });

    $('.filter-keyword').on('click', function() {
  reset_pages_checked_values();
	var filters = JSON.parse($('#pages_filters').val());
	var kwd = $('#filters_search_keyword').val();
	filters['keyword'] = String(kwd);
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-keyword-reset').on('click', function() {
  reset_pages_checked_values();
	var filters = JSON.parse($('#pages_filters').val());
	filters['keyword'] = String('');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-clear').on('click', function() {
	var filters = JSON.parse($('#pages_filters').val());
	filters['warning'] = String('all');
	filters['status'] = String('0');
	filters['sris'] = [];
	filters['cvsses'] = [];
	filters['area'] = String('');
	filters['exploitable'] = String('');
  filters['categories']['ids'] = [];
  filters['categories']['is_and'] = false;
  filters['categories']['is_except'] = false;
	filters['due_date'] = '::';
	filters['date'] = '::'
	filters['keyword'] = String('');
  filters['product'] = {};
  filters['cvss_vector'] = {};
	//$('#pages_category_id').val('0');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_checked').val(JSON.stringify([]));
	$('#pages_all_checked').val('');
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    /*$('.download').on('click', function() {
	$('#download_category_id').val($('#pages_category_id').val());
	$('#download_idx').val($('#pages_idx').val());
	$('#download_order').val($('#pages_order').val());
	$('#download_filters').val($('#pages_filters').val());
	$('#download_htmlids').val($('#pages_checked').val());
	$('#form-download').submit();
	return true;
    });*/

    $('.vulSelect').on('change', function() {
	var checkbox = $(this);
	var hostid = parseInt(checkbox.val());
	var checked = JSON.parse($('#pages_checked').val());
	var all_host_ids = JSON.parse($('#all_html_ids').val());
	var all_host_size = all_host_ids.length;
	if (checkbox.prop('checked')) {
	    if (!checked.includes(hostid)) {
		checked.push(hostid);
		if (checked.length == all_host_size) {
		    $('.allVulSelect').prop('checked', true);
		    $('#pages_all_checked').val('true');
		} else {
		    $('.allVulSelect').prop('checked', false);
		    $('#pages_all_checked').val('');
		}
		$('#pages_checked').val(JSON.stringify(checked));
	    }
	} else {
	    var idx = checked.indexOf(hostid);
	    if (idx == 0) {
		checked = checked.slice(1, all_host_size);
	    } else if (idx == all_host_size - 1) {
		checked = checked.slice(0, all_host_size - 1);
	    } else if (idx > 0 ) {
		var c_left = checked.slice(0, idx);
		var c_right = checked.slice(idx + 1, all_host_size);
		checked = c_left.concat(c_right);
	    }
	    $('#pages_checked').val(JSON.stringify(checked));
	    if (checked.length == all_host_size) {
		$('.allVulSelect').prop('checked', true);
		$('#pages_all_checked').val('true');
	    } else {
		$('.allVulSelect').prop('checked', false);
		$('#pages_all_checked').val('');
	    }
	}
	if (checked.length > 0) {
	    $('.bulkbtns').removeClass('disabled');
	    $('.bulkbtns').prop('disabled', false);
	} else {
	    $('.bulkbtns').addClass('disabled');
	    $('.bulkbtns').prop('disabled', true);
	}
	return true;
    });

    $('.allVulSelect').on('change', function() {
	var checkbox = $(this);
	if (checkbox.prop('checked')) {
	    $('#pages_checked').val($('#all_html_ids').val());
	    $('#pages_all_checked').val('true');
	    $('.vulSelect').prop('checked', true);
	    $('.bulkbtns').removeClass('disabled');
	    $('.bulkbtns').prop('disabled', false);
	} else {
	    $('#pages_checked').val(JSON.stringify([]));
	    $('#pages_all_checked').val('');
	    $('.vulSelect').prop('checked', false);
	    $('.bulkbtns').addClass('disabled');
	    $('.bulkbtns').prop('disabled', true);
	}
	return true;
    });

    //windowのresize時にmodalのtdを調整
    $(window).on('resize', function(){
        if( $('#modalEditStatus').is(':visible') ){
            $('.modalEditStatus-vul-td-inner').outerWidth($('#modalEditStatus-vul-th').outerWidth() - 1.5);
        }
        if($('#modalEditSchedule').is(':visible')){
            $('.modalEditSchedule-vul-td-inner').outerWidth($('#modalEditSchedule-vul-th').width() - 1);
        }
    });

    $('#modalEditStatus').on('hidden.bs.modal',function(){
        $('#modalEditStatusTargetList > *').remove();
    });

    const APPEND_VUL_NUM = 200;
    var is_appending = false
    function append_vuls_to_modalEditStatus(is_initial = false){
        is_appending = true;
        var appended_num = parseInt($('#modalEditStatus-appended-vuls-num').val());
        if( is_initial ){
            var htmlids = JSON.parse($('#pages_checked').val());
            $('#modalEditStatus_htmlids').val(JSON.stringify(htmlids));
        }else{
            var htmlids = JSON.parse($('#modalEditStatus_htmlids').val());
        }
        if( htmlids.length <= appended_num ){
            return false;
        }
        if( appended_num === 0 ){
            var target_htmlids = htmlids.slice(0, APPEND_VUL_NUM);
        }else{
            var target_htmlids = htmlids.slice(appended_num, appended_num + APPEND_VUL_NUM);
        }
        $.ajax({
            url: $('#htmls_statuses_path').val(),
            type: 'POST',
            dataType: 'json',
            data: { 'params[htmlids]': JSON.stringify(target_htmlids), 'params[category_id]': $('#category_id').val() },
            timeout: AJAX_TIMEOUT_SECOND
        })
        .done(function(data) {
            var htmls = Object.keys(data);
            if (htmls.length > 0) {
                if(Browser_Ident === 'Chrome'){
                    var overflow_class = '';
                }else if(Browser_Ident === 'FireFox'){
                    var overflow_class = ' overflow-clip';
                }else{
                    //Safari
                    var overflow_class = ' overflow-initial';
                }
                for (var i = 0; i < htmls.length; i++) {
                    var c_tr = $('<tr></tr>').attr('class', 'd-flex');
                    var c_td = $('<td></td>').attr({
                        'class': 'd-block modal-t-name' + overflow_class,
                         style: 'padding: 0.17rem 0px 0.17rem !important;'//cssで!importantされているもの上書き 
                    });// { class: 'hostname' });
                    c_td.append(
                        $('<div>').attr('class', 'modalEditStatus-vul-td-inner text-truncate')
                                  .css('padding', '0px 0.25rem 0px')
                                  .append(
                                      $('<span>').text(data[htmls[i]]['title'])
                                  )
                    );
                    c_tr.append(c_td);
                    c_td = $('<td></td>').attr('class', 'd-block modal-t-status');
                    var c_span = $('<span></span>', {
                        class: 'badge g-font-size-11 c_white'
                    });
                    if(i === 0){
                        var svg = status_bar(70, 12, data[htmls[i]]['status'], '件');
                        svg.find('a').data('placement', 'left');
                        c_span.append(svg);
                    }else{
                        c_span.append(status_bar(70, 12, data[htmls[i]]['status'], '件'));
                    }   
                    c_td.append(c_span);
                    c_tr.append(c_td);
                    $('#modalEditStatusTargetList').append(c_tr);
                }
                enable_bootstrap_actions('#modalEditStatusTargetList');
                $('.modalEditStatus-vul-td-inner').outerWidth($('#modalEditStatus-vul-th').outerWidth() - 1.5);
                $('#modalEditStatus-appended-vuls-num').val( appended_num + htmls.length );
                is_appending = false;
            }else{
                alert('指定したホストが削除されたため、画面をリロードします。');
                location.reload(true);
                return false;
            }
        })
        .fail(function(data) {
            alert('データの取得に失敗したため、画面をリロードします。');
            location.reload(true);
            return false;
        });
    }
    
    $('#modalEditStatusTargetList').on('scroll', function(){
        if( !is_appending ){
            append_vuls_to_modalEditStatus();
        }
    });

    $('#modalEditStatus').on('show.bs.modal', function(event) {
       is_appending = false;
       var submit_button = $('#modalEditStatusExecute');
       if( $('#modalEditStatusSelect').val() == 0 ){
           submit_button.prop('disabled', true);
           submit_button.attr('aria-disabled', 'true');
       }else{
           submit_button.prop('disabled', false);
           submit_button.attr('aria-disabled', 'false');
       }
       var button = $(event.relatedTarget);
       var htmlids = JSON.parse($('#pages_checked').val());
       if (htmlids.length > 0) {
           $('#modalEditStatus-appended-vuls-num').val(0);
           append_vuls_to_modalEditStatus(true);
       } else {
           return false;
       }
       return true;
   });

    $('#modalEditStatusSelect').on('change', function(event) {
	var target = $(this);
	var new_val = target.val();
	var button = $('#modalEditStatusExecute');
	if ('0' == new_val) {
	    button.prop('disabled', true);
	    button.attr('aria-disabled', 'true');
	} else {
	    button.prop('disabled', false);
	    button.attr('aria-disabled', 'false');
	}
	return true;
    });

    
    function append_vuls_to_modalEditSchedule(is_initial = false){
        is_appending = true;
        var appended_num = parseInt($('#modalEditSchedule-appended-vuls-num').val());
        if( is_initial ){
            var htmlids = JSON.parse($('#pages_checked').val());
            $('#modalEditSchedule_htmlids').val(JSON.stringify(htmlids));
            $('#modalEditSchedule').modal('show');
        }else{
            var htmlids = JSON.parse($('#modalEditSchedule_htmlids').val());
        }
        if( htmlids.length <= appended_num ){
            return false;
        }
        if( appended_num === 0 ){
            var target_htmlids = htmlids.slice(0, APPEND_VUL_NUM);
        }else{
            var target_htmlids = htmlids.slice(appended_num, appended_num + APPEND_VUL_NUM);
        }
            $.ajax({
                url: $('#htmls_due_dates_path').val(),
                type: 'POST',
                dataType: 'json',
                data: { 'params[htmlids]': JSON.stringify(target_htmlids), 'params[category_id]': $('#category_id').val() },
                timeout: AJAX_TIMEOUT_SECOND
            }).done(function(data) {
                var htmls = Object.keys(data);
                if (htmls.length > 0) {
                    if(Browser_Ident === 'Chrome'){
                        var overflow_class = '';
                    }else if(Browser_Ident === 'FireFox'){
                        var overflow_class = ' overflow-clip';
                    }else{
                        //Safari
                        var overflow_class = ' overflow-initial';
                    }
                    for (var i = 0; i < htmls.length; i++) {
                        var c_tr = $('<tr></tr>').attr('class', 'd-flex');
                        var c_td = $('<td></td>').attr({
                            'class': 'd-block modal-t-name' + overflow_class,
                             style: 'padding: 0.17rem 0px 0.17rem !important;'//cssで!importantされているもの上書き
                        });//, { class: 'hostname' });
                        c_td.append(
                            $('<div>').attr('class', 'modalEditSchedule-vul-td-inner text-truncate').css('padding', '0px 0.25rem 0px').append(
                                $('<span>').text(data[htmls[i]]['title'])
                            )
                        );
                        c_tr.append(c_td);
                        c_td = $('<td></td>', { class: 'd-block modal-t-date' });
                        var due_dates = data[htmls[i]]['due_dates'];
                        for (var j = 0; j < due_dates.length; j++) {
                            var c_div = $('<div></div>');
                            c_div.text(due_dates[j] ? due_dates[j] : '未設定');
                            c_td.append(c_div);
                        }
                        c_tr.append(c_td);
                        $('#modalEditScheduleTargetList').append(c_tr);
                    }
                    $('#modalEditScheduleExecute').prop('disabled', false);
                    $('.modalEditSchedule-vul-td-inner').outerWidth($('#modalEditSchedule-vul-th').width());
                    $('#modalEditSchedule-appended-vuls-num').val( appended_num + htmls.length );
                    is_appending = false;
                } else {
                    alert('指定したホストが削除されたため、画面をリロードします。');
                    location.reload(true);
                    return false;
                }
            }).fail(function(data) {
                alert('データの取得に失敗したため、画面をリロードします。');
                location.reload(true);
                return false;
            })
    }
   
    $('#modalEditSchedule').on('hidden.bs.modal', function(){
        $('#modalEditScheduleTargetList > *').remove();
    });

    $('#modalEditScheduleTargetList').on('scroll', function(){
        if( !is_appending ){
            append_vuls_to_modalEditSchedule();
        }
    });
    
    $('#bulk-edit-schedule').on('click', function(){
	      var button = $(this);
        var htmlids = JSON.parse($('#pages_checked').val());
        var filtered_htmlids = [];
        var untargeted_vuls = [];
        var unfinished_status_html_ids = JSON.parse($('#unfinished_status_html_ids').val());
        for(var i = 0; i < htmlids.length; i++){
            var h_id = htmlids[i];
            if(!unfinished_status_html_ids.includes(h_id)){
                untargeted_vuls.push('.vulSelect[value="' + h_id + '"]');
            }else{
                filtered_htmlids.push(h_id);
            }
        }
        if(filtered_htmlids.length === 0){
            alert('対象となる脆弱性は存在しません。\n※未対策と対策中の脆弱性のみ、対策予定日を設定できます。');
            return false;
        }
        if(untargeted_vuls.length > 0 ){
            $('#bulk-edit-schedule-caution').show();
            $('#allSelect').prop('checked', false);
        }else{
            $('#bulk-edit-schedule-caution').hide();
        }
        htmlids = filtered_htmlids;
        $('#pages_checked').val(JSON.stringify(htmlids));
        $('#SortTR').find(untargeted_vuls.join(', ')).prop('checked', false);
        if (htmlids.length > 0) {
            $('#modalEditSchedule-appended-vuls-num').val(0)
            append_vuls_to_modalEditSchedule(true);
        } else {
            return false;
        }
    });

    $('#form_status').on('submit', function(){
        var msg = '指定した脆弱性の内、変更対象ステータスで指定した対応状況に該当するもの全てが更新されます。本当に実行してよろしいですか？';
        var info = {
            'ids': JSON.parse($('#pages_checked').val()),
            'prev_status': $('#modalEditStatusPrev').val(),
            'new_status': $('#modalEditStatusSelect').val(),
            'comment': $('#modalEditStatus-comment-field').val(),
            'category_id': $('#category_id').val()
        }
        execute_process_with_progress_bar('status', msg, info, $('#sidfm_vulnerabilities_update_status_path').val());
        return false;
    });

    $('#form_due_dates').on('submit', function(){
        var msg =  '「強制上書き」が有効な場合は指定した脆弱性全て、無効な場合は対策予定日が設定されていない脆弱性の内、対策が終了していないもの全ての対策予定日が更新されます。本当に実行してよろしいですか？';
        var info = {
            'ids': JSON.parse($('#pages_checked').val()),
            'force': $('#modalEditSchedule-force-flg').prop('checked'),
            'due_date': $('#modalEditSchedule-due-date').val(),
            'comment': $('#modalEditSchedule-comment-field').val(),
            'category_id': $('#category_id').val()
        };
        execute_process_with_progress_bar('schedule', msg, info, $('#sidfm_vulnerabilities_update_due_dates_path').val());
        return false;
    });

  function get_popover_btn(names_array, userid, type){
      var elms_for_popover = '';
      if(type === 'host'){
          var top_name = names_array[0]['display_name'];
          for(var j = 0; j < names_array.length; j++){
              var t_host = names_array[j];
              elms_for_popover += "<div class='p-1 max-width-160px g-font-size-0_93x text-left text-truncate border list_alternative' data-toggle='tooltip' data-title='" + 'ホスト名: ' + t_host['hostname'] + '<br/>表示名: ' + (t_host['ext_name'] ? t_host['ext_name'] : '(未設定)') + "' data-html= 'true' data-boundary='window' data-placement='right'>" + t_host['display_name'] + '</div>';
          }
      }else{
          var top_name = names_array[0];
          for(var j = 0; j < names_array.length; j++){
              elms_for_popover += '<div class="p-1 max-width-160px g-font-size-0_93x text-left text-truncate border list_alternative">' + escape_html_special_chars(names_array[j]) + '</div>';
          }
      }
      var popover_btn = $('<div>').attr({
                            'class': 'max-width-160px',
                        }).append(
                             $('<div>').attr({
                                 'class': ' mail-btn show-original-popover btn btn-xs btn-light-nb text-nowrap w-100',
                                 'data-popoverid': type + userid,
                                 'data-html': 'true',
                                 'data-content': elms_for_popover,
                             }).append(
                                 $('<div>').attr('class', 'd-flex').append(
                                     $('<span>').attr('class', 'text-left mr-1 inline-block text-truncate w-100')
                                                .text(top_name),
                                     $('<span>').attr('class', 'position-static ml-auto inline-block badge badge-pill badge-gray-999')
                                                .text(names_array.length)
                                 )
                             )
                         );
      return popover_btn
  }

  $('#modalSendMail').on('show.bs.modal', function(event) {
  $('#loading').hide();
  $('#recipients').val(JSON.stringify({}));
  $('#users_sidinfo').val(JSON.stringify([]));
  $('#AllUsersSelect').prop('checked', false);
  $('#count-letters').text('0');
  revert_changekeywords_btn();
  $('#keyword_loading').remove();
  $('#mail-length-over').attr('class', 'invisible');
  $('#limit-keywords-data').text('20件');
  $('#limit-data-num').val(20);
  $('#show-byte').text('byte');
  $('#modalSendMailTargetList .chk-box .user-chk-box').prop('checked', false);
	var button = $(event.relatedTarget);
	var htmlids = JSON.parse($('#pages_checked').val());
	if (htmlids.length > 0) {
      $('#modal-main').hide();
      $('#loading').show();
	    $.ajax({
		url: $('#htmls_emails_path').val(),
		type: 'POST',
		dataType: 'json',
		data: { 'params[htmlids]': JSON.stringify(htmlids) },
		timeout: 5000
	    })
	    .done(function(data) {
    $('#loading').hide();
    $('#modal-main').show();
		var htmls = data['htmls'];
		var users = data['users'];
    if(users.length === 0){
        $('#AllUsersSelect').prop('disabled', true);
    }
		var userids = Object.keys(users);
    if(userids.length === 0){
        $('#AllUsersSelect').prop('disabled', true);
    } else {
        $('#AllUsersSelect').prop('disabled', false);
    }
    $('#modalSendMailTargetList > *').remove();
		if (userids.length > 0) {
        var users_without_id = [];
        for (var i = 0; i < userids.length; i++) {
            var user = users[userids[i]];
            users_without_id.push(user);
        }
        users_without_id = users_without_id.sort(function(a, b) {
                           if(a['lastname'].toString().toLowerCase() > b['lastname'].toString().toLowerCase()){
                               return 1;
                           }else if(a['lastname'].toString().toLowerCase() === b['lastname'].toString().toLowerCase()){
                               if(a['firstname'].toString().toLowerCase() > b['firstname'].toString().toLowerCase()){
                                   return 1;
                               } else {
                                   return -1;
                               }
                           }else{
                               return -1;
                           }
                           });
      var all_users = {};
      var users_sidinfo = [];
      var user_num = 0;
		  for (var i = 0; i < userids.length; i++) {
      user_num += 1;
      var user = users_without_id[i];
      var fullname = user['lastname'] + ' ' +  user['firstname'];
		  var c_tr = $('<tr></tr>').attr('class', '');
      var c_td = $('<td></td>', { class: 'chk-box modal-mail-chkbox text-center' });
      var c_chkbox = $('<input>', { type: 'checkbox', class: 'user-chk-box'});
      c_td.append(c_chkbox);
      c_tr.append(c_td);
			c_td = $('<td></td>', { class: 'name modal-mail-name' });
			c_td.text(fullname);
			c_tr.append(c_td);
			c_td = $('<td></td>', { class: 'mailaddress modal-mail-address' });
			for (var j = 0; j < user['emails'].length; j++) {
			    var email = user['emails'][j];
			    var c_div = $('<div class="text-truncate modal-mail-address"></div>');
			    c_div.text(email['address']);
			    c_td.append(c_div);
          all_users[email['address']] = fullname;
			}
			c_tr.append(c_td);
      var category_names = [];
			c_td = $('<td></td>', { class: 'category modal-mail-category' });
			for (var j = 0; j < user['categories'].length; j++) {
			    var category = user['categories'][j];
			    category_names.push(category['name']);
			}
      if(category_names.length > 1){
          category_names.sort();
          var categories_elm = get_popover_btn(category_names, userids[i], 'category');
      }else{
          var categories_elm = $('<div>').attr('class', 'g-pl-5 g-font-size-0_93x text-truncate max-width-160px').text(category_names[0]);
      }
      c_td.append(categories_elm);
			c_tr.append(c_td);
      var temp_hostnames = [];
			c_td = $('<td></td>', { class: 'host modal-mail-host' });
			for (var j = 0; j < user['hosts'].length; j++) {
			    var t_host = user['hosts'][j];
          var hostname = t_host['hostname'];
          var ext_name = t_host['ext_name'];
			    temp_hostnames.push(
              {
                   'hostname': hostname,
                   'ext_name': ext_name,
                   'display_name': (ext_name ? ext_name : hostname)
              }
          );
			}
      if(temp_hostnames.length > 1){
          temp_hostnames.sort(function(a, b){
              if(a['display_name'].toLowerCase() > b['display_name'].toLowerCase()){
                  return 1;
              }else{
                  return -1;
              }
          });
          var hosts_elm = get_popover_btn(temp_hostnames, userids[i], 'host');
      }else{
          var t_host = temp_hostnames[0];
          var hosts_elm = $('<div>').attr({
               'class': 'g-pl-5 g-font-size-0_93x text-truncate max-width-160px',
               'data-toggle': 'tooltip',
               'data-title': 'ホスト名: ' + t_host['hostname'] + '<br/>表示名: ' + (t_host['ext_name'] ? t_host['ext_name'] : '(未設定)'),
               'data-html': 'true',
               'data-boundary': 'window',
               'data-placement': 'right'
          }).text(t_host['display_name']);
      }
      c_td.append(hosts_elm);
			c_tr.append(c_td);
      var userinfo = {
          'num': user_num, 
          'category_names': category_names, 
          'hostnames': temp_hostnames.map(function(host){ return host['hostname'] }),
          'display_names': temp_hostnames.map(function(host){ return host['display_name'] }),
      };
      c_chkbox.val(JSON.stringify(userinfo));
      users_sidinfo.push(userinfo);
			$('#modalSendMailTargetList').append(c_tr);
      $('#modalSendMailTargetList').find('[data-toggle="tooltip"]').tooltip();
		    }
		    $('#modalSendMailNotice > *').remove();

      $('#modalSendmailBodyTitle').val('');
      $('#modalSendmailBodyText').val('');
      $('#keywords-list').prop('disabled', false);
      $('#modalSendmailExecute').prop('disabled', true);
      $('#MailConfirmation-btn').prop('disabled', true);
      $('#change-keywords').prop('disabled', false);
      $('#limit-keywords-data').prop('disabled', false);
      $('#reset-mailmodal').prop('disabled', false);
      var chk_box_length = $('#modalSendMailTargetList .user-chk-box').length;
      $('#modalSendMailTargetList .chk-box .user-chk-box').on('change', function() {
          var checkbox = $(this);
          var user_info = JSON.parse(checkbox.val());
          var temp_users_sidinfo = JSON.parse($('#users_sidinfo').val());
          var recipients = JSON.parse($('#recipients').val());
          var user_address = checkbox.parent().siblings('.mailaddress').text();
          var user_name = checkbox.parent().siblings('.name').text();
          if (checkbox.prop('checked')) {
              temp_users_sidinfo.push(user_info);
              recipients[user_address] = user_name;
          }else{
              for(var i = 0; i < temp_users_sidinfo.length; i++){
                  if(temp_users_sidinfo[i]['num'] === user_info['num']){
                      temp_users_sidinfo.splice(i, 1);
                  }
              }
              delete recipients[user_address];
          }
          if (Object.keys(recipients).length === chk_box_length){
              $('#AllUsersSelect').prop('checked', true);
          }else{
              $('#AllUsersSelect').prop('checked', false);
          }
          if($('.user-chk-box:checked').length === 0){
              $('#modalSendmailExecute').prop('disabled', true);
          }else{
              if($('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
                  $('#modalSendmailExecute').prop('disabled', false);
              }
          }
          $('#recipients').val(JSON.stringify(recipients));
          $('#users_sidinfo').val(JSON.stringify(temp_users_sidinfo));
      });
      $('#AllUsersSelect').on('change', function (){
          var all_chk_box = $('#modalSendMailTargetList .user-chk-box');
          if ($(this).prop('checked')) {
              all_chk_box.prop('checked', true);
              $('#recipients').val(JSON.stringify(all_users));
              $('#users_sidinfo').val(JSON.stringify(users_sidinfo));
              if($('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
                   $('#modalSendmailExecute').prop('disabled', false);
              }
          }else{
              all_chk_box.prop('checked', false);
              $('#recipients').val(JSON.stringify({}));
              $('#users_sidinfo').val(JSON.stringify([]));
              $('#modalSendmailExecute').prop('disabled', true);
          }
      });
      $('#modalSendmailBodyTitle').on('keydown', function(e) {
          if(e.keyCode && e.keyCode === 13){
              return false;
          }
      });
   
      $('#modalSendMail').on('hide.bs.modal', function (){
         $('.dropdown-menu.show:last').closest('.action-close-dropdown').find('.dropdown-toggle').click();
         // edited_title = $('#modalSendmailBodyTitle').val();
         // edited_text = $('#modalSendmailBodyText').val();
      });
      // tableのcss設定中は表示見せない
      //$('#modalSendMailTargetList').css('opacity', '0.05');

      set_modal_mail_btn_font_size()

		} else {
		    var temp = $('<div></div>', {
			class: 'alert alert-danger',
			role: 'alert'
		    });
		    temp.text('指定したホストに、メール送信可能なユーザが関連付けられたカテゴリが設定されておりません。メール送信を行うためには、ユーザを関連づけたカテゴリを作成し、各ホストのカテゴリとして追加登録する必要があります。');
		    $('#modalSendMailNotice > *').remove();
		    $('#modalSendMailNotice').append(temp);
        $('#modalSendmailBodyTitle').val('');
        $('#modalSendmailBodyText').val('');
		    $('#modalSendmailExecute').prop('disabled', true);
        $('#MailConfirmation-btn').prop('disabled', true);
        $('#keywords-list').prop('disabled', true);
        $('#change-keywords').prop('disabled', true);
        $('#limit-keywords-data').prop('disabled', true);
        $('#reset-mailmodal').prop('disabled', true);
		}
 	    })
            .fail(function(data) {
		alert('データの取得に失敗したため、画面をリロードします。');
		location.reload(true);
		return false;
	    });
	} else {
	    return false;
	}
	return true;
    });
  $('#modalSendmailBodyText, #modalSendmailBodyTitle').on('input', function(){
      if($('#change-keywords').text() === 'キーワードに戻す'){
          revert_changekeywords_btn();
      }
      check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
      if($('#recipients').val() != '{}' && $('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
          $('#modalSendmailExecute').prop('disabled', false);
      }else{
          $('#modalSendmailExecute').prop('disabled', true);
      }
  });

  $('#modalSendMail').on('shown.bs.modal',function(){
      //heightを設定してロードマーク表示時に崩れないようにする
      $('#LoadingTarget').height($('#change-keywords').height());
  });
//  var timer = setInterval(function(){
//      if(!$('#loading').is(':visible') && $('#modalSendMailTargetList').css('opacity') === '0.05'){ 
//          $('#modalSendMailTargetList').find('tr')
//         .each(function(){
//              var tr = $(this);
//              var tr_height = $(this).height();
//              var box = tr.find('.chk-box');
//              var name = tr.find('.name');
//              var addr = tr.find('.mailaddress');
//              var category = tr.find('.category');
//              var host = tr.find('.host');
//              var b_height = box.height();
//              var n_height = name.height();
//              var ad_height = addr.height();
//              var c_height = 0;
//              var h_height = 0;
//              category.find('.cat-item').each(function(){
//                  c_height += $(this).height();
//              });
//              host.find('.host-item').each(function(){
//                   h_height += $(this).height();
//              });
//              var h = (tr_height - b_height) / 2;
//              box.css({'cssText': 'padding-top:' + h + 'px !important;'});
//              h = (tr_height - n_height) / 2;
//              name.css({'cssText': 'padding-top:' + h + 'px !important;'});
//              h = (tr_height - ad_height) / 2;
//              addr.css({'cssText': 'padding-top:' +  h + 'px !important;'});
//              h = (tr_height - c_height) / 2;
//              category.css({'cssText': 'padding-top:' + h + 'px !important;'});
//              h = (tr_height - h_height) / 2;
//              host.css({'cssText': 'padding-top:' + h + 'px !important;'});
//             // tdのheight100%を設定するためにcssに高さを伝える
//             $(this).height($(this).height());
//         });
//         $('#modalSendMailTargetList').css('opacity', '');
//         clearInterval(timer);
//      }
//   }, 100);
//});

  function set_modal_mail_btn_font_size(){
      if($(window).width() < 992){
          $('#modalSendMail').find('.modal-mail-footer-part').css('font-size', '75%');
      }else{
          $('#modalSendMail').find('.modal-mail-footer-part').css('font-size', '');
      }
  }

  $(window).on('resize', set_modal_mail_btn_font_size);

  //var edited_text;
  //var edited_title;
  function revert_changekeywords_btn() {
      $('#change-keywords').text('キーワードを変換')
                           .attr('class', 'btn btn-light btn-sm text-nowrap')
                           .data('replace', 'replace')
                           .css('color', 'black');
  }
  function change_changekeywords_btn(){
       $('#change-keywords').text('キーワードに戻す')
                            .attr('class', 'btn btn-secondary btn-sm text-nowrap')
                            .data('replace', 'revert')
                            .css('color', 'white');
  }
  
  $('#modalSendmailExecute').on('click', function(){
      if($('#modalSendmailBodyTitle').val().length === 0){
          alert('件名を入力して下さい');
          return false;
      }
      if($('#modalSendmailBodyText').val().length ===0){
          alert('本文を入力して下さい');
          return false;
      }
      $('#wrap-modalSendmailExecute').append(
           $('<div>').attr('id', 'conf-btn-loading-mark').append(
               $('<div>').attr('class', '_loading mx-auto')
           )
      );
      replace_mail_keywords('#confirm-subject', '#confirm-message', true);
  });
  $('#mail-cancel, #close-mailmodal').on('click', function(){
       if($('#modalSendmailBodyText').val() != '' || $('#modalSendmailBodyTitle').val() != ''){
           return confirm('メールの内容は破棄されます。よろしいですか？');
       }
   });
  $('#MailConfirmation').on('hide.bs.modal', function(){
      $('#modalSendmailBodyTitle').val($('#confirm-subject').text());
      $('#modalSendmailBodyText').val($('#confirm-message').val());
      check_mail_length($('#confirm-message').val() + $('#confirm-subject').text());
  });
  $('#MailConfirmation').on('show.bs.modal', function (e){
      $('#confirm-recipients > *').remove();
      var recipients = JSON.parse($('#recipients').val());
      $.each(recipients, function( address, name) {
         var recipient_text = name + '<' + address + '>';
         var recipient = $('<tr><td></td></tr>');
         recipient.text(recipient_text);
         $('#confirm-recipients').append(recipient);
      });
      /*replace_mail_keywords('#confirm-subject', '#confirm-message', true);
      var bytes = calc_bytes($('#confirm-message').val() + $('#confirm-subject').text());
      if(bytes > 1048576){
          $('#warn-length-over').attr('class', 'ml-auto visible');
          $('#MailConfirmationSubmit').prop('disabled', true);
      }else{
          $('#warn-length-over').attr('class', 'ml-auto invisible');
          $('#MailConfirmationSubmit').prop('disabled', false);
      }*/
  });
  /*var unhandled_rate = $('#unhandled_rate').val() + '%';
  var URL = location.href.replace(/index_r/, 'index');
  var page_title = $('#sidfm_header_title').text();
  var risks = JSON.parse($('#number_of_risks').val());
  var risks_text;
  var risks_names;
  var nums;
  if (risks['sri']){
      risks_names = ['重大', '高', '中', '低', '無', '済'];
      nums = risks['sri'];
  }else if (risks['cvss']){
      nums = risks['cvss'];
      risks_names = ['未登録', ' 10.0～9.0', ' 8.9～7.0', ' 6.9～4.0', ' 3.9～0.0', ' 済'];
  }
  calculate_percentage(nums, risks_names, 'risks');
  var status_text;
  var status_nums = JSON.parse($('#number_of_status').val());
  var status_names = [' 未対策', ' 対策中', ' 対策済', ' 影響無'];
  calculate_percentage(status_nums, status_names, 'status');
  function calculate_percentage(numbers, labelnames, section){
      var sum = 0;
      var text = [];
      for (var i = 0; i < numbers.length; i++){
          sum += parseInt(numbers[i]);
      }
      for (var i = 0; i < labelnames.length; i++){
          var num = parseInt(numbers[i]);
          var percentage = (num / sum * 100).toFixed(3);
          if(percentage >= 10){
              percentage = (num / sum * 100).toFixed(1);
          } else if(percentage < 10 && percentage >= 1) {
              percentage = (num / sum * 100).toFixed(2);
          }
          percentage = parseFloat(percentage) + '%';
          text.push(labelnames[i] + ': ' + percentage);
      }
      if(section === 'risks'){
          risks_text = text;
      } else {
          status_text = text;
      }
  }
  var risks_rate = risks_text.join(',');
  var handling_rate = status_text.join(',');
  var osnames = JSON.parse($('#osnames').val());
  var osnames_with_percentage = [];
  var myuserinfo = JSON.parse($('#myuserinfo').val());
  var myusername = myuserinfo['name'];
  var myemail = myuserinfo['email'];
  var mylogin = myuserinfo['login'];
  for(osname in osnames){
      osnames_with_percentage.push(osname + ': ' + osnames[osname] + '%');
  }
  osnames = Object.keys(osnames);*/
  function replace_mail_keywords(subject_field, message_field, is_conf_modal = false){
      var unhandled_rate = $('#unhandled_rate').val() + '%';
      var URL = location.href.replace(/index_r/, 'index');
      var page_title = $('#sidfm_header_title').text();
      var risks = JSON.parse($('#number_of_risks').val());
      var risks_text;
      var risks_names;
      var nums;
      if (risks['sri']){
          risks_names = ['重大', '高', '中', '低', '無', '済'];
          nums = risks['sri'];
      }else if (risks['cvss']){
          nums = risks['cvss'];
          risks_names = ['未登録', ' 10.0～9.0', ' 8.9～7.0', ' 6.9～4.0', ' 3.9～0.0', ' 済'];
      }
      calculate_percentage(nums, risks_names, 'risks');
      var status_text;
      var status_nums = JSON.parse($('#number_of_status').val());
      var status_names = [' 未対策', ' 対策中', ' 対策済', ' 影響無'];
      calculate_percentage(status_nums, status_names, 'status');
      function calculate_percentage(numbers, labelnames, section){
          var sum = 0;
          var text = [];
          for (var i = 0; i < numbers.length; i++){
              sum += parseInt(numbers[i]);
          }
          for (var i = 0; i < labelnames.length; i++){
              var num = parseInt(numbers[i]);
              var percentage = (num / sum * 100).toFixed(3);
              if(percentage >= 10){
                  percentage = (num / sum * 100).toFixed(1);
              } else if(percentage < 10 && percentage >= 1) {
                  percentage = (num / sum * 100).toFixed(2);
              }
              percentage = parseFloat(percentage) + '%';
              text.push(labelnames[i] + ': ' + percentage);
          }
          if(section === 'risks'){
              risks_text = text;
          } else {
              status_text = text;
          }
      }
      var risks_rate = risks_text.join(',');
      var handling_rate = status_text.join(',');
      var osnames = JSON.parse($('#osnames').val());
      var osnames_with_percentage = [];
      var myuserinfo = JSON.parse($('#myuserinfo').val());
      var myusername = myuserinfo['name'];
      var myemail = myuserinfo['email'];
      var mylogin = myuserinfo['login'];
      for(osname in osnames){
          osnames_with_percentage.push(osname + ': ' + osnames[osname] + '%');
      }
      osnames = Object.keys(osnames);
 
      var limit_num = parseInt($('#limit-data-num').val());
      var checked = JSON.parse($('#pages_checked').val());
      var selected_users = [];
      var recipients_sidinfo = JSON.parse($('#users_sidinfo').val());
      var recipients_hostnames = [];
      var recipients_display_names = [];
      var recipients_categories = [];
      for(var i = 0; i < recipients_sidinfo.length; i++){
          var info = recipients_sidinfo[i];
          recipients_hostnames.push(info['hostnames']);
          recipients_display_names.push(info['display_names']);
          recipients_categories.push(info['category_names']);
      }
      recipients_hostnames = Array.prototype.concat.apply([], recipients_hostnames);
      recipients_display_names = Array.prototype.concat.apply([], recipients_display_names);
      recipients_categories = Array.prototype.concat.apply([], recipients_categories);
      var self_categories = JSON.parse($('#self_user_categories').val());
      var self_custom_category_names = [];
      var self_system_category_names = [];
      for(var i = 0; i < self_categories.length; i++){
          var c = self_categories[i];
          if(c['custom_c']){
              self_custom_category_names.push(c['custom_c']);
          }else if(c['system_c']){
              self_system_category_names.push(c['system_c']);
          }
      }
      var c_category_list = [];
      var s_category_list = [];
      var hostnames_list = [];
      var display_names_list = [];
      var vuls_info_list = [];
      var vulsnames_list = [];
      var links_to_vuldetail = [];
      var vul_selectors = [];
      var all_area = ['未定義 ', 'ローカル ', 'クライント ', 'リモート '];
      var all_status_names = ['未対策', '対策中', '対策済', '影響無'];
      var all_sri_status = ['無', '低', '中', '高', '重大'];
      var count = 0;
      var subject_val = $('#modalSendmailBodyTitle').val();
      var message_val = $('#modalSendmailBodyText').val();

      var path = $('#sidfm_internal_api_get_vul_view_send_mail_data_path').val();
      var is_list_related_keywords = (subject_val + message_val).match(/%VULNERABILITY%|%VULTITLE%|%LINKS%|%HOST%|%DISPLAY_NAME%|%S_CATEGORY%|%C_CATEGORY%/);
      $.ajax({
          type: 'POST',
          url: path,
          data: { 
              'html_ids': is_list_related_keywords ? JSON.stringify(checked) : '[]',
              'index': $('#pages_idx').val(),
              'category_id': $('#category_id').val()
          }
      }).done(function(data){
          if( data['err_message'] ){
              alert(data['err_message']);
              location.reload();
              return false;
          }
          $.each(data['data'], function(){
              var vul = this;
              var vulid = vul.html_id;
              var vulname = vul.vulname;
              vulsnames_list.push(vulname);
              var hostnames = vul.hostnames;
              hostnames_list.push(...hostnames);
              var display_names = vul.display_names;
              display_names_list.push(...display_names);
              var s_cat = vul.system_category;
              var c_cat = vul.custom_category;
              if(s_cat.length > 0){
                  s_category_list.push(...s_cat);
              }
              if(c_cat.length > 0){
                  c_category_list.push(...c_cat);
              }
              if(count < limit_num ){
                  var link = location.origin + url_vulnerability_detail(vulid);
                  var link_with_vulname = vulname + '\n'+ link;
                  links_to_vuldetail.push(link_with_vulname);
              }
              if(subject_val.indexOf('%VULNERABILITY%') != -1 || message_val.indexOf('%VULNERABILITY%') != -1){
                  if(count < limit_num ){
                      var areaid = vul.area_id;
                      var area = all_area[areaid];
                      var status_ids = vul.status_ids;
                      var noreg = 0;
                      var local = 0;
                      var client = 0;
                      var remote = 0;
                      var status_nums = [noreg, local, client, remote];
                      for(var i = 0; i < status_ids.length; i++){
                          var status_id = status_ids[i] - 1;
                          status_nums[status_id] += 1;
                      }  
                      var h_status = '';
                      for(var i = 0; i < all_status_names.length; i++){
                          h_status += all_status_names[i] + status_nums[i] + '件 ';
                      }        
                      var detected_date = vul.detected_date;
                      var elapsed_days = vul.elapsed_days; 
                      var taiou = vul.taiou;
                      var sri_id = vul.sri;
                      var sri = all_sri_status[sri_id];
                      var cvss = vul.cvss;
                      var exploit = vul.exploit;
                      var tackle_date = vul.tackle_date;
                      var tackle_status = vul.tackle_status;
                      if(s_cat.length > 0){
                          s_cat = s_cat.join(', ');
                      }else{
                          s_cat = 'なし';
                      }
                      if(c_cat.length > 0){
                          c_cat = c_cat.join(', ');
                      }else{
                          c_cat = 'なし';
                      }
                      var text = [ 
                          vulname, 
                          link, 
                          '関連するホスト:' + (display_names.length > 0 ? display_names.join(', ') : 'なし'), 
                          'システムカテゴリ:' + s_cat + '   ' + 'カスタムカテゴリ:' + c_cat,
                          '対応:' + taiou + '   ' + 'SRI値:' + sri + '   ' + 'CVSS値:' + cvss + '   ' +  '影響範囲:' + area + '   ' +  '攻撃コード:' + exploit,
                          '対応状況:' + h_status, 
                          '検出日:' + detected_date + '   ' + '検出後最長経過日数:' + elapsed_days + '   ' +  '対策予定日設定済:' + tackle_date + '   ' + '対処率:' + tackle_status 
                      ];
                      vuls_info_list.push(text.join('\n'));
                  }
              }
              count += 1;
          }); 
       
          hostnames_list = Array.from(new Set(hostnames_list));
          display_names_list = Array.from(new Set(display_names_list));
          c_category_list = Array.from(new Set(c_category_list));
          s_category_list = Array.from(new Set(s_category_list));
          vulsnames_list = Array.from(new Set(vulsnames_list));
          recipients_categories = Array.from(new Set(recipients_categories));
          recipients_hostnames = Array.from(new Set(recipients_hostnames));
          recipients_display_names = Array.from(new Set(recipients_display_names));
          var sort_list = [
              self_custom_category_names, osnames, hostnames_list, display_names_list, c_category_list, s_category_list,
              recipients_categories, recipients_hostnames, recipients_display_names
          ];
          for(var n = 0; n < sort_list.length; n ++){
              var l = sort_list[n];
              l.sort(function(a, b){
                  if(a.toLowerCase() > b.toLowerCase()){
                       return 1;
                  }else{
                      return -1;
                  }
              });
          }
    
          var u_checked  = JSON.parse($('#recipients').val());
          var limited_osnames_with_percentage = osnames_with_percentage.slice(0, limit_num);
          var limited_osnames = osnames.slice(0, limit_num);
          for (key in u_checked){
              selected_users.push(u_checked[key]);
          }
     
          hostnames_list = hostnames_list.slice(0, limit_num);
          display_names_list = display_names_list.slice(0, limit_num);
          c_category_list = c_category_list.slice(0, limit_num);
          s_category_list = s_category_list.slice(0, limit_num);
          recipients_categories = recipients_categories.slice(0, limit_num);
          recipients_hostnames = recipients_hostnames.slice(0, limit_num);
          recipients_display_names = recipients_display_names.slice(0, limit_num);
          selected_users = selected_users.slice(0, limit_num);
          self_system_category_names = self_system_category_names.slice(0, limit_num);
          self_custom_category_names = self_custom_category_names.slice(0, limit_num);
          limited_osnames_with_percentage = osnames_with_percentage.slice(0, limit_num);
          limited_osnames = osnames.slice(0, limit_num);
          vulsnames_list = vulsnames_list.slice(0, limit_num);
              
          function replace_keywords(text) {
              var replaced_text =
                  text.replace(/%VULNERABILITY%/, vuls_info_list.join('\n\n'))
                      .replace(/%LINKS%/, links_to_vuldetail.join(',\n'))
                      .replace(/%URL%/g, URL)
                      .replace(/%NAME%/, selected_users.join(', '))
                      .replace(/%TITLE%/g, page_title)
                      .replace(/%UNHANDLED_RATE%/g, unhandled_rate)
                      .replace(/%RISK_RATE%/g, risks_rate)
                      .replace(/%HANDLING_RATE%/g, handling_rate)
                      .replace(/%OS%/, limited_osnames.join(', '))
                      .replace(/%VULTITLE%/, vulsnames_list.join('\n'))
                      .replace(/%S_CATEGORY%/, s_category_list.length > 0 ? s_category_list.join(', ') : 'なし')
                      .replace(/%C_CATEGORY%/, c_category_list.length > 0 ? c_category_list.join(', ') : 'なし')
                      .replace(/%HOST%/, hostnames_list.length > 0 ? hostnames_list.join(', ') : 'なし')
                      .replace(/%DISPLAY_NAME%/, display_names_list.length > 0 ? display_names_list.join(', ') : 'なし')
                      .replace(/%MYNAME%/g, myusername)
                      .replace(/%MY_USER_NAME%/g, mylogin)
                      .replace(/%MYEMAIL%/g, myemail)
                      .replace(/%R_HOSTNAME%/, recipients_hostnames.join(', '))
                      .replace(/%R_CATEGORY%/, recipients_categories.join(', '))
                      .replace(/%R_DISPLAY_NAME%/, recipients_display_names.join(', '))
                      .replace(/%OSRATE%/g, limited_osnames_with_percentage.join(', '))
                      .replace(/%MY_S_CATEGORY%/g, self_system_category_names.length > 0 ? self_system_category_names.join(', ') : 'システムカテゴリ無し')
                      .replace(/%MY_C_CATEGORY%/g, self_custom_category_names.length > 0 ? self_custom_category_names.join(', ') : 'カスタムカテゴリ無し')
              ;
              return replaced_text;
          }
          var message = $('#modalSendmailBodyText').val();
          var replaced_message = replace_keywords(message);
          var subject = $('#modalSendmailBodyTitle').val();
          var replaced_subject = replace_keywords(subject);
          if(subject_field === '#modalSendmailBodyTitle'){
              $(subject_field).val(replaced_subject);
          }else{
              $(subject_field).text(replaced_subject);
          }
          $(message_field).val(replaced_message);
          
          if(message === replaced_message && subject === replaced_subject){
             if( !is_conf_modal ){
                 $('#change-keywords').tooltip('show');
                 setTimeout(function(){
                     $('#change-keywords').tooltip('hide');
                 }, 1000);
             }
          }else{
              $('#before_replaced').val(JSON.stringify({'subject': subject, 'message': message}));
              change_changekeywords_btn();
          }
          
          if( is_conf_modal ){
              var bytes = calc_bytes($('#confirm-message').val() + $('#confirm-subject').text());
              if(bytes > 1048576){
                  $('#warn-length-over').attr('class', 'ml-auto visible');
                  $('#MailConfirmationSubmit').prop('disabled', true);
              }else{
                  $('#warn-length-over').attr('class', 'ml-auto invisible');
                  $('#MailConfirmationSubmit').prop('disabled', false);
              }
              $('#MailConfirmation').modal('show');
              $('#conf-btn-loading-mark').remove();
          }else{ 
              check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
              $('#keyword_loading').remove();
          }
      });
  }
  
  $('#LoadingTarget').on('click', function(){
      if($('.action-close-dropdown').is(':visible')){
          $('#keywords-list').dropdown('toggle');
      }
      //if($('#limit-data-num').val() >= 500 && $('#change-keywords').data('replace') === 'replace'){
      if( $('#change-keywords').data('replace') === 'replace' ){
          var target_offset = $('#LoadingTarget').offset();
          var target_top = target_offset.top; 
          var target_left = target_offset.left;
          var keyword_loading = $('<div>').attr('id', 'keyword_loading');
          var hidden_loading = $('<div>').attr({
                                             'id': 'hidden_loading',
                                             'class': '_loading mx-auto',
                                             'style': 'display:none;height:20;'
                                         });
          keyword_loading.append(hidden_loading); 
          $(this).append(keyword_loading);
          $('#keyword_loading').offset({
             top: target_top -15,
             left: target_left
          });
          $('#hidden_loading').show(adjust_btn_status);
      }else{
          adjust_btn_status();
      }
  });
  function adjust_btn_status(){
      var btn =  $('#change-keywords');
      if(btn.data('replace') === 'replace'){
          replace_mail_keywords('#modalSendmailBodyTitle', '#modalSendmailBodyText');
      }else{
          before_replaced = JSON.parse($('#before_replaced').val());
          revert_changekeywords_btn();
          $('#modalSendmailBodyTitle').val(before_replaced['subject']);
          $('#modalSendmailBodyText').val(before_replaced['message']);
          check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
          $('#keyword_loading').remove();
      }
  }
  $(document).on('click', '#MailConfirmationSubmit', function(){
      $('#modalSendmailBodyText').val($('#confirm-message').val());
      $('#modalSendmailBodyTitle').val($('#confirm-subject').text());
      $('#MailConfirmation').modal('hide');
      $('#modalSendMail').modal('hide');
      $('#form_sendmails').submit();
  });
  var selected_textarea = $('#modalSendmailBodyText');
  $('#modalSendmailBodyTitle, #modalSendmailBodyText').on('click', function (){
      selected_textarea = $(this);
  });
  $('.put-keyword').on('click', function (){
      var textarea = selected_textarea;
      var pos = textarea.get(0).selectionStart;
      var len = textarea.val().length;
    //  if(pos === 0){ pos = len;}
      var content =  textarea.val();
      var before = content.substr(0, pos);
      var keyword = $(this).val();
      var after = content.substr(pos);
      content = before + keyword + after;
      textarea.val(content);
      revert_changekeywords_btn();
      var sum_mail_letters = $('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val();
      check_mail_length(sum_mail_letters);
      if($('#recipients').val() != '{}' && $('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
          $('#modalSendmailExecute').prop('disabled', false);
      }else{
          $('#modalSendmailExecute').prop('disabled', true);
      }
  });

  $('#reset-mailmodal').on('click', function(){
      $('#AllUsersSelect').prop('checked', false);
      $('.user-chk-box').prop('checked', false);
      $('#recipients').val(JSON.stringify({}));
      $('#users_sidinfo').val(JSON.stringify([]));
      $('#modalSendmailBodyTitle').val('');
      $('#modalSendmailBodyText').val('');
      check_mail_length('');
      revert_changekeywords_btn();
      $(this).tooltip('hide');
      $('#limit-keywords-data').text('20件');
      $('#limit-data-num').val(20);
      $('#modalSendmailExecute').prop('disabled', true);
      $('.dropdown-menu.show:last').closest('.action-close-dropdown').find('.dropdown-toggle').click();
  });

  $('#limit-keywords-data-tooltip').on('show.bs.dropdown', function(){
      $(this).tooltip('disable');
  });
  $('#limit-keywords-data-tooltip').on('hide.bs.dropdown', function(){
      $(this).tooltip('enable');
  });
  $('#limit-data-num option').on('click', function(){
      $('#limit-keywords-data').text($(this).val() + '件');
  });
  $('#keywords-list').on('click', function() {
      var check_letters = $('#modalSendmailBodyTitle').val() + $('#modalSendmailBodyText').val();
      check_presence_keyword(check_letters);
  });
  
  var buttons_as_disabled = $('.list-tooltip-as-disabled');
  function check_presence_keyword(letters) {
      $.each(buttons_as_disabled, function(){
          var tooltip_selector = $(this);
          var target_selector = tooltip_selector.find('button');
          var class_name = target_selector.attr('class');
          if(letters.indexOf(target_selector.val()) != -1){
              class_name = class_name.replace(/btn-outline-dark2/, 'btn-outline-secondary');
              target_selector.prop('disabled', true).attr({
                  'class': class_name,
                   'style': 'pointer-events:none;border-color:#a8b7c5;'
              });
              tooltip_selector.tooltip('enable');
          }else{
              class_name = class_name.replace(/btn-outline-secondary/, 'btn-outline-dark2');
              target_selector.prop('disabled', false).attr('class', class_name).removeAttr('style');
              tooltip_selector.tooltip('disable');
          }
      });
  }
  function check_mail_length(letters){
      var count_bytes = calc_bytes(letters);
      count_bytes > 1 ? $('#show-byte').text('bytes') : $('#show-byte').text('byte');
      $('#count-letters').text(count_bytes.toLocaleString());
      if(count_bytes > 1048576){
          $('#mail-length-over').attr('class', 'visible');
      }else{
          $('#mail-length-over').attr('class', 'invisible');
      }
  }
  function calc_bytes(letters){
      var bytes = encodeURIComponent(letters).replace(/%../g,"x").length;
      return bytes;
  }
  if (JSON.parse($('#pages_checked').val()).length > 0){
       $('.bulkbtns').removeClass('disabled');
      $('.bulkbtns').prop('disabled', false);
  }

  //サマリー表のチェックボックスとpages_checkedの整合性を取る
  $(window).on('pageshow', function(){
      var is_all_checked = $('#pages_all_checked').val();
      if(is_all_checked === 'true'){
           var all_ids = JSON.parse($('#all_html_ids').val());
           $('#SortTR').find('#allSelect, .vulSelect').prop('checked', true);
           $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
      }else{
           $('#SortTR').find('#allSelect, .vulSelect').prop('checked', false);
           var pages_checked = JSON.parse($('#pages_checked').val());
           var target_elm = '';
           pages_checked.forEach(function(id){
               target_elm += '#table_selected' + id + ',';
           });
           target_elm = target_elm.slice(0, -1);
           $(target_elm).prop('checked', true);
       }
  });
  
  //ブラウザバックでリロードされたらチェックボックスの表示を修正する
  /*$.post($('#check_browser_back_path').val(), {'page_name': 'vuls'},
      function(info){
          if(info === 'browser_back'){
              var is_all_checked = $('#pages_all_checked').val();
              if(is_all_checked === 'true'){
                  var all_ids = JSON.parse($('#all_html_ids').val());
                  $('#Sort-TR').find('#allSelect, .vulSelect').prop('checked', true);
                  $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
              }else{
                  $('#SortTR').find('#allSelect, .vulSelect').prop('checked', false);
                  var pages_checked = JSON.parse($('#pages_checked').val());
                  var target_elm = '';
                  for (var id of pages_checked){
                      target_elm += '#table_selected' + id + ',';
                  }
                  target_elm = target_elm.slice(0, -1);
                  $(target_elm).prop('checked', true);
              }
          }
  });*/

  //プロダクト検索
  $('#filters-search-product-btn').on('click', function(){
       var button = $(this);
       var prod_name = button.attr('data-productname');
       $('#seared-product-name').val(prod_name);
       if( prod_name.length === 0 ){
           $('#seared-product-name').attr('disabled', true);
       }else{
           $('#seared-product-name').attr('readonly', true)
                                    .addClass('bg-white');
       }
       if( $('#filter-product-list > * ').length === 0 ){
           $('#filter-product-notice').removeClass('visible').addClass('invisible');
       }else{
           $('#filter-product-notice').removeClass('invisible').addClass('visible');
       }
       $('#FilterProductModal').modal('show');
   });

   var jqxhr = null
   $('#filter-product-input').on('input', function(){
       $('[data-toggle="tooltip"]').tooltip('hide');
       if(jqxhr){
           jqxhr.abort();
       }
       var keyword = $(this).val();
       var path = $('#sidfm_licenses_api_substr_search_path').val();
       $('#filter-product-list > *').remove();
       jqxhr = $.get(path, { 'params[keyword]': keyword }, function(data) {
           if(keyword.length < 2){
               $('#filter-product-notice').removeClass('visible').addClass('invisible');
               if(keyword.length != 0){
                   $('#filter-product-input-tooltip').attr('data-original-title', '2文字以上入力して下さい').tooltip('show');
               }else{
                   $('#filter-product-input-tooltip').tooltip('hide');
               }
           }else{
               $('#filter-product-input-tooltip').tooltip('hide');
               var lproducts = data['lproducts'];
               delete data['lproducts'];
               var pids = Object.keys(data);
               if(pids.length === 0 && lproducts.length === 0){
                   $('#filter-product-notice').removeClass('visible').addClass('invisible');
                   $('#filter-product-input-tooltip').attr('data-original-title', '該当するプロダクトはありません').tooltip('show');
               }else{
                   $('#filter-product-notice').removeClass('invisible').addClass('visible');
                   for (var i = 0; i < pids.length; i++) {
                       var product = data[pids[i]]['product'];
                       var p_item = $('<span></span>', {
                           class: 'dropdown'
                       });
                       p_item.append($('<button></button>', {
                           class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                           type: 'button',
                           'data-toggle': 'dropdown',
                           'aria-haspopup': 'true',
                           'aria-expanded': 'false',
                           text: product['name']
                        }));
                        var p_menu = $('<div></div>', {
                            class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                        });
                        p_menu.append($('<a></a>', {
                            class: 'dropdown-item exec-search-product-btn',
                            text: '全て',
                            href: '#',
                            'data-pid': pids[i]
                        }));
                        var versions = data[pids[i]]['versions'];
                        if (versions) {
                            for (var j = 0; j < versions.length; j++) {
                                var version = versions[j];
                                var p_ver = $('<a></a>', {
                                    class: 'dropdown-item exec-search-product-btn',
                                    href: '#',
                                    text: version['fullname'],
                                    'data-vid': version['vid']
                                });
                                p_menu.append(p_ver);
                            }
                        }
                        p_item.append(p_menu);
                        $('#filter-product-list').append(p_item);

                   }
                   for (var i = 0; i < lproducts.length; i++) {
                        var lproduct_data = lproducts[i];
                        var lproduct = lproduct_data['product'];
                        var lversions = lproduct_data['versions'];
                        var p_item = $('<span></span>', {
                            class: 'dropdown lproduct-dropdown'
                        });i
                        p_item.append($('<button></button>', {
                            class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
                            type: 'button',
                            'data-toggle': 'dropdown',
                            'aria-haspopup': 'true',
                            'aria-expanded': 'false',
                            text: lproduct['name']
                        }));
                        var p_menu = $('<div></div>', {
                            class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
                                   'aria-labelledby': 'm_searched_item_' + lproduct['id']
                        });
                        p_menu.append($('<a></a>', {
                            class: 'dropdown-item exec-search-product-btn',
                            text: '全て',
                            href: '#',
                            'data-lpid': lproduct['id']
                        }));
                        if (lversions.length > 0) {
                            for (var j = 0; j < lversions.length; j++) {
                                var lversion = lversions[j];
                                var p_ver = $('<a></a>', {
                                    class: 'dropdown-item exec-search-product-btn',
                                    href: '#',
                                    text: lversion['fullname'],
                                    'data-lvid': lversion['id']
                                });
                                p_menu.append(p_ver);
                            }
                        }
                        p_item.append(p_menu);
                        $('#filter-product-list').append(p_item);
                    }
               }
           }
       });
   });

   //バージョン名押下でプロダクト検索
   $(document).on('click', '.exec-search-product-btn', function(e){
       e.stopPropagation();
       var button = $(this);
       var pid = button.attr('data-pid');
       var vid = button.attr('data-vid');
       var lpid = button.attr('data-lpid');
       var lvid = button.attr('data-lvid');
       var filter = JSON.parse($('#pages_filters').val());
       if( pid ){
           var prod_info = {'pid': pid};
       }else if( vid ){
           var prod_info = {'vid': vid};
       }else if( lpid ){
           var prod_info = {'lpid': lpid};
       }else if( lvid ){
           var prod_info = {'lvid': lvid};
       }else{//通常の操作ではここには入らない
           var prod_info = {};
       }
       reset_pages_checked_values();
       filter['product'] = prod_info;
       $('#pages_filters').val(JSON.stringify(filter));
       $('#pages_offset').val('0');
       $('#pages_form').submit();
   });

   //バージョン検索リセット
   $('#reset-filters-product').on('click', function(){
       reset_pages_checked_values();
       var filter = JSON.parse($('#pages_filters').val());
       filter['product'] = {};
       $('#pages_filters').val(JSON.stringify(filter));
       $('#pages_offset').val('0');
       $('#pages_form').submit();
   });

   //CVSS指標検索
   function toggle_execute_filter_cvss_vector_button(){
       var cvss_v2_param = JSON.parse($('#cvss-v2-vectors-for-filter').val());
       var cvss_v3_param = JSON.parse($('#cvss-v3-vectors-for-filter').val());
       var is_unregist_checkbox_checked = $('#filter-unregistered-cvss-vector-checkbox').prop('checked');
       var is_selected_value = false;
       if( is_unregist_checkbox_checked ){
           is_selected_value = true;
       }
       if( !is_selected_value ){
           $.each(cvss_v2_param, function(vector, value){
               if( is_selected_value ){
                   return false;
               }
               if( value ){
                   is_selected_value = true;
               }
           });
           $.each(cvss_v3_param, function(vector, value){
               if( is_selected_value ){
                   return false;
               }
               if( value ){
                   is_selected_value = true;
               }
           });
      
       }
       if( is_selected_value ){
           $('#execute-filter-cvss-vector').prop('disabled', false);
       }else{
           $('#execute-filter-cvss-vector').prop('disabled', true);
       }
   }

   function toggle_filter_cvss_areas(checkbox){
       if( checkbox.prop('checked') ){
           $('#cvss-v2-vectors-area').append(
               $('<div>').attr('class', 'disabled-cvss-area')
           );
           $('#cvss-v3-vectors-area').append(
               $('<div>').attr('class', 'disabled-cvss-area')
           );
       }else{
           $('#cvss-v2-vectors-area .disabled-cvss-area').remove();
           $('#cvss-v3-vectors-area .disabled-cvss-area').remove();
       }
   }

   $('#filter-cve-vector-btn').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       if( Object.keys(filters['cvss_vector']).length > 0 ) {
           var filtered_cvss_v2 = filters['cvss_vector']['cvss_v2'];
           var filtered_cvss_v3 = filters['cvss_vector']['cvss_v3'];
           $('#cvss-v2-vectors-for-filter').val(JSON.stringify(filtered_cvss_v2));
           $('#cvss-v3-vectors-for-filter').val(JSON.stringify(filtered_cvss_v3));
           var cvss_v2_area = $('#cvss-v2-vectors-area');
           var cvss_v3_area = $('#cvss-v3-vectors-area');
           cvss_v2_area.find('[data-cvss]').removeClass('selected-cvss');
           $.each(filtered_cvss_v2, function(vector, value){
               if( value ){
                   cvss_v2_area.find('[data-cvss="' + vector + '"][data-value="' + value + '"]').addClass('selected-cvss');
               }
           });
           cvss_v3_area.find('[data-cvss]').removeClass('selected-cvss');
           $.each(filtered_cvss_v3, function(vector, value){
               if( value ){
                   cvss_v3_area.find('[data-cvss="' + vector + '"][data-value="' + value + '"]').addClass('selected-cvss');
               }
           });
           var checkbox = $('#filter-unregistered-cvss-vector-checkbox');
           if( filters['cvss_vector']['is_target_unregistered'] ){
               checkbox.prop('checked', true);
           }else{
               checkbox.prop('checked', false);
           }
           toggle_filter_cvss_areas(checkbox);
       }else{
           $('#filter-unregistered-cvss-vector-checkbox').prop('checked', false);
           var default_cvss_v2_val = {};
           var cvss_v2_vector_items = JSON.parse($('#cvss-v2-vectors').val());
           $.each(cvss_v2_vector_items, function(vector, items) {
               default_cvss_v2_val[vector] = null;
           });
           $('#cvss-v2-vectors-for-filter').val(JSON.stringify(default_cvss_v2_val));
           $('#cvss-v2-vectors-area').find('[data-cvss]').removeClass('selected-cvss');

           var default_cvss_v3_val = {};
           var cvss_v3_vector_items = JSON.parse($('#cvss-v3-vectors').val());
           $.each(cvss_v3_vector_items, function(vector, items) {
               default_cvss_v3_val[vector] = null;
           });
           $('#cvss-v3-vectors-for-filter').val(JSON.stringify(default_cvss_v3_val));
           $('#cvss-v3-vectors-area').find('[data-cvss]').removeClass('selected-cvss');
       }
       toggle_execute_filter_cvss_vector_button();
       $('#FilterCvssVectorModal').modal('show'); 
   });

   function set_filter_cvss_item(clicked_elm, cvss_area_name){
       if( cvss_area_name === 'cvss_v2' ){
           var target_param_elm = $('#cvss-v2-vectors-for-filter');
           var target_area = $('#cvss-v2-vectors-area');
       }else{
           var target_param_elm = $('#cvss-v3-vectors-for-filter');
           var target_area = $('#cvss-v3-vectors-area');
       } 
       var param = JSON.parse(target_param_elm.val());
       var vector_name = clicked_elm.attr('data-cvss');
       var is_selected = clicked_elm.hasClass('selected-cvss');
       target_area.find('[data-cvss="' + vector_name + '"]').removeClass('selected-cvss');
       if( is_selected ){
           param[vector_name] = null;
       }else{
           clicked_elm.addClass('selected-cvss');
           param[vector_name] = clicked_elm.attr('data-value');
       }
       target_param_elm.val(JSON.stringify(param));
       toggle_execute_filter_cvss_vector_button();
   }

   $('#cvss-v2-vectors-area [data-cvss]').on('click', function(){
       set_filter_cvss_item($(this), 'cvss_v2');
   });

   $('#cvss-v3-vectors-area [data-cvss]').on('click', function(){
       set_filter_cvss_item($(this), 'cvss_v3');
   });

   $('#filter-unregistered-cvss-vector-checkbox').on('change', function(){
       toggle_filter_cvss_areas($(this));
       toggle_execute_filter_cvss_vector_button();
   });

   $('#execute-filter-cvss-vector').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       var is_target_unregistered = $('#filter-unregistered-cvss-vector-checkbox').prop('checked');
       filters['cvss_vector']['is_target_unregistered'] = is_target_unregistered;
       var selected_cvss_v2 = JSON.parse($('#cvss-v2-vectors-for-filter').val());
       var selected_cvss_v3 = JSON.parse($('#cvss-v3-vectors-for-filter').val());
       if( is_target_unregistered ){
           $.each(selected_cvss_v2, function(vector, value){
               selected_cvss_v2[vector] = null;
           });
           $.each(selected_cvss_v3, function(vector, value){
               selected_cvss_v3[vector] = null;
           });
       }
       filters['cvss_vector']['cvss_v2'] = selected_cvss_v2;
       filters['cvss_vector']['cvss_v3'] = selected_cvss_v3;
  
       reset_pages_checked_values(); 
       $('#pages_filters').val(JSON.stringify(filters));
       $('#pages_form').submit();
   });

   $('#reset-filter-cvss-vector').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       filters['cvss_vector'] = {}
       reset_pages_checked_values();
       $('#pages_filters').val(JSON.stringify(filters));
       $('#pages_form').submit();
   });

   //JSON_TSVダウンロード
   $('#exec-download').on('click', function(){
       json_tsv_summary_table_progress_download($('#download_select').val(), $('#read-download-data-path').val());
   });

  //担当者にメール送信画面で、ホスト名とカテゴリ名を表示した時にpopoverを表示する（bootstrapのpopoverだとバグになるので独自に実装
  $(document).on('click', '.show-original-popover', function(){
      var button = $(this);
      var id = button.attr('data-popoverid');
      var popover = $('.original-popover');
      var popover_id = popover.attr('data-popoverid');
      popover.remove();
      if(popover_id === id){
          return false;
      }
      var content = $('<div>').attr({
                              'class': 'original-popover',
                              'data-popoverid': id,
                              });
      var inner_content = $('<div>').attr('class', 'original-popover-inner');
      var text = button.attr('data-content');
      button.attr('data-html') ? inner_content.html(text) : inner_content.text(text);
      content.append(inner_content);
      var triangle_target = $('<div>').attr({
                                       'class': 'position-relative triangle',
                                       'data-popoverid': id,
                                      });
      content.append(triangle_target);
      content.css('opacity', 0);
      $('body').append(content);
      var btn_width = button.outerWidth(true);
      var content_width = content.outerWidth(true);
      var offset = button.offset();
      var offset_top = offset.top - content.outerHeight(true) - 5;
      var offset_left = offset.left + (btn_width / 2) - (content_width / 2);
      content.offset({
          'top': offset_top,
          'left': offset_left
      });
      content.css({
          'opacity': ''
      });
      content.find('[data-toggle="tooltip"]').tooltip();
  });

  //担当者にメール送信を開いている時に画面クリックでpopover削除
  $('#modalSendMail').on('click', function(e){
      if(e.target){
          var t_elm = $(e.target);
          if(!t_elm.hasClass('show-original-popover') && t_elm.closest('.show-original-popover').length === 0 && !t_elm.hasClass('triangle')){
              $('.original-popover').remove();
          }
      }
  });

  //担当者にメール送信画面のスクロールでpopover削除
  $('.modal-mail-table').on('scroll', function(){
      $('.original-popover').remove();
  });

  //ClipboardJSでコピー
  const clipboard_supported = ClipboardJS.isSupported();
  $(document).on('click', '.copybtn', function(e){
    e.stopPropagation();
    if(clipboard_supported === false) {
        alert('このブラウザではコピー機能はサポートされておりません');
        return false;
    }
  });

  var clipboard = new ClipboardJS('.copybtn', {
      text: function(e){
          var t = '';
          $('.summary-cveids-list .summary-cveid').each(function(){
              t += $(this).text() + '\n';
          });
          return t;
      }
  });

  clipboard.on('success', function(e){
     var obj = $(e.trigger);
     obj.tooltip('show');
     setTimeout(function (){
         obj.tooltip('hide');
         e.clearSelection();
     }, 1000);
  });
  clipboard.on('error', function(e) {
        alert('コピーに失敗しました');
        e.clearSelection();
  });
  
});
